commit 647ee6f091eafcce70ffb75ddf7e121e192ab217
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 18:46:39 +0900

    [ruby/reline] Version 0.1.2

    https://github.com/ruby/reline/commit/b41024e317

commit 1341a279a4becd91f35b23eca6d129990eccc8bb
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 18:45:02 +0900

    Save last breaking point to complete

commit a52e364e6541a6e234718ac63aa7eb5c3f2c832f
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-25 18:02:53 +0900

    fix version regexp

commit ecbf7fe27ce444782f0a48fc41f8043a25078666
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-25 17:01:26 +0900

    fix typo

commit a65e8644fb97491314387e4138cabf6378a8e8d5
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-25 15:48:56 +0900

    v2.7.0p0

commit 75dca097b873222eaf3c70b7f43e3ffb98b7f2ed
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-25 14:13:15 +0900

    [bundler/bundler] Do `require "rubygems"` only when needed

    This require causes circular require.

    ```
    $ touch empty_file

    $ RUBYGEMS_GEMDEPS=empty_file ./local/bin/ruby -w -e ''
    /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92: warning: /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92: warning: loading in progress, circular require considered harmful - /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb
            from <internal:gem_prelude>:1:in  `<internal:gem_prelude>'
            from <internal:gem_prelude>:1:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1417:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1203:in  `use_gemdeps'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/user_interaction.rb:47:in  `use_ui'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1204:in  `block in use_gemdeps'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler.rb:11:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler.rb:11:in  `require_relative'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler/rubygems_integration.rb:3:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
    ```

    https://github.com/bundler/bundler/commit/c7c5bcea92

commit 27453b04c85249372950b6b12fabbef8c0d1a80b
Author: Kenta Murata <mrkn@users.noreply.github.com>
Date:   2019-12-25 15:21:50 +0900

    Update the version of bigdecimal to 2.0.0 (#2784)

Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 56e002981fab73a94c6038cb9de82aba6ff84eb4
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-25 14:47:31 +0900

    Show the error line only when same as the current

commit 9808e010907bb16068497d9f0f8593a7165fa42d
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-25 14:37:53 +0900

    export a function for MJIT.

    rb_iseq_complete() can be used by MJIT.

commit d9bf9c572f461c282fa6e65833e98bc7d453a66f
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-25 14:10:35 +0900

    take care of USE_LAZY_LOAD=1.

    On USE_LAZY_LOAD=1, the iseq should be loaded. So rb_iseq_check()
    is needed. Furthermore, now lazy loading with builtin_function_table
    is not supported, so it should cancel lazy loading.

commit 81e377023c490998a3fec245ca2fb2b3c710c2c6
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-25 13:35:22 +0900

    range.c: Range#min with a beginless one now raises an explicit exception

    [Bug #16450]

commit cd6c013b075c9c27437f30efcee9d4dd9e0ee1c5
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 12:55:31 +0900

    Add readline and readline-ext to default gems list in NEWS

commit 227c3d642631262acfbf140c566a7841c32b372f
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-25 12:06:02 +0900

    add ref to NEWS entry

commit 3345eab934073bdd8394ee8a46fc18954999af76
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-25 11:37:27 +0900

    NEWS: add a ticket reference

commit b9e35d27096290f9544dca685fb4cf5bd0e09397
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-25 11:31:44 +0900

    NEWS: add a ticket reference

commit e0929c44ddc7490dc97cabf12c7505173316a623
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-25 11:27:13 +0900

    NEWS: add ticket references

commit eb3f19b9b896094ae9754de1b48fed86fb35fe39
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-25 11:17:24 +0900

    update-bundled_gems: drop branch name on github [ci skip]

commit 00710d10761ad1aa752cf2c035e3bfbde40092b6
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 10:47:53 +0900

    [ruby/readline] Version 0.0.2

    https://github.com/ruby/readline/commit/42b71f3fc0

commit e51a34511c9e4394467cde24deee19cf8536a3e7
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 10:47:34 +0900

    [ruby/readline] Use a box to make easier to see the message

    https://github.com/ruby/readline/commit/e49e942053

commit 57c74841c7bc2bb2ffbb8ed89597e993116e26a8
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 10:44:52 +0900

    [ruby/readline] Fix any wrong in messages

    https://github.com/ruby/readline/commit/a2cf437c8f

commit de0f4f2fd7620e2486f5aef031dad18324437c2b
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 10:30:24 +0900

    [ruby/readline] Version 0.0.1

    https://github.com/ruby/readline/commit/d2363cad33

commit 5d20865708552a522d5eb39c4d9238f96693f8f2
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 10:25:15 +0900

    [ruby/readline] Add post_install_message

    https://github.com/ruby/readline/commit/03126372b5

commit 999a2819a75e40aec405e088d01b12eda341025d
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 10:31:03 +0900

    [ruby/readline-ext] Version 0.1.0

    https://github.com/ruby/readline-ext/commit/f5abaf5be1

commit 246242700867ed3fdce8288897d74bd261379018
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 10:08:06 +0900

    [ruby/reline] Version 0.1.1

    https://github.com/ruby/reline/commit/923f97d068

commit ed5b4bae6a4f991a0c5299581bd0b137a98d3723
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 09:52:25 +0900

    The behavior of vi_end_of_transmission should be the same of vi_list_or_eof

commit 03c504ac59a2bf78bab925379e93184d81296e96
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-25 09:38:12 +0900

    Commented-out btest on cygwin environment of GitHub Actions

commit 622e47a1dbeee52fb218b816943b69cb88e17ae6
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-25 09:29:46 +0900

    ^D on non-empty line in vi mode behaves like Enter

commit 8e6d51e09a93ae2c57d56105a5fd39fb92855394
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-12-25 08:41:26 +0900

    Sync did_you_mean

commit 2b2be71cabf987effd2783747eedf573af1400cf
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-12-25 08:23:59 +0900

    Add did_you_mean's promotion to the NEWS

Notes:
    Merged: https://github.com/ruby/ruby/pull/2782

commit 1857b4427817755bb0879ca67e1b2f3276f95d4c
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-25 07:28:02 +0900

    Merge Bundler 2.1.2 from bundler/bundler.

    [Misc #16449][ruby-core:96458]

commit da0a0bae8b50087d140309b27eb4d4b4776c27e4
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-25 06:13:49 +0900

    NEWS: add meaning of "CoW" ("copy-on-write")

commit ceba5b70889666b82b80910a441cf4a92b5c7160
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-25 05:50:27 +0900

    [DOC] Fix typo in Time#inspect

commit f3067deb88badf8d15e49d13f082284f58b2c62b
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-12-25 04:54:20 +0900

    Revert "Add NEWS entry about Module#name performance (#2779)" (#2781)

    This reverts commit 3e9221d94a12b54c1285923b642364acdbc31c7e.

Notes:
    Merged-By: XrXr

commit 3e9221d94a12b54c1285923b642364acdbc31c7e
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-12-25 04:02:50 +0900

    Add NEWS entry about Module#name performance (#2779)

Notes:
    Merged-By: XrXr

commit 5220145ea289d9eb955b373f31773fab2d4f0271
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-25 01:32:37 +0900

    add debug_counter access functions.

    These functions are enabled only on USE_DEBUG_COUNTER=1.

commit 9b617ffa8884f9f80a0b1bdb89169d8139ba5001
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-25 01:00:40 +0900

    * 2019-12-25 [ci skip]

commit 3679023df822d8bf3f88b9b2e4b849318d2c409e
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-25 00:57:30 +0900

    [DOC] Fix typo and language

commit 8c017824c8eeffe11070ce69c914725af314d9f6
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-24 22:31:38 +0900

    Added entry for json-2.3.0

commit 1cd2ebed616473ed56730292879e8bc9d6dfd060
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-24 21:39:37 +0900

    Update the news entries for RubyGems and Bundler

commit 05b0410f91360e15511903580f0401b123f3abce
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 21:17:00 +0900

    [ruby/irb] Fix typo

    https://github.com/ruby/irb/commit/4bb1340687

commit 54083fd41bf876b42e1a97acdc7574c8edbb87ed
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 21:01:47 +0900

    [DOC] Fix grammar in Process module docs

commit 66e518f7b3e0bf307f86a51e6db02c3d1ec8df84
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 21:01:24 +0900

    [DOC] Fix typo

commit 4ba9347554ab1ac79fdaf1d5b3320776a2b10615
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 18:49:57 +0900

    `Object#=~` warning also obeys `Warning[:deprecated]`

commit a3c5dbf29191aa8622d8be7d990c4ac2f9392427
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 14:56:17 +0900

    Scale sleeping times to wait for the OS operations

commit 7758849cb5432ae974f616668f9c9bab415bb18a
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 18:39:48 +0900

    Remove unused variable

commit 42e2a322f100c7c798fcfbcbbfe0b4cdaf3f5855
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 18:32:50 +0900

    The delete-char-or-list shows completed list when called at end of line

    It doesn't behave the same as the delete-char.

commit b03aea62abfbdc7c8ee53c30a27127c3c394a6ba
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 18:02:22 +0900

    NEWS: fix method references for Range#{cover?,include?}

commit 44a1f51695058159ff2f191c97a082bed9665137
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 17:49:22 +0900

    NEWS: improve sections for warning option / Warning

commit 27b4f477d960c75f3ff5cd5e045b307cad314ec7
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 17:03:42 +0900

    [DOC] Improve docs for Enumerator.produce, Enumerator.new

commit 81504e83e72bf125476528e5f119604d9697f682
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 15:47:59 +0900

    Synchronize with a Queue instead of sleeping

commit 47ad57f2450251f47b3f8e1f744d782269bbcdeb
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-24 15:38:46 +0900

    Revert "Scale sleeping times"

    This reverts commit e57d6194218efc73c30f3fed9dd321d2e357030b.

    Test fails:
    http://ci.rvm.jp/results/trunk-gc-asserts@ruby-sky1/2518563
    http://ci.rvm.jp/results/trunk-gc_compact@silicon-docker/2518533

commit c47106699cf2bcf426285efcd795223c200a3120
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 14:57:55 +0900

    NEWS: added references to warning option [ci skip]

commit e57d6194218efc73c30f3fed9dd321d2e357030b
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 14:56:17 +0900

    Scale sleeping times

commit adf498b84f56e57b74b72a3ddcc512f6d2078cef
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 13:24:41 +0900

    Moved warning option section and added a reference [ci skip]

commit 302e896833bc611ba39c8697712313fd2dbd70cc
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 13:12:28 +0900

    Added warning.rb to .document

commit 3739ddc36f462b794ec05c0cfc36458a8d1e17a7
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 12:11:42 +0900

    Added `-W:experimental` to `--help` [Feature #16420]

commit d0f1eb3e4ef7cde2d78b493b3ba1561eee79b18f
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 11:28:18 +0900

    Separated command line option in NEWS [ci skip]

commit 5a62fb1277fb351a1a11b89b0f8510c8f1a0cdff
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 11:14:13 +0900

    Mentioned `-W:` command option in NEWS [ci skip]

commit f2e1e6cba451375d8eb839bf2e7c9a39bccc044c
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-22 06:23:20 +0900

    Enhance explanations for beginless range and #clamp, and add missing feature

Notes:
    Merged: https://github.com/ruby/ruby/pull/2769

commit e954be14d07e54b8dbf71c0fa227e5818eaa01e6
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 10:27:18 +0900

    Get rid of false positive misspellings

    [Bug #16437]

commit 992aa2cda50140abbca165024682eae998756e2d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-24 10:24:45 +0900

    enc/x_emoji.h: fixed dead-links [ci skip]

    English version pages seem no longer provided.

commit f09a4ff265093742c356c69bcf56db68bd6cf064
Author: manga_osyo <manga.osyo@gmail.com>
Date:   2019-12-24 09:53:36 +0900

    Added NEWS for Feature 15373

Notes:
    Merged: https://github.com/ruby/ruby/pull/2777

commit 360f153fcaab637486aa2669d354d53e0eb1c3d2
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-24 10:23:38 +0900

    remove "experimental" from numbered parameter.

    Numbered parameter is not an experimental feature,
    confirmed by Matz.
    https://twitter.com/yukihiro_matz/status/1209271452798607361

commit 5e17834fc900a699241764ef0baacd53992d7f07
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 09:55:05 +0900

    [ruby/reline] Version 0.1.0

    https://github.com/ruby/reline/commit/55d4dfec1e

commit 8316b330fb04413bb480462941cb6b14c5352e2e
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 09:54:38 +0900

    [ruby/irb] Version 1.2.1

    https://github.com/ruby/irb/commit/8da0c74640

commit 0e528ae9cb5c1078e4d07287e403cb548e97f0a3
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 09:53:43 +0900

    [ruby/irb] Remove warning message to bundle on Ruby 2.7.0

    https://github.com/ruby/irb/commit/d9a7844f50

commit 0231661939310951c8ed339d8600a53a21015918
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 08:13:46 +0900

    [DOC] Fix wording in Math::E documentation

commit 30c5e8c4b9353dfb716033901cec7529eace3922
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 08:03:00 +0900

    [ruby/rdoc] Version 6.2.1

    https://github.com/ruby/rdoc/commit/c65e14d112

commit 2bf0743edcf6fd70cd73952e1e023821c4549a9e
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 07:58:49 +0900

    Update parsers of RDoc that are generated by Racc

commit adc9b3ca7f4e75e368731fe8a7092ce078bcec04
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 07:41:37 +0900

    [ruby/rdoc] Support newline in the middle of constant definition

    https://github.com/ruby/rdoc/commit/74d3984324

commit e50e55269358520dc55595a9c3e074d351d96b66
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-24 07:00:35 +0900

    [ruby/rdoc] Treat Proc#call syntax sugar for constant correctly

    https://github.com/ruby/rdoc/commit/957d041ae0

commit 819b604037c317d2b53a1aaca67aef25da2d5ec9
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 16:34:16 +0900

    Reword keyword arguments warning messages to convey these are deprecation warnings

commit df6f5c44af1f261fa940ec3954468be8b820450e
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 06:41:58 +0900

    [DOC] Fix invalid code to make it syntax highlighted

commit a7b5018495c4a6b82d779958b086647226ce61e7
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 06:07:02 +0900

    [DOC] Use capitalized "Ruby"

commit ba9ccef81811e9387c0189d596189236b25d0dba
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-24 06:04:59 +0900

    [DOC] Various fixes in bug triaging guide

commit aa01441fd29be8be28644db7abac9f7940fcc814
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-24 04:17:11 +0900

    * 2019-12-24 [ci skip]

commit f201700051cc107b55c425bf331ce6d7ad3ef22b
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-24 04:16:40 +0900

    move a NEWS entry about inline method cache

commit 16fddfe352828d26aaa6cdbce696e62de04511ce
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-23 23:02:59 +0900

    [DOC] Improve readability of requirements for <=>

commit 9a42e0c7ed4dcc57043a8a35a50686625adba686
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-23 22:46:58 +0900

    NEWS: add reference for [Feature #14405]

commit de1a462454f4196490263c9be8be16a44513f5a0
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-23 22:45:24 +0900

    NEWS: revise grammar, language, markup, etc.

commit bbde77cd2694e87646842777e873d849bbf5703e
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-23 17:46:08 +0900

    NEWS: fix some typos, grammar, and language

commit 100fc2750b8f2c4dbe0aaa6c622bbf5f6d61e3c0
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-23 17:04:31 +0900

    fix wmap_finalize.

    wmap_finalize expects id2ref() returns a corresponding object
    even if the object is dead. Make id2ref_obj_tbl() for this
    purpose.

commit 9eeaae432b9a894e28e3906435f3d454d8fd025c
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-23 16:30:45 +0900

    add more debug counters to count numeric objects.

commit 7779ade48c2786992e41c0ab87761ab467f4be49
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 15:59:17 +0900

    NEWS: Fix issue reference [#15807] [DOC]

commit dadf1255b6e13578f888c239f0dc6fb201fd40bb
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 15:55:39 +0900

    README: Add Range#minmax to the list of potential incompatibilities [#15929] [DOC]

commit 3e1adf573110ddce8f900d9473dde7fa7de9c0e2
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 15:48:38 +0900

    README: Improve wording [DOC]

commit 7df2503b7770147a8589a594bf30726f733b1d86
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 15:37:45 +0900

    NEWS: Hint at potential incompatibility with Range#minmax [#15807]

commit a96f8cecc2488126d7298ea304da8bad3dde1792
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-23 15:02:14 +0900

    ObjectSpace._id2ref should check liveness.

    objspace->id_to_obj_tbl can contain dead objects because of lazy
    sweep, so that it should check liveness.

commit 672a61b97fe0cdb256611c707e7cc69856208467
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-12-23 14:47:03 +0900

    Port https://github.com/ruby/did_you_mean/commit/dd1dd86e6c3188c36224d5dd4389676e6653a727

commit 92d0958257965adf426e6f6c654c5935a690bf5b
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-23 13:23:08 +0900

    FrozenError.new accepts :receiver instead of 2nd argument [ci skip]

    [ruby-core:96227] [Feature #16419]

commit 3142a6beb28db36dc9150f1ad6752cd1e19a8712
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-23 12:07:15 +0900

    Revert "Changed behavior on windows platforms too [ci skip]"

    This reverts commit 1bf8d5e9797f6304b2e27cb7f42d467f84de0ff4.

    Because 204dc3f39f12b4e2640555306bd1dd4530344277 reverts 61aff0cd189e67fa6f2565639ad0128fa33b88fc

commit 204dc3f39f12b4e2640555306bd1dd4530344277
Author: NAKAMURA Usaku <usa@ruby-lang.org>
Date:   2019-12-23 11:54:25 +0900

    Revert "Should return "." for File.extname("file.") also on Windows"

    We want to introduce consistency and better compatibility with unixen,
    but the Windows APIs do not have consistency fundamentally and
    we can not found any logical way...

    This reverts commit 61aff0cd189e67fa6f2565639ad0128fa33b88fc.

commit 048f797bf019cdf303d70494fba63d4a4e606462
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 10:54:50 +0900

    [ruby/prime] Bump version

commit 446c243da35831de701ff6dd6c3c6da8252b6a10
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 09:44:43 +0900

    [ruby/ostruct] Bump version

commit 9be3295d53b6fd9f8a3ad8157aa0655b1976d8ac
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 09:40:32 +0900

    [ruby/ostruct] Create OpenStruct::VERSION

commit 49d94248ebfb7a51e342f8102d21ad132a40f91a
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 09:34:42 +0900

    [ruby/ostruct] Move gemspec

commit 48d1acdf25b13bd9e28bf6baa3f74ec082a27a00
Author: Marc-Andre Lafortune <github@marc-andre.ca>
Date:   2019-12-23 08:33:19 +0900

    [ruby/matrix] Bump version

commit 1ed87dd3c4fb085955bb3848579a3ed7aba38507
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-22 13:56:20 +0900

    Add NEWS about Warning.[] [Feature #16345] [ci skip]

commit 5de284ec78220e75643f89b454ce999da0c1c195
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-23 10:37:30 +0900

    Fixed a typo in an exception class name

commit 5f18635a800eee29fd051ea758a2ec561f090ebe
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-23 10:10:23 +0900

    make-snapshot: fixed mode

    "X" must be used in conjunction with "+".

commit 80d5d220b948517306e23b18260768ab8fe008bc
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-23 08:42:53 +0900

    Fix typo in commit logs by log-fix notes

commit 4de2297d74fbc0a0e69ac8bcc2aad5b192fd11b6
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-23 09:07:07 +0900

    Re-apply f85e8d2a8b keeping characters < 80

commit f156f70b3192ddab41e432e743936a09a5aaae09
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-23 09:02:49 +0900

    Revert "Fixed misspellings"

    This reverts commit f85e8d2a8b2a37740334db4fd92ef820f05ddbc5.

    It violated the limit of width (> 80) and caused the test failure

commit f85e8d2a8b2a37740334db4fd92ef820f05ddbc5
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-23 08:31:46 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437]

commit a4b99f97642d31fc8ddd537155ff6cf61be6a43c
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-23 05:56:44 +0900

    Fix typos of previous docs PR

    In #2612 I made two typos (extra ,, and copy-pasted
    same line of code instead of showing two different
    ones), fixing them.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2771

commit c1bd1bf27236b33965dd92c1b2297edc91327cfb
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-14 01:59:23 +0900

    Document Module#const_source_location

Notes:
    Merged: https://github.com/ruby/ruby/pull/2750

commit ade6543f4cf7dfb1ab4585a1bfca20f3d64d5add
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-12-23 08:21:13 +0900

    Adjust sentence in doc [ci skip]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2773

    Merged-By: XrXr

commit bb05cdcd78b3e3d54f0ad9afc01de383ed33dc1c
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-23 06:36:14 +0900

    [DOC] Improve documentation for Enumerable#tally

commit 7c37f2cb1ad248a1db327f3522a8e3ffa5c5412f
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-23 03:46:24 +0900

    Some fixes in Enumerator::Lazy docs

    * fix list in #flat_map
    * fix wrong indentation in #filter_map and #with_index
    * other small fixes

commit 679bc4f9cb6a5471df903436c6240ca2157986dd
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-09-08 21:04:46 +0900

    [ruby/reline] Use IO#raw to read one byte

    https://github.com/ruby/reline/commit/be17740e82

commit 3a18e43caac4ce31702c9b79de3b6e8af05ef173
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-23 00:17:25 +0900

    * 2019-12-23 [ci skip]

commit 1bf8d5e9797f6304b2e27cb7f42d467f84de0ff4
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-23 00:16:51 +0900

    Changed behavior on windows platforms too [ci skip]

    at 61aff0cd189e67fa6f2565639ad0128fa33b88fc [Bug #15267]

commit d339de9d1a11923cd6d435d995ee479d08791720
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-22 06:05:45 +0900

    Enhance docs for Module#deprecate_constant

Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 5a0102cb615f27f2daef8af6d9ae996926b2d167
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-22 05:58:14 +0900

    Enhance Range docs

    * Change === docs to mention it uses cover?
    * Add different example to === docs to showcase
      behavior better
    * Change include? docs to mention cover?
      and clarify the difference

Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 4988843188c7a1666b11e1390acd7b991941c3a8
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-22 05:37:35 +0900

    Actualize Time#inspect docs

Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 5fa9c2eeb04a2e44a2a028d933bc95f219a6a282
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-22 05:31:30 +0900

    Actualize Method#inspect docs

Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit d78fcfb7ab351fd4861e42985db34e9bda3509a7
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-22 05:21:20 +0900

    Fix FrozenError#receiver and #initialize docs

Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit e568bb5649a93c60aaa51c1e5308054079815bcc
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-22 05:17:35 +0900

    Update private visibility explanation

Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 03b983d54c17615e36d56d2937a685fc8c3f2cdb
Author: zverok <zverok.offline@gmail.com>
Date:   2019-12-21 05:51:22 +0900

    Document numbered block parameters

Notes:
    Merged: https://github.com/ruby/ruby/pull/2767

commit 890c834ec6bb03fab4fee6f5b14f99660a64d207
Author: BurdetteLamar <burdettelamar@yahoo.com>
Date:   2019-12-17 07:58:53 +0900

    Enhancements for ENV doc

Notes:
    Merged: https://github.com/ruby/ruby/pull/2757

commit 54be15f3256fd2dbb0d5d7962e9dfac2b87c797b
Author: QuestionDriven <QuestionDriven@gmail.com>
Date:   2019-12-17 16:11:02 +0900

    [Doc] Fix sample in Encoding#names

Notes:
    Merged: https://github.com/ruby/ruby/pull/2760

commit 9654241d5d5717b7cd6ddedb6c192e971f9d473a
Author: QuestionDriven <QuestionDriven@gmail.com>
Date:   2019-12-17 16:05:17 +0900

    [Doc] Fix wrong example in Encoding.aliases

Notes:
    Merged: https://github.com/ruby/ruby/pull/2760

commit cc87037f1c5a143af8089555e704505fcf0b2879
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-22 22:49:17 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437], missed and a new
    typo.

commit 7c33ee5ddfafe737add2a7f4c4975108f9196dbd
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-22 19:39:22 +0900

    Move version guard outside to make it clear the method was added in Ruby 2.5

commit d76c8cfecdaa2960153b5b24ccd0d61f9af60abd
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-22 15:18:22 +0900

    RDoc of Warning.[] and .[]= [Feature #16345] [ci skip]

commit d2ac6d4d9f57b34eeb94bd6302b54a632051ce64
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-22 14:45:42 +0900

    Manage deprecation warning by the flag

commit 58527a79263c6572bd4f97d0a0e0359c0ace6f3c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-22 13:52:59 +0900

    [ruby/io-console] bump up to 0.5.3

commit ced4c5dace63dcb5aabe4d9c480e02e7581b8816
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-22 11:40:07 +0900

    add NEWS about cache improvement [ci skip]

commit efd4a11ada731ce18f5eb1500c76f77b4d0f313f
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-22 11:46:09 +0900

    Support multibyte input

commit cf59e1476d01be27dc88cbee5f6c6cf87f007043
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-22 06:28:13 +0900

    fix a thread test.

    * Use Queue for synchronization.
    * Don't use `sleep 0.2` and use `th.join` because created thread
      can raise an exception after 0.2 seconds.

commit fa1bf8ab37caad5fa0679adc0ecb8f6f5cec2eea
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-19 23:13:21 +0900

    [ruby/reline] Support Ctrl+right as em_next_word, and Ctrl+left as ed_prev_word

    https://github.com/ruby/reline/commit/e98ad3b486

commit 644336eef54c8ee2aeb7fd6c55fcd5620bcfa5b4
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-22 05:20:08 +0900

    add a NEWS entry for [Feature #16163]

commit 75acbd5f0076970d48bc423c2b058adbdb5da9e8
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-22 03:31:27 +0900

    compile.c: avoid newarraykwsplat for arguments

    `foo(*rest, post, **empty_kw)` is compiled like
    `foo(*rest + [post, **empty_kw])`, and `**empty_kw` is removed by
    "newarraykwsplat" instruction.
    However, the method call still has a flag of KW_SPLAT, so "post" is
    considered as a keyword hash, which caused a segfault.
    Note that the flag cannot be removed if "empty_kw" is not always empty.

    This change fixes the issue by compiling arguments with "newarray"
    instead of "newarraykwsplat".

    [Bug #16442]

commit 3a29f05ba5ba7ed4b821ba5f566eeb3ff3c5c3b1
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-22 01:39:17 +0900

    Move stats under a dict

commit 61aff0cd189e67fa6f2565639ad0128fa33b88fc
Author: NAKAMURA Usaku <usa@ruby-lang.org>
Date:   2019-12-22 02:36:55 +0900

    Should return "." for File.extname("file.") also on Windows

    But not changes another cases, such as "file.rb."
    [Bug #15267]

commit 29ea228efc5af08a0e91fafe155617f20e22976b
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-22 01:58:02 +0900

    * 2019-12-22 [ci skip]

commit 0835a971ef84dfebefbc73ddd468450cbfb90974
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-18 22:57:25 +0900

    Remove TODO comment

commit 616f1357c3030fad73c42ea061a7f21b0df57fb5
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-14 16:14:43 +0900

    [ruby/irb] Make nesting level up for `1.times do`

    Follow up of the previous commit

    https://github.com/ruby/irb/commit/ab207353d3

commit a3cc2a2fbde23637fb924f75e977599b7a475118
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-14 16:07:21 +0900

    [ruby/irb] Fix auto-indent for `1.times do`

    Fixes #47

    https://github.com/ruby/irb/commit/6b8eca4635

commit ec1de789a98923417cf983cb3cdaed003c0f8be6
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-14 15:46:42 +0900

    [ruby/reline] Preserve the input buffer across cursor_pos

    The old version of cursor_pos discards the input buffer, which made IRB
    ignore the input immediately after IRB is invoked.

    This change keeps the input before cursor_pos by using ungetc.

    https://github.com/ruby/reline/commit/4a8cca331f

commit 7fd6077d9896cc10244fb9416ef87ae461c079db
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-14 11:01:49 +0900

    [ruby/reline] Consider Reline::ANSI.input at prep

    https://github.com/ruby/reline/commit/b111cde3c3

commit 85a337f986fe6da99c7f8358f790f17b122b3903
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-07-14 01:04:01 +0900

    Kernel#lambda: return forwarded block as non-lambda proc

    Before this commit, Kernel#lambda can't tell the difference between a
    directly passed literal block and one passed with an ampersand.

    A block passed with an ampersand is semantically speaking already a
    non-lambda proc. When Kernel#lambda receives a non-lambda proc, it
    should simply return it.

    Implementation wise, when the VM calls a method with a literal block, it
    places the code for the block on the calling control frame and passes a
    pointer (block handler) to the callee. Before this commit, the VM
    forwards block arguments by simply forwarding the block handler, which
    leaves the slot for block code unused when a control frame forwards its
    block argument. I use the vacant space to indicate that a frame has
    forwarded its block argument and inspect that in Kernel#lambda to detect
    forwarded blocks.

    This is a very ad-hoc solution and relies *heavily* on the way block
    passing works in the VM. However, it's the most self-contained solution
    I have.

    [Bug #15620]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2289

commit ddb6023d64a8c96348b4e67603753e2916a04f28
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-07-15 13:35:30 +0900

    Add spec for capturing Kernel#lambda with Kernel#method

Notes:
    Merged: https://github.com/ruby/ruby/pull/2289

commit e0b336c8ce84e1456fc6126ca232289667db3e19
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-07-15 12:41:43 +0900

    Add specs for calling into Kernel#lambda with super

Notes:
    Merged: https://github.com/ruby/ruby/pull/2289

commit ea405ee8ed00c03e0521ff4b852d8f3bea849243
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-21 10:06:14 +0900

    test/ruby/test_pattern_matching.rb: suppress "unused variable" warning

commit 9eded02446e34d4db1051f5f18c2d7d554e792d3
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-12-21 03:47:56 +0900

    Add Array#minmax, Range#minmax, and Proc#ruby2_keywords to NEWS

commit 63ce77929ab0ebe992e91a1bad436a5d8e6488a9
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-21 00:07:13 +0900

    * 2019-12-21 [ci skip]

commit 484c1be8956b7bb7a0253c6d6c7a740c341487fa
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 23:51:17 +0900

    Added `-W:experimental` command line option

    [Feature #16420]

commit 07e595fdbd75ed44473073cdf8cd758572d11709
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 23:48:15 +0900

    Added `experimental` warning category

    [Feature #16420]

commit dd7f0c87c9da8e695c38a6529deb6e0f24f6d06c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 23:36:19 +0900

    Hoisted out new_case3

commit a84ad24386d27269b90794146c2a351c1d79471b
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 23:05:22 +0900

    Added -W: command line option

    To manage `Warning[category]` flags.  Only `-W:deprecated` and
    `-W:no-deprecated` are available now.  [Feature #16345]

commit 6876aa38f607cdd6fb24910e54143d9110d025c9
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 22:50:46 +0900

    Added `FEATURE_SET_RESTORE` macro

commit 1fea3a7636cfaf25baba1e9f208c68a8a8ba52cc
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-20 21:37:46 +0900

    NEWS: Update the explanation of pattern matching

    Add an example of "<expr> in <pattern>", an example of
    NoMatchingPatternError, and mention that the slides are slightly
    obsolete.

commit f7aee584987e24768670e96b1455ed1193f91ef2
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-20 19:41:15 +0900

    vm_args.c: rephrase the warning message of keyword argument separation

    (old)
    test.rb:4: warning: The last argument is used as the keyword parameter
    test.rb:1: warning: for `foo' defined here; maybe ** should be added to the call?

    (new)
    test.rb:4: warning: The last argument is used as keyword parameters; maybe ** should be added to the call
    test.rb:1: warning: The called method `foo' is defined here

commit 2b2030f265e4ec0782de9c8dd9f8828a1a0af1b5
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 15:05:10 +0900

    Refined the warning message for $, and $;

    [Bug #16438]

commit 7a94225e7d04f17ddd37433c3904b04fec97f281
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 14:54:44 +0900

    Refined the warning message for numbered-parameter like variables

    [Bug #16438]

commit a8bddb3a189545a2bef8ee7cffdb328d8de7974c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 14:29:42 +0900

    Refined the warning message for numbered-parameter like variables

    [Bug #16438]

commit 435a4ca2a38f3be1f5d2db0f71487a52c8285e9c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 14:14:07 +0900

    Makes the receiver to FrozenError.new a keyword parameter

    [Feature #16419]

commit 216b62aa87f069c51085e9f9abb548930370bc53
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-20 14:10:37 +0900

    use UTC to use previous day in midnight

commit e68999c82c4863d33a6f893661fba1b7538c5671
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 12:19:45 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437], for default gems.

commit e672494cd737b8fea3a186aeb5c2c17d1a18cb96
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-20 11:50:32 +0900

    Merge RubyGems 3.1.2

commit fac60be324260cd834478fedf934e59b97935dbf
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 09:39:50 +0900

    shell.rb is no longer bundled [ci skip]

commit db166290088fb7d39d01f68b9860253893d4f1a7
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 09:19:39 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437], only in ruby and rubyspec.

commit 2898367b3a1de00ca78067cc17dd4d1f8df37778
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 08:18:19 +0900

    Warn also numbered parameter like methods

commit 3816cd945d68eac7ca8fecbc9d71f878ff3e7b3d
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-20 01:40:00 +0900

    Add `URI#open` to warning message

commit 844f1fada6f364dc26bd6eb6de2c4299a69e272a
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-20 01:37:11 +0900

    * 2019-12-20 [ci skip]

commit 27ddb6e99848c397a415b785315896ab50308076
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-20 01:01:17 +0900

    Warn also numbered parameter like parameters

    [Feature #16433]

commit c6c67254fb17b3196a7b0d3fda4650f6b20a467d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 17:17:07 +0900

    Added rb_warn_deprecated

commit 7aa8a786740fd84bd718b0c055f190b25a8f0277
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 17:16:12 +0900

    Manage deprecation warnings about keyword argument

commit 9bf9de3d9d2f67bc401151fb94abf75b5eff5913
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 14:52:15 +0900

    Made the warning for deprecated constants follow the category flag

commit 76035e5bb6a5b44621fd1c11a0553780474d1c01
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-16 18:19:01 +0900

    Adjusted the format

commit e732e0074e53e7ddbaf863197ec3775d7e9d4516
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-19 02:08:51 +0900

    * 2019-12-19 [ci skip]

commit 1e88f6eb95672cae2b0628895a9ee9a5d384e048
Author: Aaron Patterson <tenderlove@ruby-lang.org>
Date:   2019-12-18 10:26:11 +0900

    Refactor free page insertion

    I am trying to fix this error:

      http://ci.rvm.jp/results/trunk-gc_compact@silicon-docker/2491596

    Somehow we have a page in the `free_pages` list that is full.  This
    commit refactors the code so that any time we add a page to the
    `free_pages` list, we do it via `heap_add_freepage`.  That function then
    asserts that the free slots on that page are not 0.

commit efbc0d499c0dc5b74698418c76e58098c6c113e1
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-18 14:53:19 +0900

    Merge bundler-2.1.1 from bundler/bundler

commit fa7fa5c86b0674eca233922045e4d3dd4ee49cb7
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-18 13:03:54 +0900

    delete rb_vm_call()

    Nobody uses it any longer.

commit dcb603bbdbe3a8ea6f6d07198c8711cf9a44a4d2
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-18 12:57:46 +0900

    describe mc_miss_reuse_call [ci skip]

commit fcd8bafd086a7105b535ec1691f960e37d5c911b
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-18 13:35:58 +0900

    Use a temporary file for chown test

    Errno::EROFS may occur when the source tree is placed in a
    read-only filesystem.

commit c147eeff7c2b8d4b8864c8be6496abf7f622a983
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-18 13:29:55 +0900

    [ruby/io-console] Skip Interrupt test on Linux

    Hangs up only in ruby/ruby on Travis-CI.

    https://github.com/ruby/io-console/commit/de39aa6dd6

commit f054f11a38f66af17a0aed8e0d2d46731eaab27d
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-17 15:49:41 +0900

    per-method serial number

    Methods and their definitions can be allocated/deallocated on-the-fly.
    One pathological situation is when a method is deallocated then another
    one is allocated immediately after that.  Address of those old/new method
    entries/definitions can be the same then, depending on underlying
    malloc/free implementation.

    So pointer comparison is insufficient.  We have to check the contents.
    To do so we introduce def->method_serial, which is an integer unique to
    that specific method definition.

    PS: Note that method_serial being uintptr_t rather than rb_serial_t is
    intentional.  This is because rb_serial_t can be bigger than a pointer
    on a 32bit system (rb_serial_t is at least 64bit).  In order to preserve
    old packing of struct rb_call_cache, rb_serial_t is inappropriate.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2759

commit 77e3078ede833e86a1ee0e2ce745b15e892bdbf6
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-18 10:25:18 +0900

    [ruby/io-console] Set raw mode strictly same as cfmakeraw

    * Default VMIN and VTIME to minimum input.
    * Disable parity check bits explicitly.
    * Disable all bits for flow control on input.

    Co-Authored-By: NARUSE, Yui <naruse@airemix.jp>

    https://github.com/ruby/io-console/commit/5ce201a686

commit 254477248cde5bf82c4f256dca05b13d01c9774c
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-12-13 08:47:59 +0900

    Skip optimized method check for most method IDs

    Previously every time a method was defined on a module, we would
    recursively walk all subclasses to see if the module was included in a
    class which the VM optimizes for (such as Integer#+).

    For most method definitions we can tell immediately that this won't be
    the case based on the method's name. To do this we just keep a hash with
    method IDs of optimized methods and if our new method isn't in that list
    we don't need to check subclasses at all.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit 9245462499e7c3216a468aadccdc11e69de8cd54
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-12-13 15:43:00 +0900

    Replace debug test with assertion

    It's a Ruby bug if this ever happens check it as an assertion instead of
    paying the cost of the check every time.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit a01d22b8c16d9bd44767cced8d45398493af0a7c
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-12-12 08:47:49 +0900

    Check type with BUILTIN_TYPE in method cache clear

    We know that this is a heap-allocated object (a CLASS, MODULE, or
    ICLASS) so we don't need to check if it is an immediate value. This
    should be very slightly faster.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit 8e56d3a6ab7cc05be586010acd9f85384d53403a
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-12-13 09:42:34 +0900

    Define PREV_CLASS_SERIAL

    Avoids generating a "throwaway" sentinel class serial. There wasn't any
    read harm in doing so (we're at no risk of exhaustion and there'd be no
    measurable performance impact), but if feels cleaner that all class
    serials actually end up assigned and used (especially now that we won't
    overwrite them in a single method definition).

Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit d7a50a5cc694ab28608a9d5a2e39c2766330ffe6
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-12-12 06:10:39 +0900

    Avoid revisiting seen nodes clearing method cache

    rb_clear_method_cache_by_class calls rb_class_clear_method_cache
    recursively on subclasses, where it will bump the class serial and clear
    some other data (callable_m_tbl, and some mjit data).

    Previously this could end up taking a long time to clear all the classes
    if the module was included a few levels deep and especially if there
    were multiple paths to it in the dependency tree (ie. a class includes
    two modules which both include the same other module) as we end up
    revisiting class/iclass/module objects multiple times.

    This commit avoids revisiting the same object, by short circuiting when
    revisit the same object. We can check this efficiently by comparing the
    class serial of each object we visit with the next class serial at the
    start. We know that any objects with a higher class serial have already
    been visited.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit 8a40dce0ff2964df22e06ae9a08f50592d17caf0
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-18 00:08:43 +0900

    * 2019-12-18 [ci skip]

commit bcec03af05649a8132f5e4e49c2c64762e60b605
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-18 00:08:21 +0900

    Revert "Skip interruptible raw mode test on Travis-CI"

    This reverts commit 65731a1330ed02691e3c343d2feeb8d0a72af3fd.

commit 07ed8f2f916a512b35bc69b49f1c482a2ea6e9dd
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 23:26:07 +0900

    [ruby/io-console] Skip interrupt

    https://github.com/ruby/io-console/commit/8ed5a2bcc3

commit 905a926ea84e199478e32e6da5cd0e8d756132f1
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 18:20:37 +0900

    [ruby/io-console] Timeout in the child process

    https://github.com/ruby/io-console/commit/b8411689a5

commit 4b7d27ca0de5e1294fa2072d948953ef49753fc5
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 17:24:21 +0900

    [ruby/io-console] Use IO.console instead of STDIN

    https://github.com/ruby/io-console/commit/9e3ec5b936

commit 1b86309b04709ce0a64a9206ca638eccda9d4fec
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 23:38:18 +0900

    Squelch filter-branch warning and sleeping

commit ffa7ceceaf7d9f0268db9021eb0df6f197dcb3c8
Author: mihaibuzgau <mihai.buzgau@puppet.com>
Date:   2019-12-17 19:47:15 +0900

    [rubygems/rubygems] Move `require uri` to source_list

    https://github.com/rubygems/rubygems/commit/c6b4df5bfc

commit 299db379575da122bc20745811fc1e20ba01f3ce
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-17 09:46:45 +0900

    Use while instead of loop

Notes:
    Merged: https://github.com/ruby/ruby/pull/2758

commit 9d3ffcfbfc742ed5053b59678dbf97773a7dddc1
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-17 20:22:00 +0900

    disable assertion.

    This assertion is not needed because we found the bug.
    ba11a74745.

commit 65731a1330ed02691e3c343d2feeb8d0a72af3fd
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 17:18:42 +0900

    Skip interruptible raw mode test on Travis-CI

commit b226a68141bd60db4b14264cb579e3eab9b6bcbd
Author: mihaibuzgau <mihai.buzgau@puppet.com>
Date:   2019-12-16 21:42:34 +0900

    [rubygems/rubygems] require `uri` in source.rb

    https://github.com/rubygems/rubygems/commit/8de4d0272e

commit ea717d1ce1199bbd2e6532f1607bab6e1a1f9274
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-17 13:22:24 +0900

    convert macros into inline functions

    For better readability.

commit d616926af916d140f0bd1be3cdc232193d46286a
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-17 14:20:51 +0900

    Remove an unnecessary variable

commit 8f52604b478fee5243080116b8e62f0c1f5cb9a0
Author: Masataka Pocke Kuwabara <kuwabara@pocke.me>
Date:   2019-12-09 00:48:13 +0900

    Remove unnecessary double bangs from Pathname#root?

Notes:
    Merged: https://github.com/ruby/ruby/pull/2732

commit 9421c7804191b73aa9fde8f14235b3a1f37ffd4b
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-16 12:33:13 +0900

    [ruby/logger] Fixed leaked tempfile

    https://github.com/ruby/logger/commit/fb3eff153f

commit 4f9a4c1a8f6a31def5fdf58582f064cf644a5828
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-17 13:47:06 +0900

    Remove unnecessary branches

commit e36319249b1a9967a83e66df2661769c136594ad
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 13:57:58 +0900

    [ruby/io-console] bump up to 0.5.2

commit b39d5da97426c6f65e2b39b307ce19d774d93ddd
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-14 19:15:02 +0900

    [ruby/io-console] Use TCSANOW to prevent from discarding the input buffer

    TCSAFLUSH discards the buffer read before the mode change, which makes
    IRB ignore the buffer input immediately after invoked.  TCSANOW
    preserves the buffer.

    https://github.com/ruby/io-console/commit/b362920182

commit 81eb2d16efcb29899e88e30a25ca5440195e2393
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-13 11:41:31 +0900

    [ruby/io-console] Disable implementation-defined special control characters

    In raw mode with interrupt enabled.

    https://github.com/ruby/io-console/commit/e9e8e3ff17

commit ec89a0f8033215817d9c6f9300d9513178e785b7
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-13 12:14:10 +0900

    [ruby/io-console] Added the test for intr option

    https://github.com/ruby/io-console/commit/4f01db102d

commit a9d17af242748c160cb79909fd881e06141fe428
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 10:07:00 +0900

    [ruby/io-console] Removed dead code

    https://github.com/ruby/io-console/commit/a49462ed97

commit 64ce658ec5a6d6fc6eb969f607e703fd9372287a
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-17 13:30:54 +0900

    Fix return condition according to the condition to skip

commit a1713bedb1de676fdd7d9bf3458b931c4702a1af
Author: Thomas Leitner <t_leitner@gmx.at>
Date:   2019-10-04 17:03:32 +0900

    [ruby/reline] Implement completion_append_character

    There is already the possibility to set Reline.completion_append_character.
    However, it is not used by the line editor.

    https://github.com/ruby/reline/commit/ab798931b9

commit 11db4d3a3b315ed2495ec0cdde4449554c002bff
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-14 11:05:16 +0900

    [ruby/reline] Disable any implementation-defined special control characters

    Including dsusp, lnext, and so on.

    https://github.com/ruby/reline/commit/a44abe586b

commit fbe229906b6e55c2e7bb1e68452d5c225503b9ca
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-17 13:14:52 +0900

    add debug counter to count `call` reusing cases.

commit 618d09115185efa05f6948247d86087f4aa96118
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-17 13:10:39 +0900

    Support change search direction

commit a14a0244b48c422e392547b198af6fb57f7ca568
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-17 12:47:09 +0900

    Support forward-search-history by C-s

commit c687be4bc01c9ce52ea990945d9304d6fe59fe9b
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 11:53:30 +0900

    Added a test for [Bug #16159]

commit ebe5b66ca8e639468e14c4134a415403d949385e
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-17 10:48:17 +0900

    Reduce tzset calls

    Set up-to-date flag always when calling tzset().

commit d6a2bce64a7fa1099e507e1d36b5f1533f42f60f
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-17 10:31:20 +0900

    time.c (find_time_t): fix round-to-zero bug

    `find_time_t` did not work correctly for year older than the Epoch
    because it used C's integer division (which rounds negative to zero).

    For example, `TIme.new(1933)` returned a wrong time whose year is 1922
    in Asia/Kuala_Lumpur because there is no 00:00:00 1st Jan. 1933 in the
    time zone.

    ```
    $ TZ=Asia/Kuala_Lumpur ruby -e 'p Time.new(1933)'
    1932-12-31 00:00:00 +0700
    ```

    This change fixes the issue by using `DIV` macro instead of `/`.
    Now `Time.new(1933)` returns a time in 1933.

    ```
    $ TZ=Asia/Kuala_Lumpur ruby -e 'p Time.new(1933)'
    1933-01-01 00:20:00 +0720
    ```

    [Bug #16159]

commit 5da4a310ccf7f4131c1814a2c9279a5682777f1b
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-17 00:49:17 +0900

    close datasocket on stor of server side

commit 5be34d6a3310065850c0c530db6936415124b5d9
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-10 19:25:00 +0900

    ensure to close the data connection [Bug #16413]

commit 95213f6df6a23918d57a743975708c638da42aae
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-15 10:29:44 +0900

    Check whether Readline.completion_append_character= exists

commit b12bc3b0461f7331db6e27865fa7a8ef29a0f652
Author: Eric Wong <normal@ruby-lang.org>
Date:   2019-12-17 03:28:44 +0900

    thread.c: avoid needless read after select|ppoll

    We do not need to issue pipe|eventfd read(2) syscall
    unless select, ppoll|poll declares the FD needs reading.

commit bba6386d9568123a7c76693e3a5fa5e33562a640
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-17 00:44:32 +0900

    test/ruby/test_process.rb: suppress "unused variable" warning

commit c6b1342d29a71e44c0275516d4f8408ce07bf397
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-17 00:01:56 +0900

    * 2019-12-17 [ci skip]

commit 6a75a460536a32fb62184dc5d8d66ddd737a9bad
Author: Richard Viney <richard.viney@gmail.com>
Date:   2017-01-22 10:50:08 +0900

    Make prettyprint’s cycle detection aware of Delegator instances

    Fixes [Bug #13144]

    Co-Authored-By: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit 251f5d8226dbde06ba06e980e3b741b45ae3826d
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-16 23:39:10 +0900

    Revert "lib/net/http/response.rb: support raw deflate correctly"

    This reverts commit 5105240b1e851410020b3b3f1a2bead7ffdd4291.

    In RFC 2616:

    ```
       deflate
            The "zlib" format defined in RFC 1950 [31] in combination with
            the "deflate" compression mechanism described in RFC 1951 [29].
    ```

    So "Content-Encoding: deflate" means zlib format, not raw deflate.

    [Bug #11268]

commit 5105240b1e851410020b3b3f1a2bead7ffdd4291
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-16 23:20:42 +0900

    lib/net/http/response.rb: support raw deflate correctly

    Net::HTTP had used `Zlib::Inflate.new(32 + Zlib::MAX_WBITS)` for all
    content encoding (deflate, zlib, and gzip).
    But the argument `32 + Zlib::MAX_WBITS` means zlib and gzip decoding
    with automatic header detection, so (raw) deflate compression had not
    been supported.

    This change makes it support raw deflate correctly by passing an
    argument `-Zlib::MAX_WBITS` (which means raw deflate) to
    `Zlib::Inflate.new`.  All deflate-mode tests are fixed too.

    [Bug #11268]

commit d6fd39030d8b14eef117c1e5e265e0b769a9f4fd
Author: BurdetteLamar <burdettelamar@yahoo.com>
Date:   2019-12-14 04:46:54 +0900

    Enhancements for ENV doc

Notes:
    Merged: https://github.com/ruby/ruby/pull/2751

commit d8db343a21b175563fa58a7d33c600ae7c7973cc
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-16 20:47:02 +0900

    Merge RubyGems 3.1.1 and update the NEWS entry for RubyGems

commit ba11a74745e10fac88a74c2da2e0032ccf254265
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-16 17:38:41 +0900

    ensure cc->def == cc->me->def

    The equation shall hold for every call cache.  However prior to this
    changeset cc->me could be updated without also updating cc->def.  Let's
    make it sure by introducing new macro named CC_SET_ME which sets cc->me
    and cc->def at once.

commit 6545d5bbb9517a9364bd59a12a98d3e00516e07e
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-16 16:59:23 +0900

    Use CDN instead of raw.githubusercontent.com

commit 8b921813aa8d5ea8f4e6c1e700ad48a120c500ab
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-16 16:58:21 +0900

    Fix open without close [ci skip]

commit 04e95f8985066b4ae1e97b045efda98bdefa07bd
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-16 11:19:59 +0900

    Get rid of infinite recursion at loading transcoder

    Disable encoding US-ASCII path to filesystem on Windows too.
    [Bug #16392]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2755

commit d2f04d332f2ff04f25202ed38e23de526a9aea46
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-16 09:44:01 +0900

    Kernel#abort without arguments should print error info

    [Bug #16424]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2754

commit 1e80a208cc44cbbdd4e49d6146eea29cde5cd42a
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-16 10:09:13 +0900

    Update the NEWS entry for Bundler 2.1.0

commit 2344d8ac9aefae6258b1967014d17564cf2d2e43
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-16 10:05:44 +0900

    * 2019-12-16 [ci skip]

commit f47c38245ff6976c5d1fc27a79f239bba00fc333
Author: Breno Leitao <breno.leitao@gmail.com>
Date:   2019-12-16 10:05:21 +0900

    gc.h: Add SET_MACHINE_STACK_END specific for Powerpc64 (#1767)

    Currently we are not able to grab the correct end/top of the stack on
    powerpc64 due to the fact that it uses the fallback function.

    The fallback function does not return the correct top of the stack
    because it adds a new frame and the returned top of the stack contains
    this frame overhead that could be something around 112 bytes on
    Powerpc64.

    This patch simply gets the correct top of the stack pointer, which is
    always on r1 register according to both ABI v1 and ABI v2 (Little
    endian).

    Signed-off-by: Breno Leitao <leitao@debian.org>

commit e8c62836a6292bf2f691de458b24ea50c51b452a
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-15 23:13:16 +0900

    IO#set_encoding_by_bom should err when encoding is already set

    Except for ASCII-8BIT.  [Bug #16422]

commit eeb99fb52500b571b1239442a7d17d335cfde060
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-15 22:19:45 +0900

    tool/gen-mailmap.rb: odaira is removed as he is added in upstream

    https://github.com/ruby/ruby-commit-hook/commit/ddc83bea6fe6f4696e140b605db10ef0c922bba6

commit 48bab6fe1eb77b481bffbc97fdbf5ba74c45a07a
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-15 21:59:30 +0900

    tool/gen-mailmap.rb: Added for generating git `.mailmap` file

    `.mailmap` can be used To show canonical names and email addresses.
    It is helpful for statistics of committers.

commit a83c46e3fd1e3480404c6dda4c4cda73533a6a1d
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-15 20:03:47 +0900

    Add more debug info

    closed server doesn't have useful info.
    So call inspect before close.
    And add local debug code in comment.

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable11x/ruby-master/log/20191215T092405Z.fail.html.gz
    ```
      1) Failure:
    IMAPTest#test_connection_closed_without_greeting [/export/home/rubyci/chkbuild-tmp/tmp/build/20191215T092405Z/ruby/test/net/imap/test_imap.rb:483]:
    [Net::IMAP::Error] exception expected, not #<RuntimeError: {:e=>#<Errno::EINVAL: Invalid argument - connect(2) for [::1]:41748>, :server=>#<TCPServer:(closed)>, :port=>41748, :server_addr=>"::1"}>.
    ```

commit 980ddca47e892535c1da897b33ac7bc727efd52d
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-15 16:48:40 +0900

    Prepare to release rubygems-3.1.0

commit 9f43160014905db159ec67e3ee2b485d870de05d
Author: David Rodríguez <deivid.rodriguez@riseup.net>
Date:   2019-12-14 22:15:43 +0900

    Delegate should be supported now

    Since `did_you_mean` dropped its dependency on it.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit 286cb3395f8be493b21d0bdf13bcf40fe5c3ab50
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-14 21:19:28 +0900

    Fixed test failures with gem command path on ruby core repo.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit 0fab9005387549d5c5b13cf330012d02e5312bc2
Author: David Rodríguez <deivid.rodriguez@riseup.net>
Date:   2019-12-14 04:41:13 +0900

    Vendor thor 1.0.0

Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit 38002a8adbd98266426940d829429a30af0622a4
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-14 19:49:16 +0900

    Prepare to release bundler-2.1.0

Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit e2b192f7d5b4f0e2133bb6cf03cfc609258826be
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-15 14:47:36 +0900

    rand(beginless_range) raise Errno::EDOM instead of TypeError

    same as `rand(endless_range)`

    Before:
    ```
    $ ruby -e 'rand(..1)'
    Traceback (most recent call last):
            2: from -e:1:in `<main>'
            1: from -e:1:in `rand'
    -e:1:in `-': nil can't be coerced into Integer (TypeError)
    ```

    After:
    ```
    $ ruby -e 'rand(..1)'
    Traceback (most recent call last):
            1: from -e:1:in `<main>'
    -e:1:in `rand': Numerical argument out of domain (Errno::EDOM)
    ```

commit db2ea9b0c5fb49a04af1b299a37e92f81d7cccd2
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-15 00:21:19 +0900

    [DOC] Fixed the class name in FrozenError#receiver

commit 38b9d213f1fc474549d7ca6858ed4f1d1436d1ee
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-15 00:18:09 +0900

    Revert "[DOC] Fixed the class name in FrozenError#receiver"

    This reverts commit 5f56a5fc9be9ea7b088795c2d3871c2352a020c2.
    `FrozenError.new(mesg, nil).receiver` should not raise an
    ArgumentError.

commit 52b1ba0b0242dc8b10b24df716ec439cd4b2bd88
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-15 00:15:23 +0900

    * 2019-12-15 [ci skip]

commit 5f56a5fc9be9ea7b088795c2d3871c2352a020c2
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-14 23:57:44 +0900

    [DOC] Fixed the class name in FrozenError#receiver

commit 33f0ef44fde7b042d15056cea9af49d160268537
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-14 23:56:28 +0900

    [DOC] Fixed the FrozenError.new result [ci skip]

commit 9e0256836370d6294114320f1b5fa9b3b16b8ae2
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-14 20:26:30 +0900

    Improve highlighting in RubyVM::AbstractSyntaxTree docs when using `ri`

commit b4b22b9278007b106fe40c0191f8dcf5e7e8c0f2
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-14 20:16:58 +0900

    Clarify in the documentation that RubyVM::AbstractSyntaxTree is not stable API

    * See [Feature #14844].

commit 4cc83f9ac60d18ba330dc7f8e92eae1ffce67322
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-14 16:05:49 +0900

    [Feature #13083] is already reverted

commit 90cdcefa78ee9f3c7c78db2c5f3df0fdba25d83f
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-14 16:05:15 +0900

    Update warnings in NEWS

commit e2708068ad65f7f9986adf4fb3a4fa660f430a5a
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-12-14 11:39:58 +0900

    Drop delegate dependency

    Original comment:
      https://github.com/ruby/did_you_mean/commit/2f26c9ee770f28da0942c42cbc9e5800535b75e1

commit f3240eb67dc4c807f6489a8a5ccb6eeec239efe5
Author: Marcus Stollsteimer <sto.mar@web.de>
Date:   2019-12-14 06:07:59 +0900

    NEWS: fix pattern matching example

commit 835703c69f2b1b770b1e3c8c9dd73aca4ed734e6
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-14 00:40:25 +0900

    * 2019-12-14 [ci skip]

commit 84b873e381c6928965e36d0a83c899a01b65e646
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-13 14:35:11 +0900

    [ruby/irb] Restore environment variables

    https://github.com/ruby/irb/commit/236590882c

commit ab1f3d63b0b08fcb8e90557a0d8d72e624221557
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-13 22:10:28 +0900

    Fixed a typo

commit 2ef5f012c1d1dcef18d3c4c56d0d07fc72362be7
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-13 22:00:28 +0900

    Added explicitly loading `Gem::Command` class

commit eb512c5a9530322280991441954b0405cadeebf1
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-13 21:38:50 +0900

    warn should be a global function

commit a2e87123499f6eef9c03089f61f174dd4b3cc673
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-13 20:51:58 +0900

    Fix visibility as module_function

commit 6183addf6a4b94db7fe5b9187ac66fa11c8d2825
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 18:34:49 +0900

    Add `Warning.[]` and `Warning.[]=`

Notes:
    Merged: https://github.com/ruby/ruby/pull/2739

commit f3b1b645edfc5a8c938da74a5ed44564b9e2fc08
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 20:54:01 +0900

    Create backtrace location array directly

Notes:
    Merged: https://github.com/ruby/ruby/pull/2739

commit 0b5268afbcf11c299e11102c366e836ae55cc39f
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 20:22:42 +0900

    Moved Kernel#warn to warning.rb

Notes:
    Merged: https://github.com/ruby/ruby/pull/2739

commit 82cc2843a92b286cc13afd0860a4e111d4ea2a0b
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-13 20:19:08 +0900

    Prepare to release RubyGems 3.1.0 final version.

commit 26774351dc5f494253ba031e4bc453dc4dddb2cf
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-13 18:06:36 +0900

    Ignore error of `apt-get update` in MJIT workflow too

commit d5c73681f8fd9e17b5378cb029fc88e98d7b6abb
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-13 18:04:21 +0900

    Ignore error of `apt-get update` on GitHub Actions

commit 97a17a51b8e6eca31fd6421511f1907e6e95b415
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-13 17:26:12 +0900

    readable function names for inline functions.

    Now, C functions written by __builtin_cexpr!(code) and others are
    named as "__builtin_inline#{n}". However, it is difficult to know
    what the function is. This patch rename them into
    "__builtin_foo_#{lineno}" when cexpr! is in 'foo' method.

commit 1140625cd31f7ad74c42dc625b9dab389b12653c
Author: Matt Valentine-House <matt@eightbitraptor.com>
Date:   2019-12-12 22:37:31 +0900

    Allow more than one major version number in target_os

commit c2dfc6d869979124a46fb0c5404956891c27575f
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-13 03:57:32 +0900

    Show a menu before a document

    IRB should show a menu first if a completed list has plural items. But just
    shows document without menu if a completed list with plural items includes a
    perfect matched item. The behavior is a bug. This commit fixes it.

commit b8d6c883b3f49e6339da4fa5111dbdbe7d3c6df5
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-13 08:52:07 +0900

    Improved the test for Thread#inspect [Feature #16412]

commit fa5f7a8f7ef0d03b8ac97d25a0460c0dc6bb33f3
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-13 00:05:20 +0900

    * 2019-12-13 [ci skip]

commit 69b6f8fd047c5c9e0fa6f65656fda762f8ecfc5e
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-13 00:04:01 +0900

    Check whether TestReadline is defined

commit 93b27c69cc65b5019df061bb8fefaa097bf8a33d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-12 23:26:29 +0900

    Show the failed message too

commit 68321dd1fa6f55e578bc9776f906ee1f948c7095
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-12 22:04:07 +0900

    Move `rescue` for debug into block of assert_raise

commit dd60856f8ddaa0652bf019589f05705e00279b8c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-12 20:53:59 +0900

    [cygwin] fix File.absolute_path? test

    Paths start with the root are absolute on cygwin, regardless the
    drive letter.

commit b6f25318c5a1efca0ab963b49ae69db82787e783
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-12 20:50:01 +0900

    Cygwin path cannot be mapped to a UNC as-is

commit c20dd2f75491fc6e78dab55b492c507ee3bb670d
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-12 17:38:27 +0900

    Add more debug info when Errno::EINVAL

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable11x/ruby-master/log/20191212T072406Z.fail.html.gz

commit 54e089df9e37d438687effd092feda2442116c62
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-12 17:02:36 +0900

    show self on control frame dump.

    control frame detailed info on RUBY_DEBUG=ci should also show
    self information.

commit 55b7ba368696033f2e89b77cbcd4a05dec97b139
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-22 05:59:36 +0900

    Make super in instance_eval in method in module raise TypeError

    This makes behavior the same as super in instance_eval in method
    in class.  The reason this wasn't implemented before is that
    there is a check to determine if the self in the current context
    is of the expected class, and a module itself can be included
    in multiple classes, so it doesn't have an expected class.

    Implementing this requires giving iclasses knowledge of which
    class created them, so that super call in the module method
    knows the expected class for super calls.  This reference
    is called includer, and should only be set for iclasses.

    Note that the approach Ruby uses in this check is not robust. If
    you instance_eval another object of the same class and call super,
    instead of an TypeError, you get super called with the
    instance_eval receiver instead of the method receiver.  Truly
    fixing super would require keeping a reference to the super object
    (method receiver) in each frame where scope has changed, and using
    that instead of current self when calling super.

    Fixes [Bug #11636]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2717

commit 1a4a9bdb5da973f8a89e699ce6d0fb1ca21090bd
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-12 13:59:52 +0900

    proper initialization of struct RVALUE

    This changeset makes no difference unless GC_DEBUG is on.  When that flag is
    set, struct RVALUE is bigger than struct RObject.  We have to take care of the
    additional fields.  Otherwise we get a SIGSEGV like shown below.

    The way obj is initialized in this patch works for both GC_DEBUG is on and off.
    See also ISO/IEC 9899:1999 section 6.7.8 paragraph #21.

    ```
    Program received signal SIGSEGV, Segmentation fault.
    __strlen_avx2 () at ../sysdeps/x86_64/multiarch/strlen-avx2.S:62
    62      ../sysdeps/x86_64/multiarch/strlen-avx2.S: No such file or directory
    (gdb) bt
    #0  __strlen_avx2 () at ../sysdeps/x86_64/multiarch/strlen-avx2.S:62
    #1  0x00005555557dd9a7 in BSD_vfprintf (fp=0x7fffffff6be0, fmt0=0x5555558f3059 "@%s:%d", ap=0x7fffffff6dd0) at vsnprintf.c:1027
    #2  0x00005555557db6f5 in ruby_do_vsnprintf (str=0x555555bfc58d <obj_info_buffers+1325> "", n=211, fmt=0x5555558f3059 "@%s:%d", ap=0x7fffffff6dd0) at sprintf.c:1022
    #3  0x00005555557db909 in ruby_snprintf (str=0x555555bfc58d <obj_info_buffers+1325> "", n=211, fmt=0x5555558f3059 "@%s:%d") at sprintf.c:1040
    #4  0x0000555555661ef4 in rb_raw_obj_info (buff=0x555555bfc560 <obj_info_buffers+1280> "0x0000555555d2bfa0 [0     ] T_STRING (String)", buff_size=256, obj=93825000456096) at gc.c:11449
    #5  0x000055555565baaf in obj_info (obj=93825000456096) at gc.c:11612
    #6  0x000055555565bae1 in rgengc_remembered (objspace=0x555555c0a1c0, obj=93825000456096) at gc.c:6618
    #7  0x0000555555666987 in newobj_init (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, wb_protected=1, objspace=0x555555c0a1c0, obj=93825000456096) at gc.c:2134
    #8  0x0000555555666e49 in newobj_slowpath (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, objspace=0x555555c0a1c0, wb_protected=1) at gc.c:2209
    #9  0x0000555555666b94 in newobj_slowpath_wb_protected (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, objspace=0x555555c0a1c0) at gc.c:2220
    #10 0x000055555565751b in newobj_of (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, wb_protected=1) at gc.c:2256
    #11 0x00005555556575ca in rb_wb_protected_newobj_of (klass=93824999964192, flags=5) at gc.c:2272
    #12 0x00005555557f36ea in str_alloc (klass=93824999964192) at string.c:728
    #13 0x00005555557f2128 in rb_str_buf_new (capa=0) at string.c:1317
    #14 0x000055555578c66d in rb_reg_preprocess (p=0x555555cc8148 "^-(.)(.+)?", end=0x555555cc8152 "", enc=0x555555cc7c80, fixed_enc=0x7fffffff74e8, err=0x7fffffff75f0 "") at re.c:2682
    #15 0x000055555578ea13 in rb_reg_initialize (obj=93825000046736, s=0x555555cc8148 "^-(.)(.+)?", len=10, enc=0x555555cc7c80, options=0, err=0x7fffffff75f0 "", sourcefile=0x555555d1a5c0 "lib/optparse.rb", sourceline=1460) at re.c:2808
    #16 0x000055555578e285 in rb_reg_initialize_str (obj=93825000046736, str=93825000046904, options=0, err=0x7fffffff75f0 "", sourcefile=0x555555d1a5c0 "lib/optparse.rb", sourceline=1460) at re.c:2869
    #17 0x000055555578ee02 in rb_reg_compile (str=93825000046904, options=0, sourcefile=0x555555d1a5c0 "lib/optparse.rb", sourceline=1460) at re.c:2958
    #18 0x0000555555748dfb in rb_parser_reg_compile (p=0x555555d1f760, str=93825000046904, options=0) at parse.y:12157
    #19 0x00005555557581c3 in parser_reg_compile (p=0x555555d1f760, str=93825000046904, options=0) at parse.y:12151
    #20 0x00005555557580ac in reg_compile (p=0x555555d1f760, str=93825000046904, options=0) at parse.y:12167
    #21 0x0000555555746ebb in new_regexp (p=0x555555d1f760, node=0x555555dece68, options=0, loc=0x7fffffff89e8) at parse.y:10072
    #22 0x000055555573d1f5 in ruby_yyparse (p=0x555555d1f760) at parse.y:4395
    #23 0x000055555574a582 in yycompile0 (arg=93825000404832) at parse.y:5945
    #24 0x00005555558c6898 in rb_suppress_tracing (func=0x55555574a470 <yycompile0>, arg=93825000404832) at vm_trace.c:427
    #25 0x0000555555748290 in yycompile (vparser=93824999283456, p=0x555555d1f760, fname=93824999283624, line=1) at parse.y:5994
    #26 0x00005555557481ae in rb_parser_compile_file_path (vparser=93824999283456, fname=93824999283624, file=93824999283400, start=1) at parse.y:6098
    #27 0x00005555557cdd35 in load_file_internal (argp_v=140737488331760) at ruby.c:2023
    #28 0x00005555556438c5 in rb_ensure (b_proc=0x5555557cd610 <load_file_internal>, data1=140737488331760, e_proc=0x5555557cddd0 <restore_load_file>, data2=140737488331760) at eval.c:1128
    #29 0x00005555557cb68b in load_file (parser=93824999283456, fname=93824999283624, f=93824999283400, script=0, opt=0x7fffffffa468) at ruby.c:2142
    #30 0x00005555557cb339 in rb_parser_load_file (parser=93824999283456, fname_v=93824999283624) at ruby.c:2164
    #31 0x00005555556ba3e1 in load_iseq_eval (ec=0x555555c0a650, fname=93824999283624) at load.c:579
    #32 0x00005555556b857a in require_internal (ec=0x555555c0a650, fname=93824999284352, exception=1) at load.c:1016
    #33 0x00005555556b7967 in rb_require_string (fname=93824999284464) at load.c:1105
    #34 0x00005555556b7939 in rb_f_require (obj=93824999994824, fname=93824999284464) at load.c:811
    #35 0x00005555558b7ae0 in call_cfunc_1 (recv=93824999994824, argc=1, argv=0x7ffff7ecd0a8, func=0x5555556b7920 <rb_f_require>) at vm_insnhelper.c:2348
    #36 0x00005555558a8889 in vm_call_cfunc_with_frame (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10, empty_kw_splat=0) at vm_insnhelper.c:2513
    #37 0x000055555589fb5c in vm_call_cfunc (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:2538
    #38 0x000055555589f22e in vm_call_method_each_type (ec=0x555555c0a650, cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:2924
    #39 0x000055555589ef47 in vm_call_method (ec=0x555555c0a650, cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:3038
    #40 0x0000555555866dbd in vm_call_general (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:3075
    #41 0x00005555558ae557 in vm_sendish (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, cd=0x555555d76a10, block_handler=0, method_explorer=0x5555558ae5d0 <vm_search_method_wrap>) at vm_insnhelper.c:4021
    #42 0x000055555587745b in vm_exec_core (ec=0x555555c0a650, initial=0) at insns.def:801
    #43 0x0000555555899b9c in rb_vm_exec (ec=0x555555c0a650, mjit_enable_p=1) at vm.c:1907
    #44 0x000055555589aaf0 in rb_iseq_eval_main (iseq=0x555555c1da80) at vm.c:2166
    #45 0x0000555555641f0b in rb_ec_exec_node (ec=0x555555c0a650, n=0x555555c1da80) at eval.c:277
    #46 0x0000555555641d62 in ruby_run_node (n=0x555555c1da80) at eval.c:335
    #47 0x000055555557a188 in main (argc=11, argv=0x7fffffffc848) at main.c:50
    (gdb) fr 7
    #7  0x0000555555666987 in newobj_init (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, wb_protected=1, objspace=0x555555c0a1c0, obj=93825000456096) at gc.c:2134
    2134        if (rgengc_remembered(objspace, (VALUE)obj)) rb_bug("newobj: %s is remembered.", obj_info(obj));
    (gdb) p ((struct RVALUE*)obj)->file
    $1 = 0x65a5992b0fb25ce7 <error: Cannot access memory at address 0x65a5992b0fb25ce7>
    (gdb)
    ```

commit 35eb12c06397e770392a41343cbffc4b204e15c9
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-12 12:39:24 +0900

    add casts

    %p is for void *.  Because fprintf is a function with variadic arguments
    automatic cast from any pointer to void * does not work.  We have to be
    explicit.

commit f40143fe7c55e3b2209f57e7ec4b3ad1d9468a1e
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-12 12:37:58 +0900

    fix arity mismatch

    I missed this in bc3e7924bc66d3ef77b219c72f3e59cc154550a3 because the
    function is inside of a #ifdef.

commit 12de92a3682f7a54941c511e6394068df2adefb3
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-12 11:11:39 +0900

    implement make test-all TESTS=--gc-compact

    79eb5e1acac2339c6ec71db723298bdfcd92b233 implemented
    RUBY_TEST_GC_COMPACT=1 so why not make it also possible via the command
    line argument.

commit 53e8589c69d1345235d9f02ecbcf6aa32fa9d39c
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-12 09:14:09 +0900

    Import json-2.3.0 from flori/json

commit 7d991a0571ab33f44c00fdc227f076d1eaf5fb2b
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-12 08:40:44 +0900

    Suppress to crash IRB if completed list has nil

commit 50ae8895f32f5fc620f0a0f288dae62815cb2a6f
Author: Rei Odaira <rodaira@us.ibm.com>
Date:   2019-12-12 04:31:38 +0900

    debug_counter.c: include ruby/config.h before stdio.h
    to define _LARGE_FILES

commit 27ac034f196967f54edf00474880886624d30245
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-12 04:26:03 +0900

    support gc_compact_checker on parallel test.

commit 7dbbba38a0a6acd41a43eb0c4fc416fe35e2345a
Author: Aaron Patterson <tenderlove@ruby-lang.org>
Date:   2019-10-12 09:13:02 +0900

    Make sure we don't push MOVED or NONE on the stack

commit 79eb5e1acac2339c6ec71db723298bdfcd92b233
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-12 03:31:13 +0900

    call GC.compact after each test.

    RUBY_TEST_GC_COMPACT=1 enables GC.compact checker which calls
    GC.compact after each test.

commit 51cc5a26df5f47ecdd88398ba1a50a8e62182649
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-12 03:18:44 +0900

    Some tests failed with before GNU Readline 6.0 on Windows

commit fe4502336680270d886b502e4b35ecb3de2f2164
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-12 03:13:32 +0900

    * 2019-12-12 [ci skip]

commit 0f90630983db3257c544c698761a00456af81d85
Author: Aaron Patterson <tenderlove@ruby-lang.org>
Date:   2019-12-12 03:12:14 +0900

    Update method tables only if there is a class ext pointer

    This makes reference updating look similar to marking, and may avoid
    dereferencing a wrong pointer.

commit cae657c32492a9b4e72b5e290c143e2c84d4c42d
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-11 21:54:18 +0900

    Fix .travis.yml to keep s390x-linux as allow_features

    [Misc #16360]

commit 47a365dd580f2dfe0f0d56155587dfdf2fc7afb7
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-11 20:44:39 +0900

    Move s390x-linux to allow_failures matrix

    ref [Misc #16360]

commit 49ffae7ca66f3e0bc3e2d87092197d3514d5925e
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-12-02 12:59:07 +0900

    [ruby/forwardable] Bump version to 1.3.1

    https://github.com/ruby/forwardable/commit/aa07c55f3f

commit 0dcd3340fb5f91112ce66c53315eff92b9f10fb7
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-12-02 12:57:06 +0900

    [ruby/forwardable] Make def_*_delegator return name of method defined (Fixes #10)

    This restores compatibility with previous versions.  This behavior
    was previously undefined, but it makes sense for the name of the
    defined method to be returned.

    https://github.com/ruby/forwardable/commit/a52ef3451e

commit c2f6aa4e4810f8f2aabc35bf4c98ee030ff504b9
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-11 19:39:37 +0900

    The result of Readline.completion_proc should have the same encoding of Encoding.default_external

commit 3098798044ada5a81862aa4668aaf7548f9b1c99
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-11 16:41:37 +0900

    Test `Thread#to_s` when used from to_s_spec.rb

commit d2d42081ce76954ff55392a6e07e3eb4f26c696c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-11 16:19:49 +0900

    `Thread#to_s` has been added at ruby 2.5

commit eb9c0070535bc088ab2921613830ba983bfe07a1
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-11 16:48:19 +0900

    skip continuous failure test.

    On mingw this test fails and not solved long time, so skip it.
    Please revert it when it solved.

    https://ci.appveyor.com/project/ruby/ruby/builds/29458671/job/9nbcjnfe6p0xnxoe

commit 1269157a6e46895c0eda2ea202d44790bbe815c8
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-11 16:10:26 +0900

    Thread#to_s is not same as #inspect on old version.

    Thread#to_s returns simple Object#to_s until Ruby 2.4.

commit 7f5014e6e884d7fa091e3e6462827b910417267c
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-11 15:45:23 +0900

    rely on sorted compiled binary array.

    `builtin_binary` is sorted by miniruby loading order and this
    loading order should be same on ruby. So we can believe sorted
    order of `builtin_binary` on boot time.

commit 0afee4d80355dd03f0dfefe6120e2e1808d9cb50
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-11 14:27:21 +0900

    Show the failed message

commit 7fa821a80d60992f019c98ac813e2fc6e9775031
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-11 14:01:23 +0900

    Try to use `set-output`

    because commit info are not necessary in env.

commit 6025783a3b0b37517728c635250669449bb21a53
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-11 14:00:32 +0900

    fix for old MRI versions

commit fe8caf0ab93e69b743470d16f6cf7416fe9c98da
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-11 13:37:00 +0900

    add dependency pointed by update-deps

commit 35adc47e7eb1640d35e4d294af7e9651d918608d
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-11 13:08:21 +0900

    Create dummy files when check only

    because foo.rb in build directory breaks test-bundler
    https://github.com/ruby/ruby/runs/343168046#step:20:125

commit cf948a3d3f37c4a786611f5b48c9c020f6020161
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-10 23:01:23 +0900

    Do not load q.rb in build directory

Notes:
    Merged: https://github.com/ruby/ruby/pull/2736

commit 4f5dc15b049eacb9070e2c941183fed68c41f81e
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-10 21:44:34 +0900

    Create more dummy files in build directory

Notes:
    Merged: https://github.com/ruby/ruby/pull/2736

commit 1ed0212bcf76ec244ca5b75c65f09e5b04158377
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-10 18:31:01 +0900

    Do not load files in build directory

    related https://bugs.ruby-lang.org/issues/16177

Notes:
    Merged: https://github.com/ruby/ruby/pull/2736

commit 85e43e1dfecef69b935c48c235cc20f21bd4f0d4
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-12-11 06:38:12 +0900

    Fix Enumerator::Lazy#with_index

    * Make it correctly handle lambdas
    * Make it iterate over the block if block is given

    The original implementation was flawed, based on lazy_set_method
    instead of lazy_add_method.

    Note that there is no implicit map when passing a block, the return
    value of the block passed to with_index is ignored, just as it
    is for Enumerator#with_index. Also like Enumerator#with_index,
    when called with a block, the return value is an enumerator without
    the index.

    Fixes [Bug #16414]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2742

commit 8a80bfcfd4d510a20a62e21d8d2f4119cb823d4f
Author: Jean byroot Boussier <jean.boussier+github@shopify.com>
Date:   2019-12-10 19:49:39 +0900

    Make Thread#to_s consistent with Method and Proc to_s

Notes:
    Merged: https://github.com/ruby/ruby/pull/2738

commit 6a7af800dbd45946caaadfc4a1212fc523afe58b
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-11 11:36:21 +0900

    Add a message for CompatibilityError

commit 7e9b1609dae0998a4418179f40dc488842c56e5d
Author: Eli Sadoff <9064062+snood1205@users.noreply.github.com>
Date:   2019-12-11 11:25:54 +0900

    Added documentation for integer range sums (#1593)

commit 86e2c013d7ade7c93077d599e155aae0f3b632e8
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-11 11:25:00 +0900

    * remove trailing spaces. [ci skip]

commit bbbf451bffbc5605b53726c5977d96bffc10d162
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-11 11:22:27 +0900

    Update tool/mk_builtin_binary.rb

    Co-Authored-By: Sutou Kouhei <kou@cozmixng.org>

Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 40026a408df5e3576380f6c1d8bf6c119fa2e32b
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-10 17:39:04 +0900

    support cross-compilation.

    On cross-compilation, compiled binary can no be created because
    compiled binary should be created by same interpreter (on cross-
    compilation, host ruby is used to build ruby (BASERUBY)).
    So that cross-compilation system loads required scripts in text.
    It is same as miniruby.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 9c2807b2df14984e3c81d72a381d9a4d288b3fbe
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-10 17:13:42 +0900

    remove prelude.c

    prelude.c is an automatically generated file by template/prelude.c.tmpl.
    However it does not contain any required functions. So remove it from
    dependency.

    Also miniprelude.c is included by mini_builtin.c and does not need
    to make miniprelude.o.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 2c5c60754cafe9895b7a7421cd0552eaa2ae8b09
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-10 16:19:13 +0900

    use compiled binary for gem_prelude.rb.

    `gem_prelude.rb` is not compiled yet. This patch compile it to
    compiled binary.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 943f3e5fd463bf2a4a3a4e92b5134e238b9c931d
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-09 16:20:35 +0900

    add include guard

Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 69aa927a40618591082085fe04c010d516dd50d3
Author: Corey Farwell <coreyf@rwell.org>
Date:   2017-04-18 06:58:51 +0900

    Indicate `find_all` and `select` methods are aliases.

    This matches the documentation for `Enumerable::inject` and `Enumerable::reduce` which are also aliases.

commit 0fafb83b3878b11de18de7a2d09927842eaf5fb7
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-11 11:13:28 +0900

    * 2019-12-11 [ci skip]

commit ec54ac938104517dd61887006ef8cc324b3b1b35
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-11 11:12:54 +0900

    Support Readline.completion_quote_character by Reline

commit 8e49ef5a691cc9a249acae8c7335ec53bf445dc3
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 23:13:40 +0900

    [ruby/io-console] update depend for f9c0fe77c0e

commit 2a2a707829168b898508ae27a0458719a36bd316
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-10 21:21:19 +0900

    Followed up 38722fa179fcec549300b2f35206f4eb168f202e

commit 95f570d0d349a7fd86c6425c9c5d7d87cc5ecd46
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-10 20:56:09 +0900

    [ruby/logger] bump version to 1.4.2

    https://github.com/ruby/logger/commit/d6c01cc652

commit 0b10d46a577bb6b0e8e177f5c3f17f8d61007d6c
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-21 13:28:14 +0900

    [ruby/logger] Enable more timezone tests on OpenBSD

    https://github.com/ruby/logger/commit/bcd7e227e8

commit 7a1c56f978907d03876772d942619ec90cbbfa6b
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-18 10:34:56 +0900

    [ruby/logger] Document that shift_age of 0 disables log file rotation

    Fixes Ruby Bug 16349.

    https://github.com/ruby/logger/commit/b1b6d06f2d

commit 38722fa179fcec549300b2f35206f4eb168f202e
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-15 10:08:10 +0900

    [ruby/logger] Raise ArgumentError for invalid shift_age

    Consider 'now' and 'everytime' as valid values for the previous
    behavior of rotating every time.

    Fixes Ruby Bug 15977

    https://github.com/ruby/logger/commit/f92979a376

commit eb18cb3e476db3bc44d489e090e1535237c4c6c9
Author: George Claghorn <george@basecamp.com>
Date:   2019-09-07 07:28:05 +0900

    [ruby/logger] Honor Logger#level overrides

    https://github.com/ruby/logger/commit/7365c995bf

commit af11efd377965b6601bb54aa79072ef0789dc525
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-10 19:06:13 +0900

    fix ipaddr parameter of Net::HTTP.start to support proxy

    54072e329cab7207fba133caba4fc12b45add8f9

commit aedbee52c0e21358c33e775eab41c634905f63c3
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 18:49:53 +0900

    Prefer $(CHDIR) for the case srcdir contains symlinks

commit 79d2a1b004b06692279bb647e0eee712e55d14c4
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-10 18:41:05 +0900

    Update regression tests for 1.4.16

commit 8299bcd9465b98bd40711bb9c0d4488aba0b72e1
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-10 18:18:04 +0900

    .indent.pro: Removed because it is no longer used

commit c596e01a49d8c77b6dacc931a24eb4b7876617b7
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-10 18:05:51 +0900

    Move SECURITY.md into .github/ to reduce the files on the top directory

commit fe0df7dcfc92b81d3508473a08584f8372418323
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-10 17:27:43 +0900

    Change encoding of completion strings

commit 60c53ff6ee1eed054fc3d78ad6c06cbfc56900d6
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-10 17:10:23 +0900

    vm_core.h (iseq_unique_id): prefer uintptr_t instead of unsigned long

    It produced a warning about type cast in LLP64 (i.e., windows).

commit e27d2013db18d124d1362b6cc81ecec806ef1a0d
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-10 17:03:46 +0900

    Import racc-1.4.1 from ruby/racc.

commit 43544f8617a81fbaef03d926777df4a5311cdb74
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-10 17:03:13 +0900

    Added the missing gemspec of racc

commit 58e5ab78d0a88d9153770a82cff9b553f53dd5d5
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 15:26:14 +0900

    [ruby/io-console] bump up to 0.5.1

commit 2419b3dba6d86ea40a148f7547ff87b2074ca582
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 10:44:21 +0900

    [ruby/io-console] Suppress an unused-variable warning

    https://github.com/ruby/io-console/commit/ae5c72e481

commit f9c0fe77c0ef6c5da1d8454bf6be6841c984d606
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 10:09:33 +0900

    [ruby/io-console] Use rb_thread_call_without_gvl instead of the deprecated function

    https://github.com/ruby/io-console/commit/21338ab287

commit 09723b98f7a8db4ce6d22cd282525275154736fe
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 10:08:43 +0900

    [ruby/io-console] Warn vtime option without intr flag

    https://github.com/ruby/io-console/commit/499ff3de48

commit 0c2787b9b29d839876ac68afbd6209a8407fcb30
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 10:05:25 +0900

    [ruby/io-console] bump up to 0.5.0

commit 1bdabaa6b13344c195698ca5b0ced323cb93e2e1
Author: Konstantin Papkovskiy <konstantin@papkovskiy.com>
Date:   2017-08-15 23:35:58 +0900

    base64.rb: improve performance of Base64.urlsafe_encode64

    * lib/base64.rb: avoid unnecessary memory allocations

commit 3ca3c8d768f6d81da72df4798736c2e0059d19f9
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-10 14:15:35 +0900

    lib/net/http.rb: align the indentation

commit 7be550d046c726c2a3aa625ceb260d9b2268fb5a
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-10 12:41:09 +0900

    Stop Thread.new in `DRb::TimerIdConv::TimerHolder2#on_gc`

    and add more stop_pool after stop_service

commit 129c3216d966fc25209a7e50418413ffecd25281
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 12:11:56 +0900

    [cygwin] Removed unnecessary packages

Notes:
    Merged: https://github.com/ruby/ruby/pull/2734

commit cd35c0954085758ec1fb5a5fcfb7d6d9d5e71a90
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-10 12:11:37 +0900

    [cygwin] Removed unnecessary `-c` options

Notes:
    Merged: https://github.com/ruby/ruby/pull/2734

commit ec931ee9e13b939f6693032564ee9beeec5a4a1f
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-10 11:42:29 +0900

    forward declare struct timespec

    ... like we do so for struct timeval at several hundreds of lines above.
    Depending on OS/Compiler, this can be the first place for the struct to
    appear.  To make sure the struct is global, we need a forward
    declaration at this point.

commit c50d9dc67d350ad4e21ff1af39635bb5a6114282
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-10 11:26:22 +0900

    test/ruby/test_keywords.rb: suppress a warning

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/ubuntu1604/ruby-master/log/20191210T003005Z.log.html.gz
    ```
    .../test/ruby/test_keyword.rb:2711: warning: `*' interpreted as argument prefix
    ```

commit 660388f6c5b148ea6f84d589482391bf78f35c6b
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-10 09:41:33 +0900

    test/net/http/test_https.rb (test_get_SNI_failure): stop proxy settings

    Because the test fails under HTTP proxy settings.

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/solaris10-gcc/ruby-master/log/20191210T000004Z.fail.html.gz
    ```
      1) Failure:
    TestNetHTTPS#test_get_SNI_failure [/export/home/users/chkbuild/cb-gcc/tmp/build/20191210T000004Z/ruby/test/net/http/test_https.rb:81]:
    [OpenSSL::SSL::SSLError] exception expected, not #<Net::HTTPServerException: 403 "Forbidden">.
    ```

    The new SNI feature introduced at 54072e329c may need to be improved for
    HTTP proxy environment.

commit 6a22b2a091eda81a473eb1b0cc69fe0792560e27
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-10 07:01:26 +0900

    Support completion with case-insensitive fashion

    Reline performs completion in a case-insensitive fashon if
    Readline.completion_case_fold or completion-ignore-case of .inputrc are set
    "on".

commit 562fd754b55aaaf794fa8eb5461eb0ee87725464
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-10 00:10:44 +0900

    * 2019-12-10 [ci skip]

commit f45c0dc23980d7fd8167d290ea7c354cf2cdb500
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-12-06 04:01:20 +0900

    Add Proc#ruby2_keywords

    This allows passing keywords through a normal argument splat in a
    Proc.  While needing ruby2_keywords support for methods is more
    common, there is code that delegates keywords through normal
    argument splats in procs, including code in Rails.  For that
    reason, it makes sense to expose this for procs as well.

    Internally, ruby2_keywords is not tied to methods, but iseqs,
    so this just allows for setting the ruby2_keywords for the iseq
    related to the proc.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2728

commit c2dc27d6435f40ff24f553cf47816a1c696bbbba
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-09 20:48:35 +0900

    fix typo of 54072e329cab7207fba133caba4fc12b45add8f9

commit 54072e329cab7207fba133caba4fc12b45add8f9
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-09 20:19:11 +0900

    Add ipaddr optional parameter to Net::HTTP#start

    to replace the address for TCP/IP connection [Feature #5180]

    There're 3 layers of hostname:
    * host address for TCP/IP
    * TLS server name
    * HTTP Host header value
    To test DNS round robin or check server certificate from server local,
    people sometimes want to connect server with given IP address but keep
    TLS server name and HTTP Host header value.

    closes [Feature #15215]
    closes https://github.com/ruby/ruby/pull/1893
    closes https://github.com/ruby/ruby/pull/1977

commit 194327942690a7997c7b48d34cc105c6ec8b8d40
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-09 19:16:51 +0900

    Added workaround for CoreAssertions used by ruby/logger.

commit 4b36832ba64a8879a4b0702d6d5079ddd9d3078e
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-12-09 19:11:18 +0900

    Merge the upstream changes for test-unit on ruby/logger.

      This commits are based with:
        https://github.com/ruby/logger/commit/f067f7d1aa743b467d633ec6d1790bd93ed9e25b
        https://github.com/ruby/logger/commit/86058f420d8f6909500cccceb24f58bef0597b4d
        https://github.com/ruby/logger/commit/02db6e8ed85d1f4ba974f08fee292bad400d9fc2

commit ff7cc0dc34832a074ce42e383439b87ea63b42f7
Author: sonots <sonots@gmail.com>
Date:   2019-08-20 21:10:08 +0900

    [ruby/logger] 1.4.1

    https://github.com/ruby/logger/commit/5987f518d1

commit 895f86c81b95143ecdcca6a8cd4e9367a33b0aaa
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-08-20 16:39:38 +0900

    [ruby/logger] Fixes #38

    https://github.com/ruby/logger/commit/31efbb29ff

commit 0fe1b0508249bc6d64a67c17307a0037f29add74
Author: sonots <sonots@gmail.com>
Date:   2019-08-20 03:02:21 +0900

    [ruby/logger] 1.4.0

    https://github.com/ruby/logger/commit/8127ce0b56

commit 6158e28f8d02026e21317d8a0c2cb2115b3a0660
Author: Akira Matsuda <ronnie@dio.jp>
Date:   2019-07-31 14:38:38 +0900

    [ruby/logger] Avoid creating [] and "" when logging an Exception that has no backtrace

    https://github.com/ruby/logger/commit/75fd308053

commit 0aafc32995b935b6c46c8439a3e2da008cd683fc
Author: sonots <sonots@gmail.com>
Date:   2019-03-22 01:14:14 +0900

    [ruby/logger] frozen_string_literal: true

    https://github.com/ruby/logger/commit/a057eede7b

commit 22548195d59d8b5e421c586bec81615a0a1091bc
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-07-15 14:52:06 +0900

    [ruby/logger] Fix typo

    https://github.com/ruby/logger/commit/5f70168ac5

commit 8395a6a9a0696d1a0a6aa6a019a1a919ee2c854f
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-09 15:05:17 +0900

    Add badge of Cygwin

Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit a5e6a50cb8e4acd4feee2ad3a61eac568f2c62b6
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-09 15:04:59 +0900

    Add cache of cygwin packages

Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit ea8f03e86c57ff28154345865a2560b8895f3e68
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-09 15:03:10 +0900

    Remove unused branch name

Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit 801eafcc146808399f9ca53b3f3b730b81235abb
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-09 14:29:38 +0900

    Split cygwin-chocolatey cache

Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit c19e62ddc9d7160d470f76dae823e9546d0a7bf3
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-09 14:06:06 +0900

    Remove debug print

Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit 156fb72d7015b420c57b0bd230693f52d8d75b32
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-09 15:22:48 +0900

    vm_args.c (rb_warn_check): Use iseq_unique_id instead of its pointer

    (This is the second try of 036bc1da6c6c9b0fa9b7f5968d897a9554dd770e.)

    If iseq is GC'ed, the pointer of iseq may be reused, which may hide a
    deprecation warning of keyword argument change.

    http://ci.rvm.jp/results/trunk-test1@phosphorus-docker/2474221

    ```
    1) Failure:
    TestKeywordArguments#test_explicit_super_kwsplat [/tmp/ruby/v2/src/trunk-test1/test/ruby/test_keyword.rb:549]:
    --- expected
    +++ actual
    @@ -1 +1 @@
    -/The keyword argument is passed as the last hash parameter.* for `m'/m
    +""
    ```

    This change ad-hocly adds iseq_unique_id for each iseq, and use it
    instead of iseq pointer.  This covers the case where caller is GC'ed.
    Still, the case where callee is GC'ed, is not covered.

    But anyway, it is very rare that iseq is GC'ed.  Even when it occurs, it
    just hides some warnings.  It's no big deal.

commit 07664f3aec1b80f6ffe3929258c9a246f0bdcc48
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-09 14:21:05 +0900

    Remove workaround encoding modification

commit a14c01441b12552386c69233b0bcc53d06ed0b92
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-09 14:20:25 +0900

    Fix encoding compatibility checking of completion correctly

commit 3cdb37d9db9b7776f6adf96c70eacc39773718b4
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-09 13:49:24 +0900

    Revert "vm_args.c (rb_warn_check): Use iseq_unique_id instead of its pointer"

    This reverts commit 036bc1da6c6c9b0fa9b7f5968d897a9554dd770e.

    This caused a failure on iseq_binary mode.
    http://ci.rvm.jp/results/trunk-iseq_binary@silicon-docker/2474587

    Numbering iseqs is not trivial due to dump/load.

commit 39c7230a7a7a039639d2cb3587c054554a1beb18
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-09 13:49:17 +0900

    Revert "vm_args.c (rb_warn_check): Use unique_id * 2 instead of unique_id"

    This reverts commit 751a9b32e5a53336768eb878de1827245a3292bf.

commit 8b07c122b7785fde6b06dd31b09f59a7cbdac2cd
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-09 13:46:23 +0900

    Stop pool threads in test/rinda too

commit 751a9b32e5a53336768eb878de1827245a3292bf
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-09 12:30:00 +0900

    vm_args.c (rb_warn_check): Use unique_id * 2 instead of unique_id

    The function assumed that the LSB of `callee` was 0.

commit 036bc1da6c6c9b0fa9b7f5968d897a9554dd770e
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-09 12:04:58 +0900

    vm_args.c (rb_warn_check): Use iseq_unique_id instead of its pointer

    If iseq is GC'ed, the pointer of iseq may be reused, which may hide a
    deprecation warning of keyword argument change.

    http://ci.rvm.jp/results/trunk-test1@phosphorus-docker/2474221

    ```
      1) Failure:
    TestKeywordArguments#test_explicit_super_kwsplat [/tmp/ruby/v2/src/trunk-test1/test/ruby/test_keyword.rb:549]:
    --- expected
    +++ actual
    @@ -1 +1 @@
    -/The keyword argument is passed as the last hash parameter.* for `m'/m
    +""
    ```

    This change ad-hocly adds iseq_unique_id for each iseq, and use it
    instead of iseq pointer.  This covers the case where caller is GC'ed.
    Still, the case where callee is GC'ed, is not covered.

    But anyway, it is very rare that iseq is GC'ed.  Even when it occurs, it
    just hides some warnings.  It's no big deal.

commit 0e71fbc18e97007ac9a9b242b800f34057f5f287
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-09 00:13:07 +0900

    * 2019-12-09 [ci skip]

commit 963b84a51bf0b80da44ab775d788a911b676a6a9
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-08 23:37:04 +0900

    Separate steps

Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit 5e65e65bd935954190a5d481def788524c4ae169
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-08 23:00:46 +0900

    Set PATH at once

Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit d00349f99470cfddd522ee1e7fa9a5f6dc126771
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-08 23:09:39 +0900

    Fixed the checking out source

Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit 689e74485598d2c023fc2a00fac80b717b6f29b7
Author: Daisuke Fujimura (fd0) <booleanlabel@gmail.com>
Date:   2019-12-06 23:53:25 +0900

    Add .github/workflows/cygwin.yml

Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit 0d63a2104777e467568a31037a6573e1879870c7
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-08 18:29:39 +0900

    Skip completion tests for Editline

commit c38bc172bee99ff71440a1ebb4c38e6d092e0807
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-08 08:35:31 +0900

    Fix encoding of completed list

commit 2eb674377371d276b9de5ce06a591419f00f7c42
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-08 08:10:50 +0900

    * 2019-12-08 [ci skip]

commit c9b06d4a4e52b6ae705ebb16cafe455671780770
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-08 08:01:27 +0900

    Add test_simple_completion for Readline

commit be13b897ead62debd6d2e7696e5d28a8e8781620
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-07 22:02:24 +0900

    Show failed commits only when exists

commit 0ff84eda4e130ae17abccbb8aa92ad47e83d151d
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-07 20:28:23 +0900

    [ruby/irb] Version 1.2.0

    https://github.com/ruby/irb/commit/da6577a88c

commit 2e595c2d780814cc4d1357c687b44fd7208ff313
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-07 20:26:01 +0900

    [ruby/irb] New IRB needs Ruby 2.5 or later

    https://github.com/ruby/irb/commit/4be3158358

commit ad6837dd609654b02885199b25f7d79b1122b64a
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-07 20:21:08 +0900

    [ruby/irb] Revert "Reidline mode needs Reline what needs String#grapheme_clusters"

    This reverts commit 2b0b19b87c60d2cdb329979acbb96e12a1f940e7.

    New IRB parser needs new Ripper what has lex_state too. The new Ripper is
    adopted by Ruby 2.5 or later.

    https://github.com/ruby/irb/commit/9ab6e35a2c

commit c2afddccb36c10ac0eb530bfc3b38765882126d8
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-07 19:51:03 +0900

    [ruby/irb] Reidline mode needs Reline what needs String#grapheme_clusters

    https://github.com/ruby/irb/commit/2b0b19b87c

commit e72ffc55ba3cc9bf20c892d2d090a77f40c49ada
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-07 12:11:55 +0900

    [ruby/reline] Support Ruby 2.5 or later for String#grapheme_clusters

    https://github.com/ruby/reline/commit/33e8c8f15b

commit ebbc77836b74a74d7c07a9b91fff886219956e3c
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-07 13:15:47 +0900

    test/ruby/test_file_exhaustive.rb: shorten the name of temporary dir

    ```
      1) Error:
    TestFileExhaustive#test_socket_p:
    ArgumentError: too long unix socket path (109bytes given but 108bytes max)
        /export/home/users/chkbuild/cb-sunc/tmp/build/20191207T024036Z/ruby/test/ruby/test_file_exhaustive.rb:155:in `initialize'
    ```

commit dcf89b20d7b79b51e268ea3ffcfdc0829edf7643
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-07 01:28:20 +0900

    * 2019-12-07 [ci skip]

commit 544431e028e9d678f2989c35876a05c53f07e0ec
Author: Namrata Bhave <Namrata.Bhave@ibm.com>
Date:   2019-12-07 01:27:58 +0900

    Adding s390x support (#2727)

commit 2f6a8baac6a84935cef1f10adbba2f47df4a2346
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-06 15:56:14 +0900

    Test interfaces include localhost

    When interfaces do not include localhost,
    some other tests may fail.

commit 2c8d186c6e4fd03ea57466fa6dce6bad40d09401
Author: Aaron Patterson <tenderlove@ruby-lang.org>
Date:   2019-10-12 09:06:41 +0900

    Introduce an "Inline IVAR cache" struct

    This commit introduces an "inline ivar cache" struct.  The reason we
    need this is so compaction can differentiate from an ivar cache and a
    regular inline cache.  Regular inline caches contain references to
    `VALUE` and ivar caches just contain references to the ivar index.  With
    this new struct we can easily update references for inline caches (but
    not inline var caches as they just contain an int)

commit 38b7f947a2c76aad29a2e42f3bd0848854d96519
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-06 00:13:22 +0900

    * 2019-12-06 [ci skip]

commit 693cba1a136aafb0faa25f93434a2e8dbad320de
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-06 00:11:11 +0900

    Detect started threads when require only

commit 173b864668777ef157a0c82b6e6f1a6aa0f06ac9
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-05 23:56:14 +0900

    Do not start thread when `require 'drb/drb'` only

commit 6477d98e49dbe04deb03caee1a58a34c3b79d4e4
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-05 23:46:42 +0900

    test/lib/jit_support.rb: Update the regexp for icc

    MJIT_CC is always an absolute path.

commit d43b9eb22de1b1cd8de09a161cc836413cc158a1
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-05 22:37:08 +0900

    lib/drb/drb.rb: suppress warning: instance variable @pool_proxy not initialized

commit f4d9daf2b6f23af08296c7ccb770e1de1bc723bd
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-05 22:24:58 +0900

    coroutine/ucontext/Context.c: define __EXTENSIONS__ explicitly

    instead of ruby/config.h, per samuel's request.

    https://github.com/ruby/ruby/commit/dbfd4b780e3914a3f27e92c2248254452bf0fd6b#diff-7fd78c3cc8a19b7e0637502983ec26ff

commit c3abbc1b2f52015dc839fd96545380dbc11c77a9
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-05 16:18:22 +0900

    ext/openssl/extconf.rb: check with -Werror=deprecated-declarations

    This reverts commit 0d7d8b2989e1738dd902d354cc41186899e6b71e,
    but restore `$warnflags` without the flag, to get rid of using
    deprecated functions.

commit 4c88107c54b06c1a3e89970eb243c8ac887d84e1
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-05 18:14:31 +0900

    Fix `warning: already initialized constant DidYouMean::VERSION`

    ```
    .../gems/did_you_mean-1.3.1/lib/did_you_mean/version.rb:2: warning: already initialized constant DidYouMean::VERSION
    .../lib/did_you_mean/version.rb:2: warning: previous definition of VERSION was here
    ```

commit 75b644350a80bc31449b7cee741d309643dc27e1
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-05 17:57:05 +0900

    ext/psych/extconf.rb: braced VPATH is for nmake only

commit 0bca34ddaaf15caa852007f401707c1785aa8ed6
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-05 16:55:31 +0900

    test/io/console/test_io_console.rb: add a memo for the mysterious hack

commit 264d5aff5afecb08b0a2ccafedc0a43de4f8d16a
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-05 16:28:54 +0900

    Change encoding of completion list...for more tests

commit ee579200082329db66e153c465cb8332e55bacb2
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-05 15:01:37 +0900

    move an interrupt point.

    `args_ptr` can be corrupted by interrupt handlers.
    Pointed by nagachika <https://ruby-trunk-changes.hatenablog.com/entry/ruby_trunk_changes_20191204>.

commit b40bb27e3594bbc2e9c9ac00dfa5612ebae3151b
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-05 15:38:29 +0900

    test/io/console/test_io_console.rb: Try the hack for Solaris

    I'm not entirely sure why, but test_set_winsize_console gets stuck on
    Solaris (and if I recall, macOS).  I found a hack for FreeBSD, so I want
    to give it a try on Solaris too.

commit fa1db8f938c083ce1416f999fe8b3cf33f9f18f1
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-05 15:25:11 +0900

    Add missing dependency

    https://travis-ci.org/ruby/ruby/jobs/620972117

commit 72cff5f3af47ec8d694feef97516089e86d89673
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-05 15:18:42 +0900

    MJIT_CC and MJIT_SUPPORT are not a prefix

    0b19e15a1239bff9ae854f522f954206ec910cf8 was also for "MJIT_SUPPORT"
    too.

commit 5fbb4555b427909aed4fe2376c4c583849c1d51c
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-05 15:16:07 +0900

    Prefer using MJIT_CC for JIT support check

    because Solaris might have CC=cc and we'd like to check full path
    MJIT_CC=/opt/developerstudio12.5/bin/cc instead.

commit 199bd851e40438380b2e0f57662a212200e3ba1a
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-05 14:51:07 +0900

    parse.y: suppress "set but not used" warnings on ripper.y

commit edb80dfe3e6086fb9d5d905a40cdd6ec61a2e1ee
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-05 14:39:03 +0900

    add additional CF info for CI env

    Introduce new RUBY_DEBUG option 'ci' to inform Ruby interpreter
    that an interpreter is running on CI environment.

    With this option, `rb_bug()` shows more information includes
    method entry information, local variables information for each
    control frame.

commit c88afd532895a8527f7c9fffb2c635805d01f626
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-05 14:38:46 +0900

    fix parameter

commit 0d7d8b2989e1738dd902d354cc41186899e6b71e
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-05 14:41:38 +0900

    ext/openssl/extconf.rb: do not use -Werror=deprecated-declarations

    It fails to build on Solaris:

    ```
    ossl_cipher.c: 関数 ‘ossl_cipher_init’ 内:
    ossl_cipher.c:228:2: エラー: ‘EVP_md5’ is deprecated [-Werror=deprecated-declarations]
      228 |  EVP_BytesToKey(EVP_CIPHER_CTX_cipher(ctx), EVP_md5(), iv,
          |  ^~~~~~~~~~~~~~
    In file included from /usr/include/openssl/x509.h:73,
                     from /usr/include/openssl/x509v3.h:63,
                     from ossl.h:23,
                     from ossl_cipher.c:10:
    /usr/include/openssl/evp.h:732:26: 備考: ここで宣言されています
      732 | DEPRECATED const EVP_MD *EVP_md5(void);
          |                          ^~~~~~~
    ```

    I agree that `-Werror=` is a good habit, but adding it by default is too
    aggressive.

commit c0d118f41a3a66ab76a553f184efe431524b952d
Author: Jun Aruga <junaruga@users.noreply.github.com>
Date:   2019-12-05 14:17:16 +0900

    Fix "cannot find the function: strcpy()" error on arm32 on Travis CI. (#2686)

    This issue happened when `libc.so` and `libm.so` path were not found
    and `ldd ruby` command also failed to print the shared dependencies
    in `test/fiddle/helper.rb`.

    See https://travis-ci.org/ruby/ruby/jobs/611483288#L3018
    /home/travis/build/ruby/ruby/build/.ext/common/fiddle/import.rb:299:in `import_function': cannot find the function: strcpy() (Fiddle::DLError)

    * Set libc6:armhf as a installing dependency explicitly.
    * Remove arm32 from allow_failures.

commit ed5d032ea33a465fd7152a236a4aca0ff5653bf3
Author: Antonio Terceiro <asa@terceiro.xyz>
Date:   2019-11-26 09:25:53 +0900

    debug.rb: expand filenames in breakpoints

    When debugging some local code, specifying a breakpoint to a local
    filename does not work, i.e.

        break lib/foo.rb:10

    Expanding the filename makes it work. FWIW byebug has the same behavior.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2694

commit 20031f8b74a224bed88bfd149d59d6176c4f58e2
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-05 13:06:08 +0900

    Change encoding of completion list

commit df76f2c577b6567b617be2df9451123cc450d1cc
Author: Alan Wu <XrXr@users.noreply.github.com>
Date:   2019-12-05 11:02:21 +0900

    Make TracePoint.stat a singleton method again (#2726)

    [Bug #16399]

Notes:
    Merged-By: XrXr

commit e4db0443bcfc94f9183e8ea72fb4ab560aa005bf
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-07-23 11:56:02 +0900

    Make rb_eval_string_wrap specify a cref so constant setting works correctly

    Fixes [Bug #10466]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2722

commit 18d3b5a93a2d52412f8f563d58db682b41d5c98c
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-12-05 09:55:01 +0900

    Do not attempt to call methods on the receiver if it is a basic object

commit 88ee375dd6c93523bd5d8f9517e49215b9d8cf67
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-05 09:43:45 +0900

    Revert "Add debug option to check ci failures on solaris"

    This reverts commit f289e3994bbc6560e2e4e5905b52c35c829c972d.

commit fbf10ed5b3f37b7cd9950ac8d1f1c81255525d36
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-05 09:03:49 +0900

    * 2019-12-05 [ci skip]

commit e3587ed8498dcf7a3a8178030f7ae66cd0719c57
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-04 22:32:12 +0900

    Support disable-completion

commit ad8fbf444abdf1480d87c95b2868741f98eb953f
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-04 22:26:40 +0900

    Fix variable catch

commit fb11e6089dbe9d995510977def038a21882bcffe
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-04 21:52:29 +0900

    [DOC] Added File::FNM_SYSCASE example [Bug #16391] [ci skip]

commit dbfd4b780e3914a3f27e92c2248254452bf0fd6b
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-04 20:59:39 +0900

    coroutine/ucontext/Context.c: Include "ruby/config.h" for Solaris

    getcontext, makecontext, and swapcontext seem to be available only when
    `__EXTENSION__` is defined on Solaris.

commit a0bc0e1ba15e83c72426ac243ea96e6497c49859
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-04 18:43:19 +0900

    Fix thread leak in drb

Notes:
    Merged: https://github.com/ruby/ruby/pull/2724

commit 00bbdf4451d0e66f0f7823e77c47ac310614c1c3
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-12-04 15:31:51 +0900

    implement Range#count

    As matz requested in [Bug #16366].

commit c6e3db0c66312af1e932c21006437419efa9ac75
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-04 13:36:41 +0900

    new_cond before mon_initialize

    MonitorMixin#new_cond can be called before mon_initialize, so we
    need to initialize `@monitor` before it.

    https://bugs.ruby-lang.org/issues/16255#note-4

commit f9e5c74cd24025a5aa19e318e8fecabf207f1b7b
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-04 10:33:35 +0900

    compile.c: stop wrong peephole optimization when covearge is enabled

    jump-jump optimization ignores the event flags of the jump instruction
    being skipped, which leads to overlook of line events.

    This changeset stops the wrong optimization when coverage measurement is
    neabled and when the jump instruction has any event flag.

    Note that this issue is not only for coverage but also for TracePoint,
    and this change does not fix TracePoint.
    However, fixing it fundamentally is tough (which requires revamp of
    the compiler).  This issue is critical in terms of coverage measurement,
    but minor for TracePoint (ko1 said), so we here choose a stopgap
    measurement.

    [Bug #15980] [Bug #16397]

    Note for backporters: this changeset can be viewed by `git diff -w`.

commit 5a404efd29d255402e30f4f23a09d4e5398600b8
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-04 10:06:54 +0900

    [ruby/io-console] Fixed `intr: false` mode on Windows

    https://github.com/ruby/io-console/commit/4c172c01aa

commit 447d583536274a2489efc8792653ad35d6f7128a
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-28 03:48:50 +0900

    Silence incorrect assigned but unused variable warnings in ripper

    To only emit the warnings in correct cases would require tracking
    local variable usage in ripper, which ripper currently does not do.

    Fixes [Bug #15188]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2719

commit a91637c516779d9ecee5f323e211f0ed71eb06ad
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-03 07:20:10 +0900

    Make {Method,UnboundMethod}#super_method handle clone/bind/unbind

    This wasn't working previously because the iclass entry wasn't
    being copied, and without an iclass entry, super_method returns
    nil.

    Fixes [Bug #15629]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2723

commit f9754f0ea08e0d4fb28681a86cbc6ec2d884dba5
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-04 08:22:48 +0900

    compile.c: trivial refactoring

    Use `for` instead of `while` to make it explicit that it is a traverse
    of bytecode.

commit 8852fa876039ed177fd5e867f36177d8a9ff411c
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-04 01:26:29 +0900

    Revert "Regexp#match{?} with nil raises TypeError as String, Symbol (#1506)"

    This reverts commit 2a22a6b2d8465934e75520a7fdcf522d50890caf.
    Revert [Feature #13083]

commit 08074eb71229b4c9f669f7bfb215bbb43525bfc0
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-04 01:26:28 +0900

    Revert "Revert nil error and adding deprecation message"

    This reverts commit 452bee3ee8d68059fabd9b1c7a75661b14e3933e.

commit a705f6472c3e34422776d886bbc9f98676d8c0eb
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-04 01:26:27 +0900

    Revert "Improve warning message"

    This reverts commit 31110d820cc1258cbc84b46ecc65b254c7d5529a.

commit 34a66b1f36e9a065cf8433598b3fce03ce2c711e
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-12-04 01:26:24 +0900

    Revert "Fix warnings in Regexp#{match,match?} specs"

    This reverts commit 782d1b8fb0a039cedef9ad9c94f432dad51901e6.

commit a029b54ec716812ade37fef1f857c49f821a8cc8
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-29 08:41:39 +0900

    Make Enumerator::Chain#each treat lambdas as lambda

    Previously, lambdas were converted to procs because of how
    rb_block_call works.  Switch to rb_funcall_with_block, which
    handles procs as procs and lambdas as lambdas.

    Fixes [Bug #15613]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2720

commit 47c97e1e843159c3c4d57f8c5e22daea57c3ffe1
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-12 12:53:37 +0900

    Do not lose existing constant visibility when autoloading

    This copies the private/deprecate constant visibility across the
    autoload.  It still is backwards compatible with setting the
    private/deprecate constant visibility in the autoloaded file.
    However, if you explicitly set public constant in the autoloaded
    file, that will be reset after the autoload.

    Fixes [Bug #11055]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2716

commit b96d559c696c5141bdb6717442818f1206ff9d2e
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-04 00:27:58 +0900

    * 2019-12-04 [ci skip]

commit 5c2c3966851ed074eb468ad36d8d75e53b8eab6c
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-26 04:09:19 +0900

    Check interrupts before starting thread

    Fixes a hang when Thread.new calls Thread.new in a loop.

    Fixes [Bug #13688]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2715

commit 7f2cd2ae6fea76ff3a2b95b69e6e2f749e8a249f
Author: KOSAKI Motohiro <kosaki.motohiro@gmail.com>
Date:   2019-12-03 19:50:16 +0900

    fix typo

commit a1f98cd4c1d55efe4998ecd3d94508634baefc23
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-03 17:56:50 +0900

    vm_args.c: make the keyword deprecation message helpful

    ```
    $ ./miniruby -e 'def foo(kw: 1); end; h = {kw: 1}; foo(h)'
    -e:1: warning: The last argument is used as the keyword parameter
    -e:1: warning: for `foo' defined here; maybe ** should be added to the call?
    ```

commit 409e4ab740de3852c3667217bcf41b55040f638f
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-03 17:05:07 +0900

    tool/lib/test/unit/parallel.rb: fail explicitly when failing to get io

    `(ulimit -n 30; make test-tool)` fails with unexplicit message:
    "undefined method `write' for nil:NilClass" due to lack of stdout.

    This change makes it explicit.  [Bug #5577]

commit e42d9d8df87f58b9bfa65647249822df25851375
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-03 14:51:14 +0900

    Fixed the inverted condition

commit 9165fcdfa309052a2adc3c6100ab24204de6c2d1
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-03 14:46:49 +0900

    Wrap statements in AS_IF properly

commit 027e847cd2540553c9ddcf1b39028c43258a3fb4
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-03 13:02:01 +0900

    Fix auto-indent behavior correctly

commit 14a17063a11a01d518b4bbaf0eb967330aec3984
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-03 08:12:57 +0900

    Fixed stack overflow [Bug #16382]

    Get rid of infinite recursion in expanding a load path to the real
    path while loading a transcoder.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2714

commit 8bddf1bc9bdd1db7ce2e3fec15f2f06ff355b0a7
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-12-03 08:02:38 +0900

    mjit.c: fix a mismatch of malloc'ed type

    Coverity Scan found this issue.

commit 424ad9a49360be56244609c02678e8f055d92073
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-03 05:23:10 +0900

    Make more attempts to check for the precision of Process.times

    * Process.clock_getres specs use 10_000 but that's quite slow for
      the Process.times spec.

commit c688487fae22e0f73b4e2a9ea5749cb224c25e48
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-03 01:41:22 +0900

    * 2019-12-03 [ci skip]

commit a92560132b1bff6a01782cfeacd62756b4b34d21
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-03 01:17:07 +0900

    Support incremental search by last determined word

    In the incremental search by C-r, search word is saved when it's determined. In
    the next incremental search by C-r, if a user presses C-r again with the empty
    search word, the determined previous search word is used to search.

commit bce38f706e9c434d8fd7c0e2e14bb4acdd085777
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-02 09:15:07 +0900

    The C-r in vi command mode is also incremental search

commit a47d6c256ff684392f00516a917735a14aec64b0
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-02 17:12:29 +0900

    Fix random failure on getusage-missing environments

    `* 1e6` makes a spurious result about floating point number's precision.

    ```
    irb(main)[01:0]> 16.028
    => 16.028
    irb(main)[02:0]> (16.028 * 1e6)
    => 16027999.999999998
    ```

commit 1a88adcd75d92cb36ef5b1d5f4aeb40e6fe4dcb7
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-12-02 15:21:15 +0900

    Fix Leaked file descriptor in test/did_you_mean

    https://github.com/ruby/ruby/commit/de74d2c3b0005048a2c4433bde68b9be10c86f01/checks?check_suite_id=336910877#step:19:131
    ```
    Leaked file descriptor: NameErrorExtensionTest#test_correctable_error_objects_are_dumpable: 7 : #<File:test_name_error_extension.rb>
    ```

Notes:
    Merged: https://github.com/ruby/ruby/pull/2712

commit 185f7608737a550a0891a7fc5a6a4ee32721bce3
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-02 16:23:40 +0900

    Debug random failure of ruby-spec on ci.rvm.jp

commit 9afaf139f232e8b2c697d33e984945464744def1
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-02 14:15:42 +0900

    Revert "builtin_binary.inc needs miniruby itself for RubyVM.each_builtin"

    This reverts commit 2615030c521afc822c66a7e139ccba3d2365ab56,
    which doesn't work when cross compiling, except for mingw.

commit 2615030c521afc822c66a7e139ccba3d2365ab56
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-02 14:03:46 +0900

    builtin_binary.inc needs miniruby itself for RubyVM.each_builtin

commit a7b9f085ff952fcb18f82de39b3bf9ab7e5ba3e7
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-02 13:20:00 +0900

    Disable _FORTIFY_SOURCE on mingw for now

    It causes a link error due to some `__*_chk` functions on mingw.

commit b1c92363a74b0e649a685ae47ae400fbaab7b29d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-02 13:16:55 +0900

    Wait for the main thread to start reading by Queue

    Otherwise, the written data to pty before the reading started may
    be just lost.

commit de74d2c3b0005048a2c4433bde68b9be10c86f01
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-02 10:32:50 +0900

    Simplify variable declaration by C99

commit 103b04128f4e40b87bb9c7fb2916d2a800bfd94f
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-02 04:17:47 +0900

    Support incremental search again by C-r in incremental search

commit b3ea0980db87404c2b7763a3fdbe898c3812843d
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-02 03:53:58 +0900

    Check MJIT support in one place

    to fix test failure on trunk-no-mjit
    https://gist.github.com/ko1/32ab982ffd7555988818773c08f97123

commit 6bc8b4d8ea6cb8865225c0afcf1abd9e4b725376
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-02 03:51:04 +0900

    Skip --jit-debug= test on mswin

    it fails like
    https://ci.appveyor.com/project/ruby/ruby/builds/29235837/job/v0apdjj4qx8afars

commit c7f05310a248e44ef9747a159a0e9bc289bb7090
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-02 03:30:38 +0900

    Process Backspace key in incremental search correctly

commit e15b0313a78a6f381720cf362a1a94bda49f62ff
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-02 03:05:10 +0900

    Search history to back in the middle of histories

commit 4d7a6d04b2c71aabb9d6e619f4405887806a5be8
Author: KOSAKI Motohiro <kosaki.motohiro@gmail.com>
Date:   2019-12-02 01:21:05 +0900

    Avoid unnecessary tzset() call

    Akatsuki reported ENV['TZ'] = 'UTC' improved 7x-8x faster on following code.
    t = Time.now; 100000.times { Time.new(2019) }; Time.now - t
    https://hackerslab.aktsk.jp/2019/12/01/141551

    commit 4bc1669127(reduce tzset) dramatically improved this situation. But still,
    TZ=UTC is faster than default.

    This patch removs unnecessary tzset() call completely.

    Performance check
      ----------------------
    test program: t = Time.now; 100000.times { Time.new(2019) }; Time.now - t
    before:         0.387sec
    before(w/ TZ):  0.197sec
    after:          0.162sec
    after(w/ TZ):   0.165sec

    OK. Now, Time creation 2x faster *and* TZ=UTC doesn't improve anything.
    We can forget this hack completely. :)

    Side note:
    This patch slightly changes Time.new(t) behavior implicitly. Before this patch, it might changes
    default timezone implicitly. But after this patch, it doesn't. You need to reset TZ
    (I mean ENV['TZ'] = nil) explicitly.
    But I don't think this is big impact. Don't try to change /etc/localtime on runtime.

    Side note2: following test might be useful for testing "ENV['TZ'] = nil".
      -----------------------------------------
    % cat <<'End' | sudo sh -s
    rm -f /etc/localtime-; cp -a /etc/localtime /etc/localtime-
    rm /etc/localtime; ln -s /usr/share/zoneinfo/Asia/Tokyo /etc/localtime
    ./ruby -e '
    p Time.new(2000).zone # JST
    File.unlink("/etc/localtime"); File.symlink("/usr/share/zoneinfo/America/Los_Angeles", "/etc/localtime")
    p Time.new(2000).zone # JST (ruby does not follow /etc/localtime modification automatically)
    ENV["TZ"] = nil
    p Time.new(2000).zone # PST (ruby detect /etc/localtime modification)
    '
    rm /etc/localtime; cp -a /etc/localtime- /etc/localtime; rm /etc/localtime-
    End

commit 43811cc3b36739816788cbbac7a49b9bbf756293
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-02 00:05:20 +0900

    * 2019-12-02 [ci skip]

commit 7f0d51704a5cb789c16a6c05db455469f0b2601d
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-02 00:03:59 +0900

    Remove obsolete code

commit 8cb3f29abf9290838bdc3b9904868c78752427e8
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-01 23:53:59 +0900

    The ed_search_prev_history should always search to backward

commit f1cfc7da180a8cf26f758fbe553e6653e4a4dc53
Author: aycabta <aycabta@gmail.com>
Date:   2019-12-01 22:11:59 +0900

    Reline::HISTORY can take Range object

commit 617a3735aedc12fe82b6806d6d3a37c3f977fef1
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-01 22:11:42 +0900

    Update to ruby/spec@dcf4955

commit 60d362b0bb0fb56bd3ef61c93f71bff997ccb824
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-01 22:11:40 +0900

    Update to ruby/mspec@aa28e95

commit ab516e263c06fbd755d4805ad529c32b1b8292b5
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-01 21:14:58 +0900

    [ruby/spec] Fix failures with LC_ALL=C

    https://github.com/ruby/spec/commit/51047687c0
    https://github.com/ruby/spec/commit/2b87b467cc

commit 4e03a7298b3a99de9c57f9a4934d38445cad1b10
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-01 20:26:28 +0900

    Constified mjit_init

commit cb760f36aae42a63738394f170444b6ae4405b82
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-01 19:29:04 +0900

    Constified

commit 91af5542b503054ea059b6c4faa5cd821784774a
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-01 19:00:08 +0900

    Fix a mistake excluding NULL in the end

commit 8a677a6e80b3b7e1f52073b362083a78eb87397f
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-01 18:35:30 +0900

    Workaround missing strndup on Windows

    https://ci.appveyor.com/project/ruby/ruby/builds/29230976/job/c910t37313edb97k

commit 3e2753ad2e0b643f5c731fb162f5805d82435032
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-01 18:25:54 +0900

    Use build dir for testing --jit-debug

    to fix failure like https://github.com/ruby/ruby/runs/327745536

commit a19d625e667024fe27dcee04dd748e914bc24762
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-01 17:56:27 +0900

    Allow specifying arbitrary MJIT flags by --jit-debug

    This is a secret feature for me. It's only for testing and any behavior
    with this flag override is unsupported.

    I needed this because I sometimes want to add debug options but do not
    want to disable optimizations, for using Linux perf.

commit bdc62dfc8ecffd27dd5ad6756cce88eac5c993f5
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-12-01 14:38:33 +0900

    Fixed type of an index variable

commit 9914d6e992a69587e6d43ba7eaa6cdda9f178f8e
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-12-01 13:26:09 +0900

    Relax test strictness for error message from KeyError

commit cc7455dd1e98e297dbea2fd92e491bd36f1b473e
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-12-01 12:29:02 +0900

    Relax test requirements for DYM's verbose formatter

commit 56faa13a1c5261a0d046a4c0203e88fccfafae17
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-12-01 12:24:50 +0900

    remove spaces to pass a test.

    23d7f4c5e1ce164e78d77de694dccc0c41f6de3d breaks a test which expect
    to match error message. To avoid this failure, use #strip for expect
    and actual results.

commit 23d7f4c5e1ce164e78d77de694dccc0c41f6de3d
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-01 11:08:39 +0900

    * remove trailing spaces. [ci skip]

commit 0fef526606c72e7d2a3c83aebd9204da34016d96
Author: Yuki Nishijima <yk.nishijima@gmail.com>
Date:   2019-11-30 11:40:07 +0900

    Do not call 'gem "did_you_mean"' for now

    This will slow down the time that the +require+ method takes to load DYM,
    but this has caused a build failure in a certain situation:

      https://ci.appveyor.com/project/ruby/ruby/builds/29214253/job/r9u9c8p95tnlftt3#L24965

    which is reported as a separate bug:

      https://bugs.ruby-lang.org/issues/16382?next_issue_id=16381

    For now this commit should fix the builds, but we should come back and
    add back the 'gem' call.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2689

commit 171803d5d34feb1b4244ca81b9db0a7bc2171c85
Author: Kevin Deisz <kevin.deisz@gmail.com>
Date:   2019-10-29 23:08:37 +0900

    Promote did_you_mean to default gem

    At the moment, there are some problems with regard to bundler + did_you_mean because of did_you_mean being a bundled gem. Since the vendored version of thor inside bundler and ruby itself explicitly requires did_you_mean, it can become difficult to load it when using Bundler.setup. See this issue: https://github.com/yuki24/did_you_mean/issues/117#issuecomment-482733159 for more details.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2689

commit a2fc6a51dd2e1a153559038795e1e2509f9c6a94
Author: David Rodríguez <deivid.rodriguez@riseup.net>
Date:   2019-11-30 22:03:12 +0900

    [ruby/fileutils] Fix test failure under ruby 2.4

    `Exception#full_message` is only defined on ruby 2.5.0 and above.

    https://github.com/ruby/fileutils/commit/a8968f41ed

commit fa0f3eff228bb26de6d5b0e1238b1f358165dbd0
Author: David Rodríguez <deivid.rodriguez@riseup.net>
Date:   2019-11-30 22:01:18 +0900

    [ruby/fileutils] Fix error printing test failure

    `exception_details` is not defined anywhere.

    This commit fixes the following test crash in ruby 2.4

    ```
    Error: test_assert_output_lines(TestFileUtils): NoMethodError: undefined method `exception_details' for #<TestFileUtils:0x00005556ef699178>
    ```

    And replaces it with an actual test failure:

    ```
    [Test::Unit::CoreAssertions::MiniTest::Assertion] exception expected, not #<NoMethodError: undefined method `full_message' for #<RuntimeError: ok>
    Did you mean?  message>.
    ```

    https://github.com/ruby/fileutils/commit/2f38ba6e82

commit 5b1f7f26b4ff3b05e1c184ae87154a323b1be915
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-12-01 06:29:00 +0900

    Skip if getrusage is not supported

    1243255c3a36433041012b6107a5ac48658a0895 broke ci.rvm.jp tests like
    http://ci.rvm.jp/results/trunk_clang_39@silicon-docker/2445098.

    253232c028a5565dbeecc05fab5e81b35ab58bcc works only if getrusage is supported.

commit 1243255c3a36433041012b6107a5ac48658a0895
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-01 05:26:52 +0900

    Update to ruby/spec@4eec3dc

commit ab8345271eb87ff155d8bd5f22f53a4cf2902c26
Author: Benoit Daloze <eregontp@gmail.com>
Date:   2019-12-01 05:26:49 +0900

    Update to ruby/mspec@a401f63

commit 93a512414cbe3713f478038f6d4f5fe81c4eb62a
Author: git <svn-admin@ruby-lang.org>
Date:   2019-12-01 02:18:45 +0900

    * 2019-12-01 [ci skip]

commit 5e0479f26afe1505afd9014ea96a206a88845828
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-10-01 12:23:25 +0900

    ENV.update should not call block on existing keys

    [Bug #16192]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2512

commit b94d06096b8f2a375719ce09370e004fcb277b25
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 18:20:02 +0900

    [ruby/zlib] Bump version to 1.1.0

    https://github.com/ruby/zlib/commit/5af77c1ee8

commit 7ebcee6b7634889f0bd92aaedf079845065ac797
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 18:13:16 +0900

    [ruby/gdbm] Bump version to 2.1.0

    https://github.com/ruby/gdbm/commit/ffb2b063a3

commit 56567c76487d42f12283ecf074d45adae96ca5f0
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 18:03:57 +0900

    [ruby/etc] Bump version to 1.1.0

    https://github.com/ruby/etc/commit/78987ce56a

commit 08c866d5281777e1f8f8503f7ebdec9aee62ed63
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 18:05:51 +0900

    [ruby/fileutils] Bump version to 1.4.1

    https://github.com/ruby/fileutils/commit/da15e3ce06

commit 06b9b78e21f5da5f348a932c3e7f21468674e4f1
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 17:54:44 +0900

    [ruby/dbm] Bump version to 1.1.0

    https://github.com/ruby/dbm/commit/163078359d

commit 32e547954fbbcbdd6f4468bf3be9e7eaa5d32f0f
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 17:58:39 +0900

    Revert "[ruby/fileutils] Fix #install with "X" mode option"

      This reverts commit eab88d20eaa925d5e61a2a65820a099b46ccf3f8.

      The some CI was broken with this.

commit 5e9f08647cead8b7fa303a5da88c5e96035f3497
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-08-28 21:58:25 +0900

    [ruby/webrick] Check the feature by itself, instead of the version number

    https://github.com/ruby/webrick/commit/79d7922de9

commit a98632d5c20e41e05074384b8f760af407e6d52a
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-12 04:57:11 +0900

    [ruby/webrick] Enabled chunked encoding if Transfer-Encoding: chunked header is set

    Patch from Leonard Garvey.

    Fixes Ruby Bug 9986.

    https://github.com/ruby/webrick/commit/8cff7f3995

commit edfbffb241a894eece57155a22a89637b33cfe58
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 17:39:58 +0900

    [ruby/webrick] Bump version to 1.6.0

    https://github.com/ruby/webrick/commit/c5635fa5e2

commit c75100d00401c32b3245ce8da5b8a045976216ca
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-08-27 13:41:27 +0900

    [ruby/webrick] Allow WEBrick::HTTPServlet::CGIHandler :CGIInterpreter option to be array

    This way you don't need to escape each entry.

    Implements Ruby Feature 15170.

    https://github.com/ruby/webrick/commit/d8086e600c

commit f7cf5416e471cd34153058952063da3457468e58
Author: zverok <zverok.offline@gmail.com>
Date:   2019-10-26 19:27:17 +0900

    [ruby/webrick] Document HTTPResponse#body callable option

    https://github.com/ruby/webrick/commit/d51836d03d

commit ea4272d02b02719e266c7cf30141e6275e38f9a7
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 17:23:13 +0900

    [ruby/fileutils] Bump version to 1.4.0

    https://github.com/ruby/fileutils/commit/f92145b10b

commit 3b9e1c0b2e5b3c507c94fd36c87288e789ee9c2a
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 17:32:38 +0900

    Move gemspec of fileutils under the toplevel of lib directory.

commit eab88d20eaa925d5e61a2a65820a099b46ccf3f8
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-10-03 01:39:02 +0900

    [ruby/fileutils] Fix #install with "X" mode option

    `FileUtils#install` methed raises an unexpected `TypeError`, when
    called with `mode:` option which has `"X"`.

    ```
    $ ruby -rfileutils -e 'FileUtils.install("tmp/a", "tmp/b", mode: "o+X")'
    /opt/local/lib/ruby/2.7.0/fileutils.rb:942:in `directory?': no implicit conversion of File::Stat into String (TypeError)
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:942:in `block (3 levels) in symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `each_char'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `each'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `inject'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `block (2 levels) in symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:931:in `each'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:931:in `each_slice'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:931:in `block in symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:926:in `each'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:926:in `inject'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:926:in `symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:973:in `fu_mode'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:883:in `block in install'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:1588:in `block in fu_each_src_dest'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:1604:in `fu_each_src_dest0'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:1586:in `fu_each_src_dest'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:877:in `install'
            from -e:1:in `<main>'
    ```

    In spite of that `symbolic_modes_to_i` considers the `File::Stat`
    `path` case at the beginning, in `"X"` case, `path` is passed to
    `FileTest.directory?` method which requires a `String`.  In such
    case, the mode in `path` should be examined instead.

    https://github.com/ruby/fileutils/commit/2ea54ade2f

commit aab74fc938453233a5f11a093ad6129a0be230d1
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-10-03 01:17:26 +0900

    [ruby/fileutils] Added `test_install_mode_option`

    https://github.com/ruby/fileutils/commit/bb10efe104

commit 0a7d26bea1b2d7ab4c36e471d387d1a9907a486d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-10-03 00:55:19 +0900

    [ruby/fileutils] Remove version.rb

    Loading separate version.rb unnecessary increases every start-up
    time.  In the other hand, the gemspec file is parsed only when
    building the gem file.

    https://github.com/ruby/fileutils/commit/8359cf7cce

commit c064018a7584fe03403a3b175ac25dbbb1162c8c
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-19 15:13:35 +0900

    Make extract-gems only if test_task is check

Notes:
    Merged: https://github.com/ruby/ruby/pull/2678

commit bb3542cc6b3db5477c2a9efd76905a4133545da1
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 21:28:53 +0900

    Add update-gems before extract-gems

    (windows.yml used `nmake up`)

Notes:
    Merged: https://github.com/ruby/ruby/pull/2678

commit 2eb4afb10bd9a3849eb34292f33240ac3ef19905
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 19:45:14 +0900

    Add extract-gems to GitHub Actions CI

Notes:
    Merged: https://github.com/ruby/ruby/pull/2678

commit cf14592872684956df7c014de0f9808c8aaf0e22
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 16:01:23 +0900

    [ruby/readline-ext] Prepare to gem release

    https://github.com/ruby/readline-ext/commit/e5b969215a

commit 856f9990a90e601ec5245a934d1da153591fcf3b
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 15:50:57 +0900

    [ruby/forwardable] Bump version to 1.3.0

    https://github.com/ruby/forwardable/commit/e56f0f83c6

commit 9fa0166a580e72adf02562b7d60672c6c362d4b7
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-09-08 04:41:16 +0900

    [ruby/forwardable] Fix keyword argument separation warnings on Ruby 2.7+

    Do so in a way that is also compatible with previous versions.

    https://github.com/ruby/forwardable/commit/b2dd340988

commit af4b3f16ceed36f8b18856120940c9de6e6a0eee
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 15:26:01 +0900

    [ruby/stringio] Bump version to 0.1.0

    https://github.com/ruby/stringio/commit/4c1e267e1a

commit 990025cf60eb6586c13f5f055880ac60afbac646
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 15:16:13 +0900

    [ruby/stringio] RbConfig::LIMITS only provide after Ruby 2.5

    https://github.com/ruby/stringio/commit/1fed3aacd3

commit e764dff3641fd66fda1b9cf33cb7ddeb30e0b38a
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 14:31:00 +0900

    [ruby/date] Bump version to 3.0.0

    https://github.com/ruby/date/commit/202b2dad93

commit 80705e2c4fe7c1e968830880ea4408990e3f3c39
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-30 14:48:26 +0900

    Add to support the single commit for sync_default_gems.rb

commit f8cc05dec37f78b15814d0b936786d4e84d7d448
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-30 11:14:35 +0900

    Use @eof variable for ReidlineInputMethod#eof?

    "IRB::InputMethod#eof?" requires eof status each user input but
    "ReidlineInputMethod#eof?" used "Reline.eof?" what is singleton data.
    "ReidlineInputMethod#eof?" is changed to use the result of user input.

commit 0b1b2f2442744f0add4dec47e475e25cde602dcf
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 21:31:55 +0900

    Remove e2mmap from sync_default_gems.rb

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit c50d30f659ff22981444b3e4684fe9e6f2809055
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 17:48:43 +0900

    Simplified ErrDimensionMismatch class

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit 2f66c443d79bb3a2d5518dbe58ca86885bc23d5c
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 17:46:13 +0900

    Support argument for ErrNotRegular

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit 0c59bfae0a3a9f5a3420a1eac42753480d8d95f7
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 17:29:21 +0900

    Also replace E2MM to standard exception class

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit 0950ef9a9a8e14dce44c36cf1ecaad187716a059
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 17:15:56 +0900

    Remove e2mmap entries from docs

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit c1059e99d3f74fdd5d9a9792544a9ebc8a10edf7
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 17:11:11 +0900

    Support existence usecase for the custom exception classes

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit 5044260dcd1d1b51f2e217ca519431ab5a1cf8c2
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 16:50:54 +0900

    replace raise method from e2mmap on Scalar class

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit 9b950310be874753935a6ef4e8f94b3686f70540
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-29 16:35:51 +0900

    raise method accepts 3 argument with exception class

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit f47f2076fed1546d993a376ce3c35ca81b1f0c6a
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-27 12:17:03 +0900

    Retire to maintain e2mmap on ruby core

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit 04511b994e19de65fff84dd55a246842a2f9ad29
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-27 12:11:34 +0900

    Remove re-define embedded error classes and extract argument on custom error classes

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit d82c541ae439b3c28ec71e9d6b839c2f304df273
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-27 11:48:04 +0900

    Use simple exception classes instead of e2mmap

Notes:
    Merged: https://github.com/ruby/ruby/pull/2699

commit 0c273b2279e65c57161e0859f2d4e9f6e649b751
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-29 10:28:13 +0900

    Suppress class variable overtaken warning when original modules are the same

    This issue was exposed by recent commits to better support including
    refined modules.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2709

commit 8a1f313e2e6ecf43a1ccad6cca35f738c6052b3c
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-30 00:21:48 +0900

    * 2019-11-30 [ci skip]

commit d1ef4fd08e60adcbcb4feeb55f767ff3d80b65a0
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-30 00:15:29 +0900

    Make single line pattern matching void expression

    Instead of returning `nil`, raise a syntax error if its value is
    used.  [Feature #16355]

commit 36da0b3da1aed77e0dffb3f54038f01ff574972b
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-29 17:39:06 +0900

    check interrupts at each frame pop timing.

    Asynchronous events such as signal trap, finalization timing,
    thread switching and so on are managed by "interrupt_flag".
    Ruby's threads check this flag periodically and if a thread
    does not check this flag, above events doesn't happen.

    This checking is CHECK_INTS() (related) macro and it is placed
    at some places (laeve instruction and so on). However, at the end
    of C methods, C blocks (IMEMO_IFUNC) etc there are no checking
    and it can introduce uninterruptible thread.

    To modify this situation, we decide to place CHECK_INTS() at
    vm_pop_frame(). It increases interrupt checking points.
    [Bug #16366]

    This patch can introduce unexpected events...

commit c4686b92359d298f281f3943ba205858e183e7af
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-29 17:36:54 +0900

    Revert "Treat :@1, :@@1, @1, and @@1 correctly to check termination"

    This reverts commit 5e275dd2af4d9d24cdb1cfc0f232f348dae9c2cd.

    ...The @1 type numberd parameter is reverted from Ruby syntax.

commit bbbe481dc36b2bbd33f2d1062e149d5db7602bc1
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-29 17:32:52 +0900

    Add SECURITY.md [ci skip]

    for https://github.com/ruby/ruby/security/policy

commit 191ce5344ec42c91571f8f47c85be9138262b1c7
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-09-13 17:02:08 +0900

    Reduce duplicated warnings for the change of Ruby 3 keyword arguments

    By this change, the following code prints only one warning.

    ```
    def foo(**opt); end
    100.times { foo({kw:1}) }
    ```

    A global variable `st_table *caller_to_callees` is a map from caller to
    a set of callee methods.  It remembers that a warning is already printed
    for each pair of caller and callee.

    [Feature #16289]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2458

commit 3a87826d0c3dd4c42e327e0cd4fb0806d898497f
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-29 16:51:13 +0900

    vm_method.c: add top-level ruby2_keywords

    This is a top-level version of Module#ruby2_keywords.
    It can be used for functions (top-level methods) that delegates
    arguments.  [Feature #16364]

commit 5ad32d5504499f1a915d5d30e59dfd98da6759c6
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-29 11:25:23 +0900

    `LoadError` is not a subclass of `StandardError`

commit f83bebdf7a76e1ade3c5dc9d54cbffb9f761b453
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-29 11:19:09 +0900

    Skip useless test

    `JSONGeneratorTest#test_remove_const_seg` is meaningful only for
    the extension library version, but nonsense for pure ruby version.

commit ba1cb388a9b29856ff1e1127a10c2ac727dabfc4
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-29 11:17:27 +0900

    Fixed the position in NEWS [Feature #16348]

    [ci skip]

commit a593186a02714cb92ae2748c2b7c46a6c50b0977
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-29 11:09:08 +0900

    Nmake needs `VPATH`

commit 98006cea4fd517671dae508fade13203bc18301a
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-29 10:16:33 +0900

    Add dependency on bundled yaml.h when using

commit 6b460a79489bf65dee0a4c9f42324d3836888dd3
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-29 03:24:30 +0900

    export func for MJIT

commit f38b6d197f84ba8890daf4d708c0d17c1d339700
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-29 03:22:24 +0900

    Revert "export for MJIT"

    This reverts commit 2e6f1cf8b264f4c8499c4e5f18bf662fdade04ff.

commit e4e41840ad378ccd3144fe84ffd3aa55f6610ca5
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-29 03:22:13 +0900

    Revert "* remove trailing spaces. [ci skip]"

    This reverts commit 27d0d7c0d39076d4bbacd3c3f3864322699db7b4.

commit 27d0d7c0d39076d4bbacd3c3f3864322699db7b4
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-29 03:18:19 +0900

    * remove trailing spaces. [ci skip]

commit 2e6f1cf8b264f4c8499c4e5f18bf662fdade04ff
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-29 03:17:34 +0900

    export for MJIT

commit e5705c351c82f43bfa0c45903c72a69f307cce60
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-29 03:11:40 +0900

    * 2019-11-29 [ci skip]

commit d104ebf2c4fef4751e067ea7a2c7e664a843e088
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-29 03:11:28 +0900

    * remove trailing spaces. [ci skip]

commit dd723771c118da71aa58bb74537cacaec425542a
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-29 03:02:44 +0900

    fastpath for ivar read of FL_EXIVAR objects.

    vm_getivar() provides fastpath for T_OBJECT by caching an index
    of ivar. This patch also provides fastpath for FL_EXIVAR objects.
    FL_EXIVAR objects have an each ivar array and index can be cached
    as T_OBJECT. To access this ivar array, generic_iv_tbl is exposed
    by rb_ivar_generic_ivtbl() (declared in variable.h which is newly
    introduced).

    Benchmark script:

    Benchmark.driver(repeat_count: 3){|x|
      x.executable name: 'clean', command: %w'../clean/miniruby'
      x.executable name: 'trunk', command: %w'./miniruby'

      objs = [Object.new, 'str', {a: 1, b: 2}, [1, 2]]

      objs.each.with_index{|obj, i|
        rep = obj.inspect
        rep = 'Object.new' if /\#/ =~ rep
        x.prelude str = %Q{
          v#{i} = #{rep}
          def v#{i}.foo
            @iv # ivar access method (attr_reader)
          end
          v#{i}.instance_variable_set(:@iv, :iv)
        }
        puts str
        x.report %Q{
          v#{i}.foo
        }
      }
    }

    Result:

          v0.foo # T_OBJECT

                   clean:  85387141.8 i/s
                   trunk:  85249373.6 i/s - 1.00x  slower

          v1.foo # T_STRING

                   trunk:  57894407.5 i/s
                   clean:  39957178.6 i/s - 1.45x  slower

          v2.foo # T_HASH

                   trunk:  56629413.2 i/s
                   clean:  39227088.9 i/s - 1.44x  slower

          v3.foo # T_ARRAY

                   trunk:  55797530.2 i/s
                   clean:  38263572.9 i/s - 1.46x  slower

commit b5fbefbf2c14742f6d46ecdf3ce712062dfb1d0a
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-11-17 23:24:59 +0900

    Added Symbol#start_with? and Symbol#end_with? method. [Feature #16348]

commit 76871dea6b05ee441f25c6f694ac21525ed25f93
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-11-28 23:31:01 +0900

    Use more template feature of w.r-l.o

commit 0b453e2a55eefbe1bbb0b76faf61b9b6ab121d48
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-28 21:45:43 +0900

    Get rid of inadvertent label [ci skip]

commit 2fa3b4565ad904b09419dc77f4fff03aee1a8358
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-28 21:31:53 +0900

    Merged common statements [Bug #16242]

commit f0a5a07fa5b98a2e7fcd028cebd7770c6d8916a7
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-28 18:12:38 +0900

    Removed unused variable [Bug #16242]

commit a0579f3606561a74e323f6193b9504c06845236c
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-12 17:02:51 +0900

    Make prepending a refined module after inclusion not break refinements

    After the previous commit, this was still broken. The reason it
    was broken is that a refined module that hasn't been prepended to
    yet keeps the refined methods in the module's method table. When
    prepending, the module's method table is moved to the origin
    iclass, and then the refined methods are moved from the method
    table to a new method table in the module itself.

    Unfortunately, that means that if a class has included the module,
    prepending breaks the refinements, because when the methods are
    moved from the origin iclass method table to the module method
    table, they are removed from the method table from the iclass
    created when the module was included earlier.

    Fix this by always creating an origin class when including a
    module that has any refinements, even if the refinements are
    not currently used.  I wasn't sure the best way to do that.
    The approach I choose was to use an object flag. The flag is
    set on the module when Module#refine is called, and if the
    flag is present when the module is included in another module
    or class, an origin iclass is created for the module.

    Fixes [Bug #13446]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2550

commit 5069c5f5214ce68df8b3954321ad9114c5368dc3
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-12 16:01:37 +0900

    Honor refinements for modules that prepend other modules

    This previously did not work, and the reason it did not work is
    that:

    1) Refining a module or class that prepends other modules places
       the refinements in the class itself and not the origin iclass.

    2) Inclusion of a module that prepends other modules skips the
       module itself, including only iclasses for the prepended modules
       and the origin iclass.

    Those two behaviors combined meant that the method table for the
    refined methods for the included module never ends up in the
    method lookup chain for the class including the module.

    Fix this by not skipping the module itself when the module is
    included.  This requires some code rearranging in
    rb_include_class_new to make sure the correct method tables and
    origin settings are used for the created iclass.

    As origin iclasses shouldn't be exposed to Ruby, this also
    requires skipping modules that have origin iclasses in
    Module#ancestors (classes that have origin iclasses were already
    skipped).

    Fixes [Bug #16242]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2550

commit 4325f080862b36a3e3ddee472169f65758612ad3
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-28 15:32:21 +0900

    Add require "irb" to test/irb/test_completion.rb

commit 7d75e94ea967a47e1ca1083f6d1090eaac7ca58e
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-28 15:15:41 +0900

    Fix regexp to complete complex literal

    IRB completion logic always needed exponential notation for complex literal
    such as 3e6i but it's bug. I fixed to support complex literal without
    exponential notation such as 3i.

commit 8b4ee5d6ba92a385eedc9235ce0a2d5618deecf0
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-28 13:44:25 +0900

    Raise `NoMatchingPatternError` when expr `in` pat doesn't match

    * `expr in pattern` should raise `NoMatchingError` when unmatched
    * `expr in pattern` should return `nil`. (this is unspecified, but
      this feature is experimental, at all)

    [Feature #16355]

commit 18953416def52824c46a68370c4b34f5b720ee3f
Author: y-yagi <yuuji.yaginuma@gmail.com>
Date:   2019-11-28 13:24:01 +0900

    Fix documentation of `MonitorMixin#new_cond` [ci skip] (#2707)

    Since https://github.com/ruby/ruby/pull/2576,
    `new_cond` uses the Monitor object, not the receiver.

commit c688026455a3a37b233333aa90bdd4633b3e6a91
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-28 10:52:33 +0900

    Suppress strict-aliasing warning by x86_64-w64-mingw32-gcc 7.4.0

commit abe8fb49f0365c23df06857549b7a3a32d212ed5
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-28 09:32:51 +0900

    Delete newline when C-k on emacs mode at EOL

commit 7769975c3ccf1f08c15f4c6de8451783683e281d
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-28 08:26:10 +0900

    Remove two removed constants

commit 2d0a1a1869e601dc0d50a86a89fe98edcbd24f09
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-27 11:58:38 +0900

    Fix ghost method line no

commit f9debf343788a6460e1e67bd7efc470d73e69f21
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-28 08:13:35 +0900

    Update documentation for ruby2_keywords [ci skip]

commit 416cccc6ec4fde7220edbf848424514f5d5b5743
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-27 19:09:47 +0900

    Drop windows-2016 on GitHub Actions

    https://help.github.com/en/actions/automating-your-workflow-with-github-actions/software-installed-on-github-hosted-runners#windows-server-2016
    > Note: The Windows Server 2016 virtual environment will be removed on December 3, 2019.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2704

commit cdcaf041127430b30ee4b32452762666495a732a
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-28 03:03:51 +0900

    * 2019-11-28 [ci skip]

commit 299a13612e54accd9d3661bafde8f67142a78d54
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-28 02:03:00 +0900

    Don't modify rest array when using ruby2_keywords

    Previously, the rest array was modified, but it turns out that is
    not necessary.  Not modifying the rest array fixes cases when the
    rest array is used more than once.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2706

commit 6f27fa4f7d52bfaea4fd1bd7605bda28e302e74c
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-11-27 14:42:30 +0900

    prefer class_serial over m_tbl

    Decades ago, among all the data that a class has, its method
    table was no doubt the most frequently accessed data.  Previous
    data structures were based on that assumption.

    Today that is no longer true.  The most frequently accessed field
    moved to class_serial.  That field is not always as wide as VALUE
    but if it is, let us swap m_tbl and class_serial.

    Calculating -------------------------------------
                                   ours       trunk
    Optcarrot Lan_Master.nes     47.363      46.630 fps

    Comparison:
                 Optcarrot Lan_Master.nes
                        ours:        47.4 fps
                       trunk:        46.6 fps - 1.02x  slower

Notes:
    Merged: https://github.com/ruby/ruby/pull/2701

commit 177bc652a8110c1350c0e6df8cb17158e44e18dd
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-27 03:57:46 +0900

    * 2019-11-27 [ci skip]

commit a3e6f52c17061f012c4e638b3343b57752ed7603
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-26 12:20:53 +0900

    rename __builtin_inline!(code) and introduce others.

    rename __builtin_inline!(code) to __builtin_cstmt(code).
    Also this commit introduce the following inlining C code features.

    * __builtin_cstmt!(STMT)

    (renamed from __builtin_inline!)

    Define a function which run STMT implicitly and call this function at
    evatuation time. Note that you need to return some value in STMT.
    If there is a local variables (includes method parameters), you can
    read these values.

      static VALUE func(ec, self) {
        VALUE x = ...;
        STMT
      }

    Usage:
      def double a
        # a is readable from C code.
        __builtin_cstmt! 'return INT2FIX(FIX2INT(a) * 2);'
      end

    * __builtin_cexpr!(EXPR)

    Define a function which invoke EXPR implicitly like `__builtin_cstmt!`.
    Different from cstmt!, which compiled with `return EXPR;`.
    (`return` and `;` are added implicitly)

      static VALUE func(ec, self) {
        VALUE x = ...;
        return EXPPR;
      }

    Usage:
      def double a
        __builtin_cexpr! 'INT2FIX(FIX2INT(a) * 2)'
      end

    * __builtin_cconst!(EXPR)

    Define a function which invoke EXPR implicitly like cexpr!.
    However, the function is called once at compile time, not evaluated time.
    Any local variables are not accessible (because there is no local variable
    at compile time).

    Usage:
      GCC = __builtin_cconst! '__GNUC__'

    * __builtin_cinit!(STMT)

    STMT are writtein in auto-generated code.
    This code does not return any value.

    Usage:

      __builtin_cinit! '#include <zlib.h>'
      def no_compression?
        __builtin_cconst! 'Z_NO_COMPRESSION ? Qtrue : Qfalse'
      end

commit 9e01fcd0cb79a05daa50d99c888cc7eeb9c79426
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-26 22:54:35 +0900

    [ripper] Fixed unique key check in pattern matching

    Check keys
    * by an internal table, instead of unstable dispatched results
    * and by parsed key values, instead of escaped forms in the source

commit 22dfd14c179632d773b97e708255b6c183a740aa
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-26 15:40:34 +0900

    Hoisted out `push_pvtbl`/`pop_pvtbl`

commit 497f13aea6bae0e2443f21b4eb35fee9df3424d7
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-26 15:33:40 +0900

    Wrap `p_kw` in an array at `p_kwarg`

    Not in `p_kw` itself, which makes key and variable/expr pair only
    now.

commit 265b5382b21db28e52d0314ef47025f881dcbf0f
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-26 14:00:08 +0900

    Allow `$10` and more in the Ripper DSL

commit 7db719c51652f0de6cae079c6ce0723dd00a9939
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-26 19:08:56 +0900

    Write rbinc files to the source directory

    Update the target file itself of the dependency on this script.
    Fall back to the current working directory if unwritable.

commit 8b208293963cafa1469947a9957b59ce68895af1
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-26 19:07:29 +0900

    Remove an unnecessary variable

commit 82525fcce192aa5582480164f5c109f9f2fe621b
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-26 18:25:56 +0900

    Add sync task for ruby/openssl

commit 1fe31737d826bcc0a875419f5451679ae7ec04eb
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-26 18:20:19 +0900

    Slightly fix the warning message [ci skip]

    I'm not sure, but maybe it was grammatically incorrect?

commit 958641d9919f19a1e37c633e9dc44d2986904628
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-26 18:17:56 +0900

    Suggest an alternative to suppress the irb warning

commit 5a6e3e7552382a4863ef5a8833798edb22abb3c7
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-26 16:19:18 +0900

    Add `--with-openssl-dir` to windows on GitHub Actions

    https://github.com/ruby/ruby/commit/7bd7a013b14fb6c4403ff243ec5db13c5c71f552/checks?check_suite_id=328682567#step:10:1634
    ```
    *** Following extensions are not compiled:
    openssl:
            Could not be configured. It will not be installed.
    "       d:/a/ruby/ruby/src/ext/openssl/extconf.rb:97: OpenSSL library could not be found. You might want to use --with-openssl-dir=<dir> option to specify the prefix where OpenSSL is installed."
    ```

commit 307e899d78057f7b5b504034eea103f4a8a89ba3
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-26 11:46:22 +0900

    * 2019-11-26 [ci skip]

commit 7bd7a013b14fb6c4403ff243ec5db13c5c71f552
Author: NAKAMURA Usaku <usa@ruby-lang.org>
Date:   2019-11-26 11:44:11 +0900

    Fix `$(RMALL) -r` on Windows

    `set recursive=1 &` sets `1 ` to `recursive`, not `1`.

commit 26625bc33c32e0945bf727234a3ce6da1eb0ddc4
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-19 17:17:00 +0900

    [ripper] Quoted label without expression must be a local variable

    The difference from 0b8c73aa65add5c57b46b0cfdf4e661508802172 is to
    add the result of `string_add` event to marking objects.

    ```C
                                RNODE($1)->nd_rval = add_mark_object(p, $$);
    ```

commit 86461fc28cd9c05670ece440d337f255b33e6def
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-25 16:52:50 +0900

    lldb_cruby.py: improved dump of Symbol

    [ci skip]

commit 09e76e982801a838688ea80be29844ed91c23f46
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-25 15:05:53 +0900

    Improve consistency of bool/true/false

commit e27acb61485189fd7647741b6ca19920989dec03
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-25 14:02:15 +0900

    add fast path for argc==0.

    If calling builtin functions with no arguments, we don't need to
    calculate argv location.

commit 5c6235a83cc6a20c27f3e3a94381b4efcad4c3fc
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-25 12:10:05 +0900

    Set TRUE/FALSE to `bool ruby_tz_uptodate_p` instead of 1/FALSE

commit 714a0cefc10b8f0a2a89e6cfb06723d72f2a5b99
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-25 10:54:09 +0900

    Fix a typo [ci skip]

commit a5f0d1d71598451dd8461ba52a3a143cb33afdd3
Author: Junichi Ito <jit@sonicgarden.jp>
Date:   2019-11-25 10:16:59 +0900

    Remove duplicated line in NEWS [ci skip]

    [ruby-core:95935] [Misc #16365]

commit 9af52c0d099083fb6b56f39584a0909baa9e7a10
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-25 09:19:42 +0900

    lldb_cruby.py: fixed dump of embedded RArray

    [ci skip]

commit ce50af21af3d23e292b73f955a8b12ea9c2038e3
Author: Paweł Przeniczny <pawel.przeniczny@airhelp.com>
Date:   2019-11-25 07:08:16 +0900

    Fix the docs for Proc#>>.

    The docs are wrong about the behaviour of `#>>` (looks like it was copied from `#<<`)
    In `(prc >> g).call(n)` _prc_ is called first (with _n_), *then* _g_ is called with the result.

    Code examples are OK.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2691

commit fd956c72eaeb07d26d61310a9e4b55b500237c02
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-25 07:27:15 +0900

    Cache loaded module to suppress method redefined warnings

commit 90872520674dcc070d693430ee139042ba514591
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-25 06:50:27 +0900

    * 2019-11-25 [ci skip]

commit 51ea1abb5f2ed70387dda28a5d0d9ee817367d61
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-25 05:38:09 +0900

    Remove e2mmap dependency

commit efbca15116d4aea1588c6ba4ef0eb72c3c55c1db
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-25 03:10:35 +0900

    Remove lib/irb/slex.rb

commit 1aeb201d28ae2a10f7856be72ac6d705982b67ab
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-24 23:29:09 +0900

    Remove debug code...

commit 411644186b3bc9515fe7f60627bc1dea5d89cc36
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-24 23:15:25 +0900

    * 2019-11-24 [ci skip]

commit 745ab168185fc8f3c9d9dbd3a2355738776aee6d
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-24 22:42:08 +0900

    Disable tracer ext of IRB when tracer doesn't found

commit b563439274a402e33541f5695b1bfd4ac1085638
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-23 16:00:39 +0900

    Show include directive differences only when under git

    When building from tarballs, the source directory is not a git
    repository.

commit 9318e1ff3e700250dba277924672634c6ecf2940
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-23 11:41:27 +0900

    Use realpath to try to fix failures with symlinks

commit 818708edab6e950a8c1828816b73d36f05585f9f
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-23 07:22:33 +0900

    Stop using undefined matrix.os for macOS

    and use github.workflow instead. Applied a similar change to MJIT too.

commit b0614a0f968d40fb1bad31592fc9a607dbac447d
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-23 05:44:35 +0900

    Tracer.set_get_line_procs should support block and Proc object

    Original Tracer.set_get_line_procs is implemented by
    "def set_get_line_procs(p = proc)". It means that original
    Tracer.set_get_line_procs supports block and Proc object.

commit 1ee010a3171978007a4550e8077f1e4b646bd80a
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-23 05:20:23 +0900

    Tracer.add_filter should support block and Proc object

    Original Tracer.add_filter is implemented by "def add_filter(p = proc)". It
    means that original Tracer.add_filter supports block and Proc object.

commit 8e743fad4e9124bd59bb5f14473cb188db9d3c34
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-11-22 04:05:48 +0900

    Count pinned slots using only bitmap

    This is significantly faster than checking BUILTIN_TYPEs because we
    access significantly less memory. We also use popcount to count entire
    words at a time.

    The only functional difference from the previous implementation is that
    T_ZOMBIE objects will no longer be counted. However those are temporary
    objects which should be small in number, and this method has always been
    an estimate.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2688

commit 26fd8d962ce42b7eb8d1c1eb43ddfa1ff24dc3aa
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-11-21 07:18:40 +0900

    Optimize pinned page sorting

    Previously we would count the pinned objects on each comparison. Since
    sorting is O(N log N) and we calculated this on both left and right
    pages on each comparison this resulted in a extra iterations over the
    slots.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2688

commit 3f4199b0af791572b7abf63f33bb3b0b9b53d08f
Author: John Hawthorn <john@hawthorn.email>
Date:   2019-11-21 07:07:20 +0900

    Use value of use_verifier in gc_compact

Notes:
    Merged: https://github.com/ruby/ruby/pull/2688

commit 144bff43fc0b69361f6aa29448d24dd161b7d359
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-23 01:58:08 +0900

    * 2019-11-23 [ci skip]

commit 271cb9acd268c6074b86426e25ee61b5987e5fb3
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-23 01:55:29 +0900

    Suppress git error message

    `fatal: not a git repository (or any of the parent directories): .git`

commit d7f100226d41df364b048c7956b5140922970e9a
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-23 01:29:53 +0900

    Skip test_validate_gemspec when tarball and git installed too

    `git --version` failed as expected when git is not installed,
    but unexpectedly pass when git installed and pwd is not in git working directory.
    So use `git rev-parse` instead, and it failed when git installed too.

commit 053f78e13988e9253d1f207bf5e23d9505112b32
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-22 23:56:18 +0900

    internal.h: Add a prototype declaration for rb_gvar_readonly_setter

    emscripten fails to compile ruby due to lack of this.

commit 994435d0efa9931d0475de923c4e6c227d03e398
Author: Vít Ondruch <vondruch@redhat.com>
Date:   2019-11-22 17:47:30 +0900

    Revert "Update dependencies"

    This reverts commit e1b234148829f65bea9f5ecc7018beb782ea6023.

    This allows to build Psych against system libyaml again on Fedora.

    [Bug #16359]

commit 35608760ffae00e0daebecd260191019a9b32648
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-11-22 19:05:58 +0900

    Add github repo to remove_tag

commit a93d0a4e62c50a53ccdc3b2bc114f75a25bfc40f
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-22 18:39:39 +0900

    Check -1 arity for C++

commit f9d20a1bf157885975aacffdcb22f2b210f1258d
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-22 13:58:32 +0900

    * 2019-11-22 [ci skip]

commit 8eb0a9e5668032e750b91739cc40f3180278728d
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-22 13:55:59 +0900

    Use jsDelivr instead of raw.githubusercontent.com

    Try to fix download error on Solaris CI

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable11x/ruby-master/log/20191121T162422Z.fail.html.gz
    ```
    tool/downloader.rb:243:in `rescue in download': failed to download config.guess (RuntimeError)
    Net::HTTPFatalError: 503 "Service Unavailable": https://raw.githubusercontent.com/gcc-mirror/gcc/master/config.guess
    ```

commit 88d6009d91c197049da9d6efeb406aec5eb5d551
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-21 23:10:30 +0900

    Use more strict regexp to avoid to match naninanirb.rb

commit ffab1bfdfcb9f1448c063e93f04209c90327ad9c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-21 15:17:34 +0900

    Fixed for old git

commit 97a5af62a318fcd93a4e5e4428d576c0280ddbae
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-21 10:57:36 +0900

    Skip updating revision.h when the revision is unchanged

    note: GNU make only.

commit a9d4f2d03c847ec1c89dc03a5076a9fa29ffa61f
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-06-22 02:33:06 +0900

    Support %U/%u/%W/%w/%V/%g/%G formats in Time.strptime

    Most of these formats were documented as supported, but were not
    actually supported. Document that %g and %G are supported.

    If %U/%W is specified without yday and mon/mday are not specified,
    then Date.strptime is used to get the appropriate yday.

    If cwyear is specifier without the year, or cwday and cweek are
    specified without mday and mon, then use Date.strptime and convert
    the resulting value to Time, since Time.make_time cannot handle
    those conversions

    Fixes [Bug #9836]
    Fixes [Bug #14241]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2685

commit 8f1062127e40767240aa0a0fe18fd48687bc04e9
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-21 07:28:18 +0900

    Add test/reline/test_string_processing.rb

commit 9131e62f1862a1736d37d934cda603dc91b2c831
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-21 07:05:27 +0900

    [ruby/reline] Version 0.0.7

    https://github.com/ruby/reline/commit/09d370bdc19e62f0a27c2240e19b07963afd922f

commit f30f78e2e054d72d4997db8c14eda81479270ee8
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-21 05:21:31 +0900

    Version 0.0.6

commit e4127cdd3e2597d1814c59cb842d4dff0ba73921
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-21 05:25:01 +0900

    Version 1.1.0

commit 95f20f463aa07fbb2e5efbdb89a93d94861cdc49
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-21 07:00:01 +0900

    Consider escape sequence to calculate prompt width

commit 1197a036ae1c48ac0842bb2a0dc8af213def47d7
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-21 04:37:29 +0900

    Add a proper cast to pass JIT tests on mswin.

    https://ci.appveyor.com/project/ruby/ruby/builds/29001248/job/ye80bsrmewdgw294

commit eee70b41d4c04caa06a68cc4847a600eb7322cb8
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-21 02:44:15 +0900

    Add a warning message and --legacy of an alias of --singleline

commit 9d6f78822c61348989802848150f103f0a4ef7d0
Author: Y. Ushiki <citrus.yubeshi@gmail.com>
Date:   2019-10-30 08:49:03 +0900

    Refactor filter_backtrace

commit 04d0d93ebf8692170218fa9d55216aaca74be30b
Author: Y. Ushiki <citrus.yubeshi@gmail.com>
Date:   2019-10-30 08:43:19 +0900

    Fix filter_backtrace for context-mode 0

commit 91bf3b7a77e187794cc84549f330e5675fb5d367
Author: aycabta <aycabta@gmail.com>
Date:   2019-10-30 09:32:16 +0900

    Use singleline/multiline instead of readline/reidline

commit 9b52bacc62c3db13ea18fa5ea4d9b9a92b5fcb86
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-21 02:14:20 +0900

    Refined inspection of argument forwarding

commit f835a74da45f95073d12f84c3b8de9fb2f1e9ff6
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-21 00:48:59 +0900

    * 2019-11-21 [ci skip]

commit 6723aa07e591a13996b5af205c589200d44c5249
Author: manga_osyo <manga.osyo@gmail.com>
Date:   2019-11-20 09:13:42 +0900

    Change argument `Proc` to `#call` defined object.
    This is the same as the behavior of Readline.

commit 81586a4d9fd6afe1c39f737a704c5010faf22192
Author: manga_osyo <manga.osyo@gmail.com>
Date:   2019-11-16 11:13:19 +0900

    Add <Home> <End> keys.

commit 777973084e599cf9efa490173709b187fb507f90
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-20 17:56:59 +0900

    Add tests of argument forwarding's parameters and inspect

commit 633625a083c5f02e78355cb12818056e54330e88
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-20 17:55:03 +0900

    Mintty on Cygwin isn't a kind of command prompt, can process ANSI escape code

commit ae818b589efcb5dca47d9ceb888cb658ef56e286
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-20 17:21:38 +0900

    add a NEWS entry for Method#inspect

commit fc22b0eaa3fa073f622917364cbb573cd6ba2bfc
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-20 16:27:57 +0900

    Always forward declaration is needed

    `rb_resolve_refined_method_callable` is referenced in
    `refine_sym_proc_call`, even when pre-compiling mjit header on
    mswin.

commit 83900528ad6a2cf37360abe2bcebb16787177838
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-20 16:23:59 +0900

    Turn C4047 warning into error

    Warned at making precompiled header on mswin.

    ```
    building rb_mjit_header-2.7.0.pch
    vm.c
    d:\a\ruby\ruby\src\vm_args.c(1117): warning C4047: '=': 'const rb_callable_method_entry_t *' differs in levels of indirection from 'int'
    rb_mjit_header-2.7.0.pch updated
    ```

commit 7608baf92ae2f3b29786e7fca021c8c8d24016f8
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-11-20 15:51:10 +0900

    re-add function prototypes

    This commit reverts a part of 0e8219f591f3f17cb7ee361e8a60dbef08145883
    which broke icc.  See also https://rubyci.org/logs/rubyci.s3.amazonaws.com/icc-x64/ruby-master/log/20191120T010006Z.fail.html.gz

commit f90b22e3dc99fd8eff2235e847e52266d20e8488
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-20 15:37:05 +0900

    Revert the line for nextafter.c for FreeBSD make

commit 50cc9341450cfbdf9a40df3d38600d8d2854a0a3
Author: zverok <zverok.offline@gmail.com>
Date:   2019-11-20 09:33:20 +0900

    Update representation (discussed on ruby tracker)

Notes:
    Merged: https://github.com/ruby/ruby/pull/2618

commit baf482bab4776f781c3569d9f581e38bbf0548e1
Author: zverok <zverok.offline@gmail.com>
Date:   2019-10-27 20:32:17 +0900

    Fix test_module.rb

Notes:
    Merged: https://github.com/ruby/ruby/pull/2618

commit 4b583cff97025394fab4a014a2a8606dfb557475
Author: zverok <zverok.offline@gmail.com>
Date:   2019-10-27 19:39:33 +0900

    Method parameters inspect

    Example:

        def m(a, b=nil, *c, d:, e: nil, **rest, &block)
        end
        p method(:m)
        #=> #<Method: m(a, b=<default>, *c, d:, e: <default>, **rest, &block) ...>

Notes:
    Merged: https://github.com/ruby/ruby/pull/2618

commit da0d7211aa85b90f2246e2d9abfe08105f7ddedb
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-20 10:04:41 +0900

    Fix indent of a line when a newline is inserted to the next

commit 9306602f24e5c9be4cdae5ed7e69e746ae9e175e
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-20 09:58:33 +0900

    Replace typo "bock" with "block"

commit 19a310b0ac6bfc78340d37963ea2655783760bee
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-20 09:56:13 +0900

    A preceding token of "do" of block has EXPR_CMDARG or EXPR_ENDFN

      meth do # the preceding token of "do" has EXPR_CMDARG
      end

      meth() do # the preceding token of "do" has EXPR_ENDFN
      end

commit 49b4507fd3caed356e4039da5820a7c843c6b05a
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-20 08:39:43 +0900

    Number sign comment (# bla bla) is a kind of newline character

commit bc0da8e3ff409f09888ffe98e6e66b503ebc8083
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-19 20:58:11 +0900

    Generate history file path correctly when $HOME/.irbrc doesn't exist

commit ff41663403d3eb76d95f465cb94e14d2faaa04d1
Author: Kazuki Tsujimoto <kazuki@callcc.net>
Date:   2019-11-20 00:35:47 +0900

    Fix memory corruption in Enumerable#reverse_each [ruby-dev:50867] [Bug #16354]

commit 61131edba7c885a6d12c4d6f0e502fb40381f184
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-20 00:55:14 +0900

    Revert "[ripper] Quoted label without expression must be a local variable"

    This reverts commit 0b8c73aa65add5c57b46b0cfdf4e661508802172, which
    seems breaking RVALUE consistency check.

commit f3c9803528d429a7b5e47f400caa33dfadd94da7
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-20 00:07:26 +0900

    * 2019-11-20 [ci skip]

commit 2439948bcc0ec9daf91cf79301195e59bad49aff
Author: Kazuki Tsujimoto <kazuki@callcc.net>
Date:   2019-11-19 23:53:01 +0900

    Avoid needless object allocation

commit 822d7ae31659e4ab60c4d1aa6d088577d6bc74b0
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-19 17:34:43 +0900

    Add a test

    and rename from b.rb

    [ruby-core:95055] [Bug #16177]

commit 0b8c73aa65add5c57b46b0cfdf4e661508802172
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-19 17:17:00 +0900

    [ripper] Quoted label without expression must be a local variable

commit a5fe08fdd9d11f12a6837291ee588ab933a823b6
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-19 16:56:56 +0900

    care about TAG_FATAL.

    TAG_FATAL represents interpreter closing state and ec->errinfo
    contains FIXNUM (eTerminateSignal, etc). If we need to change the
    state, then errinfo is also changed because TAG_RAISE assumes that
    ec->errinfo contains a Exception object.

    Without this patch, TAG_FATAL is ignored and no ec->errinfo change
    so that it causes critical issue.
    [Bug #16177]

commit c53aec73ddf94bb9a06bead62c3bf58c5ba49bd3
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-19 15:06:11 +0900

    Configure static extensions only if in charge

    Get rid of races in parallel configuration when using the
    ext/Setup file.

commit f6239ce0fc906c9d407e7da33f447575670a79bd
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-11-19 13:16:04 +0900

    peep-hole optimize VM instructions

    Some minor optimizations.

    Calculating -------------------------------------
                               ours       trunk
              vm2_regexp     8.479M      8.346M i/s -      6.000M times in 0.707612s 0.718916s
       vm2_regexp_invert     8.605M      8.350M i/s -      6.000M times in 0.697298s 0.718576s

    Comparison:
                           vm2_regexp
                    ours:   8479223.3 i/s
                   trunk:   8345893.8 i/s - 1.02x  slower

                    vm2_regexp_invert
                    ours:   8604647.4 i/s
                   trunk:   8349852.8 i/s - 1.03x  slower

    Calculating -------------------------------------
                               ours+jit   trunk+jit
    Optcarrot Lan_Master.nes     68.603      64.167 fps

    Comparison:
                 Optcarrot Lan_Master.nes
                    ours+jit:        68.6 fps
                   trunk+jit:        64.2 fps - 1.07x  slower

commit 75e8dd58f69c190c9698d0133942032903fb2f07
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-19 13:06:00 +0900

    Remove TEST_BUNDLED_GEMS_ALLOW_FAILURES

    https://github.com/seattlerb/minitest/pull/798 is closed

commit 0e8219f591f3f17cb7ee361e8a60dbef08145883
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-11-18 12:13:08 +0900

    make functions static

    These functions are used from within a compilation unit so we can
    make them static, for better binary size.  This changeset reduces
    the size of generated ruby binary from 26,590,128 bytes to
    26,584,472 bytes on my macihne.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2682

commit 78e266da1dede1c81e634982e76a129c5720d80e
Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
Date:   2019-11-19 11:40:00 +0900

    Clarify documentation for `InstructionSequence#compile`.

    We incorrectly assumed that the `file` argument should be the file name and
    caused https://github.com/scoutapp/scout_apm_ruby/issues/307 because
    exception backtrace did not contain correct path. This documentation
    clarifies the role of the different arguments and provides extra
    examples.

commit cef9ebfbd3565f9feb25d0140da3176ea26bf4a9
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-13 15:28:12 +0900

    Suppress `stty` error on Apple Terminal

    `stty` called in `Reline::ANSI.deprep` command shows the following
    error message on macOS Apple Terminal, with some settings.

    ```
    $ LANG=C irb
    irb(main):001:0>
    stty: 'standard input': unable to perform all requested operations
    stty: 'standard input': unable to perform all requested operations
    ```

commit 473e314791964019e017410fb761b873d61e591c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-13 15:22:39 +0900

    Prefer dedecated assertions

commit 0be0d90ab0566df186ad7dc3b9e5ec9e06e296a3
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-19 02:31:36 +0900

    pack is not using invokebuiltin anymore

commit fea24bbfdbe17da1038355fe7e0f7063f8c26c87
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-18 23:41:26 +0900

    Fix glob base in bundler.gemspec

Notes:
    Merged: https://github.com/ruby/ruby/pull/2683

commit 9aa75795f9f438d5c874d8e418c3c7cdd63024fa
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-18 23:39:57 +0900

    Skip some tests if extracted from tarball

Notes:
    Merged: https://github.com/ruby/ruby/pull/2683

commit e9992bcab03b1646d18b4a417643273a7bbb6158
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-18 23:36:51 +0900

    Allow unknown if ruby core

Notes:
    Merged: https://github.com/ruby/ruby/pull/2683

commit 9067f43c0ae6d42222a0dd2cd55380b11343ddd1
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-19 00:27:05 +0900

    * 2019-11-19 [ci skip]

commit 0c0278b90a6fe1e71e0e5c27069b8b2976e2a7cf
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-19 00:25:49 +0900

    test/-ext-/string/test_fstring.rb: suppress a warning for taint

commit 373769c93995abeeb546bdcd9e6527c77aefa1d4
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-19 00:12:50 +0900

    NEWS: Add an example for the warning of "yield in singleton class"

commit f09fc1b0344e65aeb9c11aaeb23c99954265fe4d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-18 23:14:13 +0900

    Dependents on probes.h need the dummy header too

commit e1b234148829f65bea9f5ecc7018beb782ea6023
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-08-07 23:22:06 +0900

    Update dependencies

commit 39492d6ce6ee11cbb275dc6f48c73de93f8549ce
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-08-10 00:02:17 +0900

    Build ruby-runner

commit 227220b25aad9841eb979c18a0251b71de824e88
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-08-10 00:02:17 +0900

    Skip dependencies on timestamp files

commit 209164e44f0bd0bbd938bf726e88d0dd29f84d55
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-18 18:42:22 +0900

    Renamed assembly file like as e64f71f812324d098bed12ed68c2bc1d6e780c90

commit 7a9b2039b7b82f081f2cab40a4fbbc8b01231ca4
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-11-18 12:00:19 +0900

    delete unused codes

    Suppress compiler warnings.

commit 57cd4623cfb56d12eb308eaf5fb09612e4572c19
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-18 13:36:34 +0900

    should not use __func__

commit 22c9504905114cfb58ebc0aa631200f0caafd4e0
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-18 11:05:08 +0900

    rb_tainted_str_new_with_enc is no longer used

commit 5e34ab5406942d43b4c0fbccfc153409d0386d1e
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-18 10:36:48 +0900

    add casts.

    add casts to avoid compile error.
    http://ci.rvm.jp/results/trunk_clang_39@silicon-docker/2402215

commit c3693bbaaa39d36210060fb4478751d66c0052ad
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-18 10:24:38 +0900

    catch up last commit.

    Array#pack uses `opt_invokebuiltin_delegate_leave` now.

commit 71fee9bc720ba7a117062bf3f78b6086527b656c
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-15 17:49:49 +0900

    vm_invoke_builtin_delegate with start index.

    opt_invokebuiltin_delegate and opt_invokebuiltin_delegate_leave
    invokes builtin functions with same parameters of the method.
    This technique eliminate stack push operations. However, delegation
    parameters should be completely same as given parameters.
    (e.g. `def foo(a, b, c) __builtin_foo(a, b, c)` is okay, but
    __builtin_foo(b, c) is not allowed)

    This patch relaxes this restriction. ISeq has a local variables
    table which includes parameters. For example, the method defined
    as `def foo(a, b, c) x=y=nil`, then local variables table contains
    [a, b, c, x, y]. If calling builtin-function with arguments which
    are sub-array of the lvar table, use opt_invokebuiltin_delegate
    instruction with start index. For example, `__builtin_foo(b, c)`,
    `__builtin_bar(c, x, y)` is okay, and so on.

commit 93ce4f1cd7c96f0fdbeebc87a9fa64d07cede729
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-18 10:14:56 +0900

    update deps.

    https://travis-ci.org/ruby/ruby/jobs/613242256#L2205

commit b753929806d0e42cdfde3f1a8dcdbf678f937e44
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-18 08:00:52 +0900

    * remove trailing spaces. [ci skip]

commit 4c7dc9fbe604cc0c8343b1225c96d4e5219b8147
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-15 05:15:01 +0900

    Update NEWS for $SAFE/taint changes

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit 3a0de05beeb997ec77d35755d9d303e1ca858cb7
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-05 00:44:33 +0900

    Remove mention of $SAFE and taint from doc [ci skip]

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit c257303ae78d0e307a80dbe5ccd405abc6e8d44d
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-09-26 07:49:21 +0900

    Deprecate rb_eval_cmd, add rb_eval_cmd_kw

    rb_eval_cmd takes a safe level, and now that $SAFE is deprecated,
    it should be deprecated as well.

    Replace with rb_eval_cmd_kw, which takes a keyword flag.  Switch
    the two callers to this function.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit d03da13b17484cb3f8697e9125e028eb65ef7a39
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-15 09:56:02 +0900

    [ruby/strscan] Remove taint support

    Ruby 2.7 deprecates taint and it no longer has an effect.
    The lack of taint support should not cause a problem in
    previous Ruby versions.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit afbd8f384a54b934debe6e48cfc299fb2c7669e9
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-19 04:28:44 +0900

    [ruby/openssl] Remove taint support

    Ruby 2.7 deprecates taint and it no longer has an effect.
    The lack of taint support should not cause a problem in
    previous Ruby versions.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit 17e8a6eff4954a37966c10f35db6551fce1d80a7
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-19 04:25:15 +0900

    [ruby/io-console] Remove taint support

    Ruby 2.7 deprecates taint and it no longer has an effect.
    The lack of taint support should not cause a problem in
    previous Ruby versions.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit 398cd3cc7dda375c2d21355057c11ecb4abeda70
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-19 04:10:03 +0900

    [ruby/etc] Remove taint support

    Ruby 2.7 deprecates taint and it no longer has an effect.
    The lack of taint support should not cause a problem in
    previous Ruby versions.

    Still untaint the tmpdir object on Ruby <2.7, as returning
    a tainted string there could cause problems.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit 23f1fb066303838a0d045b5981fe3c4ad077399e
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-15 05:30:56 +0900

    [ruby/rss] Only check taint on Ruby <2.7

    Ruby 2.7 deprecates taint and it no longer has an effect.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit 50013f7ebcafeea7f5163dc6ed1b1bf58c465ac7
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-19 03:33:09 +0900

    [ruby/rexml] Only taint on Ruby <2.7

    Ruby 2.7 deprecates taint and it no longer has an effect.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit ab42e5a486a5b27107296fa34056f03ac878e306
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-11-15 11:54:13 +0900

    More fixes for $SAFE/taint post merging

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit ffd0820ab317542f8780aac475da590a4bdbc7a8
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-09-25 12:59:12 +0900

    Deprecate taint/trust and related methods, and make the methods no-ops

    This removes the related tests, and puts the related specs behind
    version guards.  This affects all code in lib, including some
    libraries that may want to support older versions of Ruby.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit c5c05460ac20abcbc0ed686eb4acf06da7a39a79
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-09-21 11:06:22 +0900

    Warn on access/modify of $SAFE, and remove effects of modifying $SAFE

    This removes the security features added by $SAFE = 1, and warns for access
    or modification of $SAFE from Ruby-level, as well as warning when calling
    all public C functions related to $SAFE.

    This modifies some internal functions that took a safe level argument
    to no longer take the argument.

    rb_require_safe now warns, rb_require_string has been added as a
    version that takes a VALUE and does not warn.

    One public C function that still takes a safe level argument and that
    this doesn't warn for is rb_eval_cmd.  We may want to consider
    adding an alternative method that does not take a safe level argument,
    and warn for rb_eval_cmd.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2476

commit 7b6a8b5b54448235e17ed187d9d73f56893e1b6f
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-18 03:25:17 +0900

    * 2019-11-18 [ci skip]

commit 7c6bedfe5c8a3a36d79bdc63f04d7ccb0a82234e
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-18 03:23:45 +0900

    Remove unnecessary check

commit e7c5c60095537dabda7be5102ae66bd39a1ad133
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-17 23:25:37 +0900

    [ruby/irb] Remove ruby-token.rb from spec.files

    https://github.com/ruby/irb/commit/0180dc74bc

commit be95d591609ffea7727628a8af6f4c0a6b75d849
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-17 23:11:58 +0900

    [ruby/irb] Version 1.1.0.pre.4

    https://github.com/ruby/irb/commit/4945d0e676

commit 910f9b833855089802ff86a2ca00d43c9a0b618c
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-17 23:12:18 +0900

    [ruby/reline] Version 0.0.5

    https://github.com/ruby/reline/commit/d57c7ea252

commit a8e4a9f03ade7fd67fbd8ab1271750dd45eca282
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-17 13:12:06 +0900

    * 2019-11-17 [ci skip]

commit 449b2b9214256b059ed883770222382d3bc90578
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-17 13:11:25 +0900

    Fix typos

commit 11ae47c2669b64b64e2b34dd6dff02e72fd60881
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-15 16:50:11 +0900

    [ruby/reline] Restore left cursor key support on Unix like OSes...

    https://github.com/ruby/reline/commit/98b72af751

commit fa7618e4c1b382cb5863161017ef89116af3e24f
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-15 16:50:11 +0900

    Implement em_set_mark and em_exchange_mark

commit 6744593b8cd836967b40a4d76a9ac301b9e0f973
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-15 11:01:06 +0900

    Fix a typo [ci skip]

commit 018be445e9e9061364e8ba20dee9d25cb6f20e55
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-15 03:56:58 +0900

    * 2019-11-15 [ci skip]

commit 9c1abe2a6c5e6288ed208000fbf811d145af9355
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-15 03:51:06 +0900

    load prelude.rb by builtin features.

    The script in prelude.rb was embed in MRI to load it (eval this
    script at everyboot).
    This commit change the loading process of prelude.rb. MRI doesn't
    eval a script, but load from compiled binary with builtin feature.

    So that Init_prelude() does not load `prelude.rb` now.

commit c9ffe751d126a302d0e7e53e645e44084e339dde
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-11-13 12:41:39 +0900

    delete unused functions

    Looking at the list of symbols inside of libruby-static.a, I found
    hundreds of functions that are defined, but used from nowhere.

    There can be reasons for each of them (e.g. some functions are
    specific to some platform, some are useful when debugging, etc).
    However it seems the functions deleted here exist for no reason.

    This changeset reduces the size of ruby binary from 26,671,456
    bytes to 26,592,864 bytes on my machine.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2677

commit 4d615a0c8f4759ce4f6b96b643ef957837bdf20e
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-14 16:37:25 +0900

    `#@1` is no longer an embedded variable

commit 703e05b0eee3017a63690155e55a97d678f073cb
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-14 16:09:36 +0900

    Added default gems entry to NEWS

commit 3b614ec48a283e61334c70806f076cea3b2192ca
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-14 16:07:48 +0900

    Update RubyGems and Bundler entries on NEWS

commit 48edaf8b8a03ef7a1c4f936c8c92e9dcf4271872
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-14 13:00:25 +0900

    test/ruby/test_proc.rb: suppress "method redefined" warnings

commit 179062dd808c0a48e16269a2c42b10235cbbacd8
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-14 04:18:41 +0900

    move rb_vm_lvar_exposed() correctly.

    rb_vm_lvar_exposed() is prepared for __builtin_inline!(), needed for
    mini_builtin.c and builtin.c. However, it's only on builtin.c.
    So move it to make it as a part of VM.

commit a8f9e25ca8cc160683711baed00008461db2ad16
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-14 02:37:25 +0900

    Suspend many fibers test on JIT for now

    https://github.com/ruby/ruby/runs/301411717

    No C backtrace information and this is hard to fix immediately.
    As CI doesn't provide helpful information, this should be debugged
    locally or at least have more logs there.

commit afc93e96ffa93aa02b3e432037b3f88d002f5eea
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-14 02:30:53 +0900

    Make GitHub Actions notification more like Travis

    Build's sequential number is a link in Travis, and also YYYY-MM-DD-XX is
    a little hard to parse.

commit a102bcab418dc61ccfe6a49870393c42305d2895
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-14 01:48:41 +0900

    * 2019-11-14 [ci skip]

commit 3a408aff578bcde428ebdd4560d819c1ba792f2c
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-14 01:48:08 +0900

    try to remove vm_core.h

commit 7f2c98b11d9eedd7028a1ccb2c1f88db71db28ca
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 19:56:33 +0900

    Use shallow-since instead of depth

    commit number of today requires log since 0:00 UTC.
    So commits of 24 hours are enough.

    https://www.git-scm.com/docs/git-clone#Documentation/git-clone.txt---depthltdepthgt
    > Implies --single-branch unless --no-single-branch is given to fetch the histories near the tips of all branches.

    So I add `--single-branch` too.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2680

commit 990728170c5e4d6b763fa42c48ce82473d753aad
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 19:49:07 +0900

    Add commit number of today to notification of mjit CI too

Notes:
    Merged: https://github.com/ruby/ruby/pull/2679

commit e7ea6e078fecb70fbc91b04878b69f696749afac
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-13 16:53:12 +0900

    Check more likely condition first [Feature #16335]

commit 3324bc9d172e52114add3a0cdd426b5648cdc33b
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 16:09:59 +0900

    Skip tailcall test for MJIT

    failing in https://github.com/ruby/ruby/runs/300579218

commit bdf71a3ef032ed4675a6f3217cf5c9efb062c0b1
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 16:04:25 +0900

    Fix MJIT test's Slack notification

commit 57dc3ff73dcc5ef5ca080e841db58862c89b03d8
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-13 13:34:06 +0900

    Removed sync library from sync tool

commit 7913daf36c25cefd66887993e0946c54b7d7d294
Author: Dylan Thacker-Smith <Dylan.Smith@shopify.com>
Date:   2019-11-08 01:14:47 +0900

    Add missing Makefile dependencies for the tool/insns2vm.rb script

Notes:
    Merged: https://github.com/ruby/ruby/pull/2657

commit ac112f2b5dc7e16ccde8f048be80946187a033b0
Author: Dylan Thacker-Smith <Dylan.Smith@shopify.com>
Date:   2019-11-06 15:47:32 +0900

    Avoid top-level search for nested constant reference from nil in defined?

    Fixes [Bug #16332]

    Constant access was changed to no longer allow top-level constant access
    through `nil`, but `defined?` wasn't changed at the same time to stay
    consistent.

    Use a separate defined type to distinguish between a constant
    referenced from the current lexical scope and one referenced from
    another namespace.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2657

commit a5b6d7bca84fce6e13c68e8753893c4697960e3a
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-13 15:10:05 +0900

    Suppress warnings except for when last evaluation

    Co-authored-by: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>

commit c33d29fba5a04bd31242eb51e54d2ec198c34ba3
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 15:13:49 +0900

    We're not using Azure Pipelines anymore

commit dca2eb350c13de4446df92b958a40f14d67c97b8
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 15:11:34 +0900

    Update badges of GitHub Actions

commit d336db6568cc96dfee503c053e8f444dc7243858
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 15:04:49 +0900

    Fix a typo

commit 68ea892daf6e4073919d58ae83c7ff7389fbf184
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 14:55:03 +0900

    Remove obsoleted Wercker status badge

commit 331655cbe7139a287267c90b3ab46ed856aebb5b
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 14:48:05 +0900

    Migrate Wercker MJIT tests to Actions (#2676)

    * Migrate Wercker MJIT tests to Actions

    * Support pull request for testing

    * Capitalize other jobs too

    * Make it a command name for consistency [ci skip]

    * Remove wercker.yml

    * Add --jit-verbose=2 for debugging

    * Install MJIT headers

    * Separate install for sudo

    * Trigger build

Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit c4064aef7f48c51add6c24467da64528d5a2a2a5
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 13:22:46 +0900

    Add commit number of today to notification of GitHub Actions

Notes:
    Merged: https://github.com/ruby/ruby/pull/2675

commit 245977b2861f5fa6a7341333ca9b1897e959489b
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 13:56:52 +0900

    Stop debugging the same thing twice

    See L25-28

commit 9ee88a070f797d5eb9516c6a17359463fb5c37b9
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 13:56:15 +0900

    Remove MSPECOPT formerly for debugging

    At least the comment looks obsoleted. Aren't we using $JOBS already?

commit 02b6451c17cf81d138cd653fa989080246a1a63a
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 13:44:00 +0900

    Improve Actions job name shown on toolip

    Hoping to make it like `make (check, ...)`, `make (test-bundler, ...)`
    instead of `latest (...)` because some of the jobs are already not
    running on a latest platform.

commit 3118c7a2d20c6894a53480501d53daa4e6d3a743
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 13:38:05 +0900

    Run test-bundler / test-bundled-gems for Ubuntu

    only once. Doing it on multiple Ubuntu versions may not worth it.

commit 9980728ad61dc544d2ce5b981b54af36fa6e2a82
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-13 13:22:33 +0900

    Remove Drone CI in favor of Travis arm32

commit 3ad78264dc7e680a004a8ea1397d4ac9297134ba
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 13:13:52 +0900

    Use style of set-env

    https://help.github.com/en/actions/automating-your-workflow-with-github-actions/development-tools-for-github-actions#set-an-environment-variable-set-env

commit 546e50c2fb1fc749399b1a6cf3ce9e01c27b9398
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-13 10:35:52 +0900

    Merge released version of RubyGems 3.1.0.pre3

commit 63f363b70dc08efd6b2d3f59183d4de1e882ef81
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 10:31:02 +0900

    Update dependencies

    patch from https://travis-ci.org/ruby/ruby/jobs/611152175#L2204

commit bb9ecd026a6cadd5d0f85ac061649216806ed935
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-13 07:57:02 +0900

    Merge Bundler 2.1.0.pre3 released version

Notes:
    Merged: https://github.com/ruby/ruby/pull/2674

commit 00d56bdf66a3aeaadbc84196aacbd8d4e698cf79
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-13 09:55:54 +0900

    Try to fix error on solaris

    Add vm_core.h before builtin.h to pack.c for VM_CORE_H_EC_DEFINED.

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/solaris11s-sunc/ruby-master/log/20191112T102505Z.fail.html.gz
    ```
    compiling dmyenc.c
    linking miniruby
    Undefined                       first referenced
     symbol                             in file
    rb_vm_lvar_exposed                  pack.o
    ld: fatal: symbol referencing errors
    gmake: *** [miniruby] Error 2
    ```

commit ae33f93836b556f36d5ffc4a7bca2c1b379c56d8
Author: Yuichiro Kaneko <yui-knk@ruby-lang.org>
Date:   2019-11-13 09:50:58 +0900

    Update comment of Ripper.lex

    This is follow up of 1f7cb4bee9.

commit 4bbfe1f7c42300e2212b8f6794d5254b4db8df1c
Author: Jun Aruga <jaruga@redhat.com>
Date:   2019-10-16 00:08:00 +0900

    Add arm32 case on Travis.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2673

commit a5448c46bdde27cb5ba8a800b29a84ced8047e94
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-13 02:29:13 +0900

    * 2019-11-13 [ci skip]

commit 4334c9315af972337fcad82c0056152c45808348
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-07 02:10:27 +0900

    Remove arm64 from allow_failures

Notes:
    Merged: https://github.com/ruby/ruby/pull/2672

commit bf34ade7ef32f89aa5ba238d0a780f23eacb0487
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 22:58:09 +0900

    Show the name `Kernel#proc` in the warning message

commit 3816622fbedd034d338fcb1bbdc80d163e302ae6
Author: manga_osyo <manga.osyo@gmail.com>
Date:   2019-11-11 14:59:17 +0900

    Fixed `assert_equal` first argument to be expected.

commit fe45bee09312a233466171f40d6826e5e4f1f2f0
Author: osyo-manga <manga.osyo@gmail.com>
Date:   2019-11-10 16:00:41 +0900

    Reline#readline and Reline#readmultiline to private.

commit f36a53d03821624d30b3e91a7a75307b06e3a03c
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-12 15:44:19 +0900

    Only enabled mon_owned condition with Ruby 2.5+

commit 3bf8ffad714efa98949e25095f1c5e2844318958
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 18:02:28 +0900

    Added assertions for realpath and realdirpath

    It is said that realpath(3) and realdirpath(3) on some platforms
    may return a relative path.

commit 0f2837847d5bfb65d20a89d196393212635fbe9e
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-12 17:46:39 +0900

    Add ticket number of `FrozenError#receiver` [ci skip]

commit fb6a489af2765a3b56e301adf0019af6bbad6156
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-10-24 01:06:59 +0900

    Revert "Method reference operator"

    This reverts commit 67c574736912003c377218153f9d3b9c0c96a17b.
    [Feature #16275]

commit b41a19f92fdd9c8567e0650ceebb72386a96e395
Author: Kazuhiro NISHIYAMA <znz@users.noreply.github.com>
Date:   2019-11-12 17:22:19 +0900

    Add matrix.os to cache key (#2671)

    * Add matrix.os to cache key
    * Use multi-line string instead of array
      ref https://github.com/actions/cache/issues/44

Notes:
    Merged-By: znz <zn@mbf.nifty.com>

commit a58b4eee25b79432d98a1c665edaf5ec0a054b2e
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 17:14:10 +0900

    Warn on `...` at EOL

commit d1ae2bc27fd4183e6abb9e83691e192bfe1e5316
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-12 17:04:11 +0900

    NEWS: Make it clear that delegation syntax `(...)` requires parentheses

    Ref [Feature #16253]

commit fb02e3192cef96284501c82dfa024ea8a2b0ea80
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 16:35:01 +0900

    Create `RUBYCOMMONDIR` directory in advance

    As well as the directory per architecture.

    Closes https://github.com/ruby/ruby/pull/2669

commit 14db635097ef89a299531770ba8ed5800a58ab8f
Author: 卜部昌平 <shyouhei@ruby-lang.org>
Date:   2019-11-12 16:15:58 +0900

    add NEWS about _1 as a local variable [ci skip]

commit b0fb9bda9ade532da9012c375c0026470484a346
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 00:09:34 +0900

    Strip the last line which become trailing spaces

commit dd0217a8696667960e834ba95534ac5731997f3d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 00:07:26 +0900

    Inline function should be static

commit 2de3feab44c928c30f35a4a3a445b4fdfc225024
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 00:08:39 +0900

    Get rid of `__` prefix which is presereved by C standard

commit 7c22898a3a5a10c8c71683918b53ec2d17fdc621
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 15:42:53 +0900

    Disable tOROP at EXPR_BEG

    Both cannot appear there anyway.

commit dbaf589fb84a5b42111c85f993430133d8cae32f
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-12 12:49:05 +0900

    Update Rake 13.0.1

commit 593f0b88533c9d327b33d098bb6b3b51df871966
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-12 11:27:55 +0900

    Try to use actions/cache on windows

Notes:
    Merged: https://github.com/ruby/ruby/pull/2670

commit b38b26c62dc12da1d4fcee39de0c0cad598f5995
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-19 03:44:47 +0900

    [ruby/bigdecimal] Remove taint checking

    This removes the taint checking.  Taint support is deprecated in
    Ruby 2.7 and has no effect.  I don't think removing the taint
    checks in earlier ruby versions will cause any problems.

    https://github.com/ruby/bigdecimal/commit/1918d466f3

commit db33ab470cb4765f1b54384b51850e0db80f5aad
Author: Aaron Patterson <aaron.patterson@gmail.com>
Date:   2019-10-18 05:48:24 +0900

    [ruby/psych] Add a note about safe_load

    https://github.com/ruby/psych/commit/0910ae5575

commit 30fdee65d96924e0793ec702fcda909a2cac71ea
Author: Jeremy Evans <code@jeremyevans.net>
Date:   2019-10-19 04:34:59 +0900

    [ruby/psych] Remove taint support

    Ruby 2.7 deprecates taint and it no longer has an effect.
    The lack of taint support should not cause a problem in
    previous Ruby versions.

    I'm not sure if the untaint calls in deduplicate are still needed
    after the removal of tainting in the parser.  If they are not
    needed, they should be removed.

    https://github.com/ruby/psych/commit/73c1a2b4e0

commit 5ef41c91f0a1bca1617aaa4367ccf8e32c04b2d9
Author: Jean Boussier <jean.boussier@gmail.com>
Date:   2019-07-25 05:08:59 +0900

    [ruby/psych] Set required_ruby_version to 2.4.0

    https://github.com/ruby/psych/commit/4f1746a3c6

commit fd6445b7e8bab9d340be6f76688a8b96f1b52029
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-12 10:02:47 +0900

    Monitor#exit: check monitor ownership.

    Monitor#exit should be called by only onwer Thread. However, there
    is not check for it.

commit fef4370b409c990228cded2c425a6afb3bec2906
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-12 09:48:49 +0900

    check more.

commit ed90ec3e0d8ff7789569b40ba36d3b3ce0e706e6
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-12 09:11:16 +0900

    Clear current argument name at empty block argument [Bug #16343]

commit 4a30fabfcfd72bd61bf1dad61f168eaba6100f12
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-12 09:35:26 +0900

    Monitor owner state check correctly.

    Monitor can be owned at the beginning of this method.

commit 2407e8972561143b34970fb5d9095be32676c685
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-12 08:39:38 +0900

    Revert "Use untaint for File.symlink in kernel_require.rb"

    This reverts commit d9978ce5d397866afae536db2aa708af3b7a4b2f.

    Untaint was tentatively restored due to test failures.  But now, the
    failed tests have been removed, so we can revert the tentative fix.

commit 9594f57f3df6c2538f96f018fa5f9a775ac7dde1
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-12 08:31:13 +0900

    test/ruby/test_require.rb: Remove the tests of require with $SAFE

    The taint mechanism is decided to be removed at 2.7.  [Feature #16131]
    So, this change removes the tests that expects a SecurityError when
    requiring a file under $SAFE >= 1.

    The reason why they should be removed in advance is because the upstream
    of rubygems has already removed a call to "untaint" method, which makes
    the tests fail.

commit d9978ce5d397866afae536db2aa708af3b7a4b2f
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-12 08:03:26 +0900

    Use untaint for File.symlink in kernel_require.rb

      Partly reverted 7d463e360b9c4718b17378eb52783116a01b884b

commit b8d242d221641752a495ca43f8f211a3ad73d467
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-12 04:33:28 +0900

    release RUBYGEMS_ACTIVATION_MONITOR correctly.

    `File.symlink? safe_lp` can raise SecurityError and raising an
    exception can leave RUBYGEMS_ACTIVATION_MONITOR locking. This
    patch release it correctly.

commit 4be1e84d7894751799cc9d8ae2dec720952a02a3
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-12 04:13:54 +0900

    more messages

commit a815053a3ea16382bea8b420a3070b4da3c3bb94
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-12 04:03:33 +0900

    check monitor is owning for debug

commit 99be207c2acabe0030c376fd731608d9cd7c69b6
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-11 17:17:26 +0900

    add a NEWS entry about builtin features.

commit c02de30efbca2a2d89cdf188a27991f7ae15b9da
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-12 01:30:42 +0900

    tool/lib/leakchecker.rb: show the code location that allocated leaked fd

    by using ObjectSpace.trace_object_allocations.

    `make test-all LEAK_CHECKER_TRACE_OBJECT_ALLOCATION=true` will print not
    only leaked fds but also where it was created.

commit b72eda3c59cd0a15ed3536a3c0cd8aebd225f16b
Author: Yusuke Endoh <mame@ruby-lang.org>
Date:   2019-11-12 01:25:42 +0900

    lib/rubygems.rb: Suppress "Resolving dependencies..."

    And suppress "Leaked file descriptor" again.

commit 14b5c4cb66175553bda1cab70715d54fe46bffc7
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-12 01:23:23 +0900

    * 2019-11-12 [ci skip]

commit b2b12792720fe83afc1a64b41ca76fde6b7d74c5
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-11-12 01:22:09 +0900

    format-release uses the result of GitHub Actions

commit 0ba1ea7fbfc059e0e0114b4fc0bd66f3058d8b48
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-11-12 01:00:22 +0900

    Always use git.ruby-lang.org as origin

    naruse sets remote.origin.pushUrl = nonexistent as fail-safe
    configuration to avoid accidentally push a new branch to origin.

commit 45bb6f28db04a1f267f5b8d79392cb35087510d8
Author: aycabta <aycabta@gmail.com>
Date:   2019-11-11 22:55:32 +0900

    Remove ruby-token.rb

commit bcfe94b7f20fa3a581fc5d6f2aef837327bfb770
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-11 22:17:50 +0900

    Revert "Revert "Promote uri to default gems""

    This reverts commit fdfad905227a0e2e4c224d87181041fb75d5082e.

      f1f27da6c457684fdbfc0352297e6847f675ce4c resolved this.

commit f1f27da6c457684fdbfc0352297e6847f675ce4c
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-11 21:49:21 +0900

    Revert "Try to revert the test failure with Ruby CI"

    This reverts commit 8b27c23b5d55bd707a89bb5d95d2bdba9e132c1a.

commit 8b27c23b5d55bd707a89bb5d95d2bdba9e132c1a
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-11 20:19:29 +0900

    Try to revert the test failure with Ruby CI

      https://rubyci.org/logs/rubyci.s3.amazonaws.com/debian9/ruby-master/log/20191111T093005Z.fail.html.gz

commit 9d3213ac856e1f5930bda555d4d65b173c6cdf83
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-11 19:03:43 +0900

    Skip test_validate_gemspec unless git installed

commit 7585bc31877d4f9725f8de51b4a2faf47acb6f34
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-11 17:57:45 +0900

    Merge Bundler 2.1.0.pre.3

      Features:
        - Add caller information to some deprecation messages to make them easier to fix [#7361](https://github.com/bundler/bundler/pull/7361)
        - Reconcile `bundle cache` vs `bundle package` everywhere. Now in docs, CLI help and everywhere else `bundle cache` is the preferred version and `bundle package` remains as an alias [#7389](https://github.com/bundler/bundler/pull/7389)
        - Display some basic `bundler` documentation together with ruby's RDoc based documentation [#7394](https://github.com/bundler/bundler/pull/7394)

      Bugfixes:
        - Fix typos deprecation message and upgrading docs [#7374](https://github.com/bundler/bundler/pull/7374)
        - Deprecation warnings about `taint` usage on ruby 2.7 [#7385](https://github.com/bundler/bundler/pull/7385)
        - Fix `--help` flag not correctly delegating to `man` when used with command aliases [#7388](https://github.com/bundler/bundler/pull/7388)
        - `bundle add` should cache newly added gems if an application cache exists [#7393](https://github.com/bundler/bundler/pull/7393)
        - Stop using an insecure folder as a "fallback home" when user home is not defined [#7416](https://github.com/bundler/bundler/pull/7416)
        - Fix `bundler/inline` warning about `Bundler.root` redefinition [#7417](https://github.com/bundler/bundler/pull/7417)

Notes:
    Merged: https://github.com/ruby/ruby/pull/2668

commit fd69f82675bf93a848e5aa58d117bf8bbf604188
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-11-11 17:37:21 +0900

    Revert "Warn EOF char in comment"

    This reverts commit 69ec3f70fab0c1c537c68fb135cc315181b1d750.

commit ba5b51ca5968314f5ca92fee0afaea44a78eb0b1
Author: NARUSE, Yui <naruse@airemix.jp>
Date:   2019-11-11 17:37:14 +0900

    Revert "Elaborated EOF char message a little"

    This reverts commit 6eaac7cfac668d6669be694fd7b723c4982ed218.

commit 7d463e360b9c4718b17378eb52783116a01b884b
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-11 15:03:57 +0900

    Merge RubyGems 3.1.0.pre3

      * Fix gem pristine not accounting for user installed gems. Pull request
        #2914 by Luis Sagastume.
      * Refactor keyword argument test for Ruby 2.7. Pull request #2947 by
        SHIBATA Hiroshi.
      * Fix errors at frozen Gem::Version. Pull request #2949 by Nobuyoshi
        Nakada.
      * Remove taint usage on Ruby 2.7+. Pull request #2951 by Jeremy Evans.
      * Check Manifest.txt is up to date. Pull request #2953 by David Rodríguez.
      * Clarify symlink conditionals in tests. Pull request #2962 by David
        Rodríguez.
      * Update command line parsing to work under ps. Pull request #2966 by
        David Rodríguez.
      * Properly test `Gem::Specifications.stub_for`. Pull request #2970 by
        David Rodríguez.
      * Fix Gem::LOADED_SPECS_MUTEX handling for recursive locking. Pull request
        #2985 by MSP-Greg.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2666

commit 31416423809f64d4b5ea6b9651cced3179cc5ced
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-11 16:38:46 +0900

    __builtin_inline!

    Add an experimental `__builtin_inline!(c_expression)` special intrinsic
    which run a C code snippet.
    In `c_expression`, you can access the following variables:
      * ec (rb_execution_context_t *)
      * self (const VALUE)
      * local variables (const VALUE)
    Not that you can read these variables, but you can not write them.
    You need to return from this expression and return value will be a
    result of __builtin_inline!().

    Examples:
      `def foo(x) __builtin_inline!('return rb_p(x);'); end` calls `p(x)`.
      `def double(x) __builtin_inline!('return INT2NUM(NUM2INT(x) * 2);')`
      returns x*2.

commit 05a5c69e1a06a3853afb3744fa9925910b78904f
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-10 07:16:56 +0900

    add deps for miniprelude.c

commit 9142f802f1126d65abb1aad5e2bc91b5b833fe7e
Author: Koichi Sasada <ko1@atdot.net>
Date:   2019-11-10 02:25:57 +0900

    rewrite comment.

    Pointed by nagachika-san.
    https://ruby-trunk-changes.hatenablog.com/entry/ruby_trunk_changes_20191109

commit 65f7e3156f66bb4eba944c8ad2a463b9452b1a29
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 15:56:59 +0900

    Removed duplicate file

    "./tests/test_helper.rb" and "tests/test_helper.rb" in `s.files`
    are same.

commit 31ee6f6f5d7f562f065dfe364bb9afb09274948c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 13:10:55 +0900

    Extract gem files after update

    So that test/optparse/test_did_you_mean.rb can find did_you_mean.rb.

commit 6eaac7cfac668d6669be694fd7b723c4982ed218
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 12:57:40 +0900

    Elaborated EOF char message a little

commit 390293525a8c8564c62f7691414194705a193b40
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 12:19:40 +0900

    Remove binary data at installation

    And revert "Relaxed warning assertions",
    6f9be8505d172b110ec449478a791d70b9b74afb.

commit 6f9be8505d172b110ec449478a791d70b9b74afb
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 12:09:19 +0900

    Relaxed warning assertions

commit 69ec3f70fab0c1c537c68fb135cc315181b1d750
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 09:59:40 +0900

    Warn EOF char in comment

commit ade038889468e7755d7ebfe75975e0e77d1e1dec
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 09:35:37 +0900

    Fixed embedded document with EOF char

commit b42656b9c403da1bac8e1dd7534f0a7a09df67b0
Author: Yuichiro Kaneko <yui-knk@ruby-lang.org>
Date:   2019-11-11 09:22:46 +0900

    Ignore *.rbinc files

commit b5dff926e710a4fb069596f1911c998a28e3262a
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-11 09:16:00 +0900

    Prefer assert_syntax_error and assert_valid_syntax

commit a73389393906939ed9208562e6ec5eb3d21775e3
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-11 07:12:13 +0900

    Fix uplevel of test_jit

commit fcd9bc28e3d7d301bcdf6eea8ffa25c0c3ec184f
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-11 06:54:44 +0900

    qsymbols and symbols should be colored as Symbol

commit 25c53a8eec4f73f4d0d127144b24bf68218149e3
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-11 06:41:34 +0900

    Colorize on_symbols_beg (%I)

commit 958d954a1909edc1e297c54db7bbab53a289a0b8
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-11 06:34:25 +0900

    * 2019-11-11 [ci skip]

commit b5996b25ae8ff7e7961fea245c5ea8476b029134
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-11 06:33:23 +0900

    Colorize string quotes as bold

    like pry

commit 6e70fa49b111e2a2839297b057a3df354cae265a
Author: Kazuki Tsujimoto <kazuki@callcc.net>
Date:   2019-11-10 22:34:49 +0900

    Disallow omission of parentheses/brackets in single line pattern matching [Feature #16182]

commit ef03d48cb20aa7739a4ac8eb4e109525a47fcc9f
Author: Yuichiro Kaneko <yui-knk@ruby-lang.org>
Date:   2019-11-10 22:18:08 +0900

    Fix a typo

commit 4570284ce14c9f00114039e9b619584a8cad6a50
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-10 14:56:38 +0900

    Test opt_invokebuiltin_delegate_leave in test_jit

commit 5c168c7e7f73d400db45980115dedab4deefcda7
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-10 14:40:38 +0900

    Support RB_BUILTIN in ISeq#to_a

commit 0483d01f6bdd3d16b31244a7aaadb4c31f6ecee7
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-10 14:16:10 +0900

    Test invokebuiltin in test_jit

    ISeq#to_a is commented out because it's broken now

commit 11aa07c27071878d9f7748995febe7df96f0405d
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-10 10:52:12 +0900

    Define NULLCMD as printing NUL [Bug #16331]

commit 2c55ba7191a69dd4db34572754162308f0a9acdd
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-10 10:09:26 +0900

    Define NULLCMD as an empty label [Bug #16331]

commit faa4f4f23fbb6b48b158cc38d9b509fd00838976
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-10 09:15:12 +0900

    Get rid of FreeBSD make incompatibility [Bug #16331]

    FreeBSD make works differently with `-j` option.

    > -j    max_jobs
    >       Specify the maximum number of jobs that `make` may have running
    >       at any one time.  The value is saved in `.MAKE.JOBS.` Turns
    >       compatibility mode off, unless the `B` flag is also specified.
    >       When compatibility mode is off, all commands associated with a
    >       target are executed in a single shell invocation as opposed to
    >       the traditional one shell invocation per line.  This can break
    >       traditional scripts which change directories on each command
    >       invocation and then expect to start with a fresh environment on
    >       the next line.  It is more efficient to correct the scripts
    >       rather than turn backwards compatibility on.

    Stop using exit, cd, exec in middle of commands.

commit ff767dd914d0aa91e2c6ec29bba7ff3739225b0c
Author: git <svn-admin@ruby-lang.org>
Date:   2019-11-10 06:23:55 +0900

    * 2019-11-10 [ci skip]

commit e0094df29d2175b8163027687671bc638a993c72
Author: Takashi Kokubun <takashikkbn@gmail.com>
Date:   2019-11-10 06:22:51 +0900

    Extend sleep duration for Solaris

commit 03fdf02321d4ac3123fb6908e7be53e232a92b67
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 23:00:32 +0900

    Removed trial and errors

commit a68205c5c19277e9ece8409b1f6af7e226989dff
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 22:40:14 +0900

    Specify the permission

    To make the temporary directory non-writable by group and others.

commit 774cfb065567d07c4cf172cbb1708acda5e0fde4
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 22:15:15 +0900

    Fixed the debug print

commit 20bc038ea31ee799103bb89068537ed4e4f699b4
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 21:58:55 +0900

    Debug-print tmpdir info

commit f48655d04d463a89b7ac15bc3942ec6c574c6cd9
Author: David Rodríguez <deivid.rodriguez@riseup.net>
Date:   2019-11-08 23:03:02 +0900

    Remove unneeded exec bits from some files

    I noticed that some files in rubygems were executable, and I could think
    of no reason why they should be.

    In general, I think ruby files should never have the executable bit set
    unless they include a shebang, so I run the following command over the
    whole repo:

    ```bash
    find . -name '*.rb' -type f -executable -exec bash -c 'grep -L "^#!" $1 || chmod -x $1' _ {} \;
    ```

Notes:
    Merged: https://github.com/ruby/ruby/pull/2662

commit fcf37ca2fef8248966dcd9143aaea569fc87953c
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 20:02:28 +0900

    Fix builtin script paths

    Do not search builtin scripts by using VPATH, to get rid of weird
    nmake VPATH.

Notes:
    Merged: https://github.com/ruby/ruby/pull/2665

commit 79f0e7aafd0532666a00a49ef8feb838b5e9e208
Author: Kazuki Tsujimoto <kazuki@callcc.net>
Date:   2019-11-09 21:12:29 +0900

    Fix typos

commit fdfad905227a0e2e4c224d87181041fb75d5082e
Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
Date:   2019-11-09 20:14:17 +0900

    Revert "Promote uri to default gems"

    This reverts commit c5b4d2a2592942766dc2789f46105b91eba7026a.

      This commit affects with activation feature of RubyGems.
      [Bug #16337][ruby-core:95768]

commit 4dd1caa12964c6932009a3548de121a861435b8e
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 20:08:01 +0900

    Updated miniprelude.o dependency

commit e3c852441177caa4b251fa33c83a65e4263a4146
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 19:43:14 +0900

    Full-path of builtin scripts no longer needed

commit dfaac2b37253ff25ec873c2fbd93abfa7f789248
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 19:28:45 +0900

    Embed builtin ruby scripts in miniprelude.c

    Instead of reading from the files by the full-path at runtime.  As
    rbinc files need to be included in distributed tarballs, the
    full-paths at the packaging are unavailable at compilation times.

commit 4dc4b1890499d6a836655957e78908ee891a42ce
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 19:15:10 +0900

    Fixed commit miss

commit 95aed94d2aba5ff93425f26ae6181607996d8ca3
Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
Date:   2019-11-09 18:44:06 +0900

    Fixed `#line` directives in miniprelude.c

commit 352096ef6047538bfedb974a7c1b1156f5a0e811
Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
Date:   2019-11-09 16:43:47 +0900

    Add debug print

